

using System;
using System.Runtime.Serialization;
using System.Xml;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationRDTIS2022
{
    /// <summary>
    /// RDTIS
    /// </summary>
    [DataContract(Name = "RDTIS", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class RDTIS
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public RP RP { get; set; }
    }

    /// <summary>
    /// Australian Owned
    /// </summary>
    [DataContract(Name = "AustralianOwned", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class AustralianOwned
    {

        /// <summary>
        /// Research Service Provider (RSP) expenditure - Australian owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? ExpenseResearchAndDevelopmentContractedExpenditureResearchServiceProviderA { get; set; }

        /// <summary>
        /// Contract expenditure (not RSP) - Australian owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? ExpenseResearchAndDevelopmentContractedExpenditureNonResearchServiceProviderA { get; set; }

        /// <summary>
        /// Salary expenditure - Australian owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? RemunerationWagesAndSalariesSalaryA { get; set; }

        /// <summary>
        /// Other expenditure - Australian owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? ExpenseResearchAndDevelopmentOtherExpenditureRegisteredResearchAgencyA { get; set; }

        /// <summary>
        /// Feedstock input expenditure - Australian owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public decimal? ExpenseResearchAndDevelopmentFeedstockA { get; set; }

        /// <summary>
        /// Paid to associates in the current year - Australian owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal? ExpenseResearchAndDevelopmentAssociatesExpenditureA { get; set; }

        /// <summary>
        /// Decline in value of assets - Australian owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public decimal? ExpenseResearchAndDevelopmentDeclineInValuePlantAndDepreciatingAssetsA { get; set; }

        /// <summary>
        /// Balancing adjustment losses - Australian owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public decimal? ExpenseResearchAndDevelopmentBalancingLossesA { get; set; }

        /// <summary>
        /// Cooperative Research Centre (CRC) contributions - Australian owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public decimal? ExpenseResearchAndDevelopmentCooperativeResearchCentreContributionsA { get; set; }

        /// <summary>
        /// Total of allocated notional deductions - Australian owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 10)]
        public decimal? ExpenseResearchAndDevelopmentAllocatedTotalA { get; set; }
    }

    /// <summary>
    /// Foreign Owned
    /// </summary>
    [DataContract(Name = "ForeignOwned", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class ForeignOwned
    {

        /// <summary>
        /// Research Service Provider (RSP) expenditure - Foreign owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? ExpenseResearchAndDevelopmentContractedExpenditureResearchServiceProviderA { get; set; }

        /// <summary>
        /// Contract expenditure (not RSP) - Foreign owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? ExpenseResearchAndDevelopmentContractedExpenditureNonResearchServiceProviderA { get; set; }

        /// <summary>
        /// Salary expenditure - Foreign owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? RemunerationWagesAndSalariesSalaryA { get; set; }

        /// <summary>
        /// Other expenditure - Foreign owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? ExpenseResearchAndDevelopmentOtherExpenditureRegisteredResearchAgencyA { get; set; }

        /// <summary>
        /// Feedstock input expenditure - Foreign owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public decimal? ExpenseResearchAndDevelopmentFeedstockA { get; set; }

        /// <summary>
        /// Paid to associates in the current year - Foreign owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal? ExpenseResearchAndDevelopmentAssociatesExpenditureA { get; set; }

        /// <summary>
        /// Decline in value of assets - Foreign owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public decimal? ExpenseResearchAndDevelopmentDeclineInValuePlantAndDepreciatingAssetsA { get; set; }

        /// <summary>
        /// Balancing adjustment losses - Foreign owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public decimal? ExpenseResearchAndDevelopmentBalancingLossesA { get; set; }

        /// <summary>
        /// Cooperative Research Centre (CRC) contributions - Foreign owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public decimal? ExpenseResearchAndDevelopmentCooperativeResearchCentreContributionsA { get; set; }

        /// <summary>
        /// Total of allocated notional deductions - Foreign owned RandD
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 10)]
        public decimal? ExpenseResearchAndDevelopmentAllocatedTotalA { get; set; }
    }

    /// <summary>
    /// Notional Deductions Calculation
    /// </summary>
    [DataContract(Name = "NotionalDeductionsCalculation", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class NotionalDeductionsCalculation
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public AustralianOwned AustralianOwned { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 2)]
        public ForeignOwned ForeignOwned { get; set; }

        /// <summary>
        /// Total notional RandD deductions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal ExpenseResearchAndDevelopmentAllocatedTotalA { get; set; }
    }

    /// <summary>
    /// Feedstock
    /// </summary>
    [DataContract(Name = "Feedstock", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class Feedstock
    {

        /// <summary>
        /// Feedstock revenue total
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? IncomeResearchAndDevelopmentRevenueTotalA { get; set; }

        /// <summary>
        /// Expenditure on feedstock inputs attributable to feedstock output
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? ExpenseResearchAndDevelopmentInputA { get; set; }

        /// <summary>
        /// Feedstock adjustment - additional assessable income
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? IncomeResearchAndDevelopmentNetA { get; set; }
    }

    /// <summary>
    /// Clawback
    /// </summary>
    [DataContract(Name = "Clawback", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class Clawback
    {

        /// <summary>
        /// Recoupments (entitled to/received)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? ResearchAndDevelopmentGovernmentGrantsAndRecoupmentsA { get; set; }

        /// <summary>
        /// RandD expenditure related to recoupments
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? ExpenseResearchAndDevelopmentRecoupmentRelatedA { get; set; }

        /// <summary>
        /// Project expenditure for which recoupments paid
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? ExpenseResearchAndDevelopmentGrantRelatedA { get; set; }

        /// <summary>
        /// RandD recoupment tax - 10% tax payable
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? TaxConcessionResearchAndDevelopmentGovernmentGrantsRecoupmentsClawbackA { get; set; }
    }

    /// <summary>
    /// Incurred Or Paid
    /// </summary>
    [DataContract(Name = "IncurredOrPaid", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class IncurredOrPaid
    {

        /// <summary>
        /// RandD expenditure to associates incurred in prior year, not paid, not claimed (carried forward)
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? ExpenseResearchAndDevelopmentAssociatesCarriedForwardA { get; set; }

        /// <summary>
        /// Current year RandD expenditure incurred to associates
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? ExpenseResearchAndDevelopmentAssociatesUnpaidA { get; set; }

        /// <summary>
        /// Current year RandD expenditure incurred to associates claimed under other provisions
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? ExpenseResearchAndDevelopmentAssociatesClaimedA { get; set; }

        /// <summary>
        /// RandD expenditure paid to associates in the current year
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public decimal? ExpenseResearchAndDevelopmentAssociatesNotClaimedA { get; set; }
    }

    /// <summary>
    /// Expenditure To Associates
    /// </summary>
    [DataContract(Name = "ExpenditureToAssociates", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class ExpenditureToAssociates
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public IncurredOrPaid IncurredOrPaid { get; set; }

        /// <summary>
        /// RandD expenditure incurred to associates to be carried forward
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? ExpenseResearchAndDevelopmentAssociatesCarriedForwardA { get; set; }
    }

    /// <summary>
    /// Group Member
    /// </summary>
    [CollectionDataContract(Name = "GroupMemberCollection", Namespace = "http://www.sbr.gov.au/ato/rdtis", ItemName="GroupMember" )]
    public class GroupMemberCollection: List<GroupMember> {}

    /// <summary>
    /// Group Member
    /// </summary>
    [DataContract(Name = "GroupMember", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class GroupMember
    {

        /// <summary>
        /// Group Member name
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string OrganisationNameDetailsOrganisationalNameT { get; set; }

        /// <summary>
        /// Group Member - Tax File Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxFileNumberId { get; set; }

        /// <summary>
        /// Group Member - Annual turnover
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal TaxConcessionResearchAndDevelopmentTaxOffsetEntityTurnoverA { get; set; }
    }

    /// <summary>
    /// Tax Offset Calculation
    /// </summary>
    [DataContract(Name = "TaxOffsetCalculation", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class TaxOffsetCalculation
    {

        /// <summary>
        /// Do you have exempt entity ownership of 50% or greater?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool TaxConcessionExemptEntityOwnershipI { get; set; }

        /// <summary>
        /// Do you have an aggregated turnover of $20 million or greater?
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public bool? TaxConcessionAggregatedTurnoverAtOrAboveThresholdI { get; set; }

        /// <summary>
        /// Reporting party - Annual turnover
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? TaxConcessionResearchAndDevelopmentTaxOffsetEntityTurnoverA { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 4)]
        public GroupMemberCollection GroupMemberCollection { get; set; }

        /// <summary>
        /// Additional Group Members - Annual Turnover
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public decimal? TaxConcessionResearchAndDevelopmentTaxOffsetAdditionalEntitiesTurnoverA { get; set; }

        /// <summary>
        /// Exclusions from aggregated turnover
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal? TaxConcessionResearchAndDevelopmentTaxOffsetTurnoverExclusionA { get; set; }

        /// <summary>
        /// Aggregated turnover
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public decimal? TaxConcessionResearchAndDevelopmentTaxOffsetTurnoverTotalA { get; set; }
    }

    /// <summary>
    /// Refundable Tax Offset
    /// </summary>
    [DataContract(Name = "RefundableTaxOffset", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class RefundableTaxOffset
    {

        /// <summary>
        /// Total notional RandD deductions - Refundable
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? TaxConcessionResearchAndDevelopmentTaxOffsetNotionalRefundableA { get; set; }

        /// <summary>
        /// Refundable RandD tax offset
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? TaxConcessionResearchAndDevelopmentTaxOffsetRefundableA { get; set; }
    }

    /// <summary>
    /// Non Refundable Tax Offset
    /// </summary>
    [DataContract(Name = "NonRefundableTaxOffset", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class NonRefundableTaxOffset
    {

        /// <summary>
        /// Total notional RandD deductions - Non-Refundable
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? TaxConcessionResearchAndDevelopmentTaxOffsetNotionalNonRefundableA { get; set; }

        /// <summary>
        /// Non-refundable RandD tax offset
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? TaxConcessionResearchAndDevelopmentTaxOffsetNonRefundableA { get; set; }
    }

    /// <summary>
    /// Reporting Party
    /// </summary>
    [DataContract(Name = "RP", Namespace = "http://www.sbr.gov.au/ato/rdtis")]
    public class RP
    {

        /// <summary>
        /// Original or amended schedule indicator
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public bool AmendmentI { get; set; }

        /// <summary>
        /// Reporting party - Tax File Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxFileNumberId { get; set; }

        /// <summary>
        /// Reporting period start date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public DateTime PeriodStartD { get; set; }

        /// <summary>
        /// Reporting period end date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public DateTime PeriodEndD { get; set; }

        /// <summary>
        /// AusIndustry Innovation Australia number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string InnovationRegistrationNumberId { get; set; }

        /// <summary>
        /// Add back of RandD accounting expenditure
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public decimal? ExpenseResearchAndDevelopmentResearchAndDevelopmentAccountingExpenditureAddBackA { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 7)]
        public NotionalDeductionsCalculation NotionalDeductionsCalculation { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 8)]
        public Feedstock Feedstock { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 9)]
        public Clawback Clawback { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 10)]
        public ExpenditureToAssociates ExpenditureToAssociates { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 11)]
        public TaxOffsetCalculation TaxOffsetCalculation { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 12)]
        public RefundableTaxOffset RefundableTaxOffset { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 13)]
        public NonRefundableTaxOffset NonRefundableTaxOffset { get; set; }
    }
}
 
