using System;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationIDS
{
    public class IDS2021
    {
    
    public string RPId = null;
    public bool RPExists = false;
    public int RPCount = 0;
    public int RPOccurrenceIndex = 0;
    public int RPLastOccurrenceIndex = 0;
    public string RPIdentifier = null;
    public string RPIdentifierScheme = null;
        public string RPIdentifierTFN = null;
        public DateTime? RPStartDate = null;
        public DateTime? RPEndDate = null;

        /// <summary>
        /// RP:tns:InternationalDealings.CountryByCountryReportApplicability.Indicator
        /// </summary>
        public bool? IDS330 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.LocalFilePartAVoluntaryLodgment.Indicator
        /// </summary>
        public bool? IDS331 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.RelatedPartiesTransactionsExcessAggregateValue.Indicator
        /// </summary>
        public bool? IDS1 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.SmallBusinessConcessionsEligibility.Indicator
        /// </summary>
        public bool? IDS425 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.RelatedPartiesTransactions.Indicator
        /// </summary>
        public bool? IDS2 = null;
    
        public bool ForeignCountriesCollectionExists = false;
        public int ForeignCountriesCollectionCount = 0;

        public List<ForeignCountries> ForeignCountriesCollection = null;

        public class ForeignCountries 
        {
            public int OccurrenceIndex = 0;
    
            /// <summary>
            /// /xbrli:xbrl/tns:ForeignCountries
            /// RP:tns:OrganisationDetails.InternationalRelatedPartyCountry.Code
            /// </summary>
            public string IDS418 = null;

            public bool ForeignCountries_ActivityCodeCollectionExists = false;
            public int ForeignCountries_ActivityCodeCollectionCount = 0;
    
            public List<ForeignCountries_ActivityCode> ForeignCountries_ActivityCodeCollection = null;
    
            public class ForeignCountries_ActivityCode 
            {
                public int OccurrenceIndex = 0;
        
                /// <summary>
                /// /xbrli:xbrl/tns:ForeignCountries/tns:ActivityCode
                /// RP:tns:OrganisationDetails.InternationalRelatedPartyCountryActivity.Code
                /// </summary>
                public string IDS419 = null;
        
                /// <summary>
                /// /xbrli:xbrl/tns:ForeignCountries/tns:ActivityCode
                /// RP:tns:Expense.Total.Amount
                /// </summary>
                public decimal? IDS5 = null;
        
                /// <summary>
                /// /xbrli:xbrl/tns:ForeignCountries/tns:ActivityCode
                /// RP:tns:Revenue.Total.Amount
                /// </summary>
                public decimal? IDS6 = null;
            }
    
            /// <summary>
            /// /xbrli:xbrl/tns:ForeignCountries
            /// RP:tns:Expense.Other.Amount
            /// </summary>
            public decimal? IDS7 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:ForeignCountries
            /// RP:tns:Revenue.Other.Amount
            /// </summary>
            public decimal? IDS8 = null;
        }

        /// <summary>
        /// RP:tns:InternationalDealings.SpecifiedCountriesTransactions.Indicator
        /// </summary>
        public bool? IDS9 = null;
    
        public bool SpecifiedCountriesCollectionExists = false;
        public int SpecifiedCountriesCollectionCount = 0;

        public List<SpecifiedCountries> SpecifiedCountriesCollection = null;

        public class SpecifiedCountries 
        {
            public int OccurrenceIndex = 0;
    
            /// <summary>
            /// /xbrli:xbrl/tns:SpecifiedCountries
            /// RP:tns:OrganisationDetails.InternationalRelatedPartyCountry.Code
            /// </summary>
            public string IDS420 = null;

            public bool SpecifiedCountries_ActivityCodeCollectionExists = false;
            public int SpecifiedCountries_ActivityCodeCollectionCount = 0;
    
            public List<SpecifiedCountries_ActivityCode> SpecifiedCountries_ActivityCodeCollection = null;
    
            public class SpecifiedCountries_ActivityCode 
            {
                public int OccurrenceIndex = 0;
        
                /// <summary>
                /// /xbrli:xbrl/tns:SpecifiedCountries/tns:ActivityCode
                /// RP:tns:OrganisationDetails.InternationalRelatedPartyCountryActivity.Code
                /// </summary>
                public string IDS421 = null;
        
                /// <summary>
                /// /xbrli:xbrl/tns:SpecifiedCountries/tns:ActivityCode
                /// RP:tns:Expense.Total.Amount
                /// </summary>
                public decimal? IDS12 = null;
        
                /// <summary>
                /// /xbrli:xbrl/tns:SpecifiedCountries/tns:ActivityCode
                /// RP:tns:Revenue.Total.Amount
                /// </summary>
                public decimal? IDS13 = null;
            }
    
            /// <summary>
            /// /xbrli:xbrl/tns:SpecifiedCountries
            /// RP:tns:Expense.Other.Amount
            /// </summary>
            public decimal? IDS14 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:SpecifiedCountries
            /// RP:tns:Revenue.Other.Amount
            /// </summary>
            public decimal? IDS15 = null;
        }

        /// <summary>
        /// RP:tns:InternationalDealings.TransactionsTangiblePropertyRevenue.Indicator
        /// </summary>
        public bool? IDS16 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.TransactionsRoyaltiesLicenceFees.Indicator
        /// </summary>
        public bool? IDS21 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.TransactionsRentLeasing.Indicator
        /// </summary>
        public bool? IDS30 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.TransactionsServiceArrangements.Indicator
        /// </summary>
        public bool? IDS35 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.DerivativeTransactions.Indicator
        /// </summary>
        public bool? IDS81 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.DerivativesTradingGlobal.Indicator
        /// </summary>
        public bool? IDS87 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.DebtFactoringSecuritisation.Indicator
        /// </summary>
        public bool? IDS88 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.OtherFinancialDealings.Indicator
        /// </summary>
        public bool? IDS97 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ForeignExchangeGainLoss.Indicator
        /// </summary>
        public bool? IDS333 = null;
    
        public bool TransactionTypeCollectionExists = false;
        public int TransactionTypeCollectionCount = 0;

        public List<TransactionType> TransactionTypeCollection = null;

        public class TransactionType 
        {
            public int OccurrenceIndex = 0;
    
            /// <summary>
            /// /xbrli:xbrl/tns:TransactionType
            /// RP:tns:InternationalDealings.ForeignExchangeTransactionType.Code
            /// </summary>
            public string IDS422 = null;

            public bool TransactionType_CurrencyCodeCollectionExists = false;
            public int TransactionType_CurrencyCodeCollectionCount = 0;
    
            public List<TransactionType_CurrencyCode> TransactionType_CurrencyCodeCollection = null;
    
            public class TransactionType_CurrencyCode 
            {
                public int OccurrenceIndex = 0;
        
                /// <summary>
                /// /xbrli:xbrl/tns:TransactionType/tns:CurrencyCode
                /// RP:tns:Miscellaneous.FunctionalCurrency.Code
                /// </summary>
                public string IDS423 = null;
        
                /// <summary>
                /// /xbrli:xbrl/tns:TransactionType/tns:CurrencyCode
                /// RP:tns:InternationalDealings.ForeignExchangeLossesHighestNominal.Amount
                /// </summary>
                public decimal? IDS336 = null;
        
                /// <summary>
                /// /xbrli:xbrl/tns:TransactionType/tns:CurrencyCode
                /// RP:tns:InternationalDealings.ForeignExchangeGainsHighestNominal.Amount
                /// </summary>
                public decimal? IDS337 = null;
            }
    
            /// <summary>
            /// /xbrli:xbrl/tns:TransactionType
            /// RP:tns:InternationalDealings.ForeignExchangeLossesOther.Amount
            /// </summary>
            public decimal? IDS338 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:TransactionType
            /// RP:tns:InternationalDealings.ForeignExchangeGainsOther.Amount
            /// </summary>
            public decimal? IDS339 = null;
        }

        /// <summary>
        /// RP:tns:InternationalDealings.OtherRevenue.Indicator
        /// </summary>
        public bool? IDS123 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.CapitalNature.Indicator
        /// </summary>
        public bool? IDS129 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.ResearchAndDevelopmentCostPlusRemuneration.Indicator
        /// </summary>
        public bool? IDS426 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.ReceivedOrProvidedServicesPropertyProcessesRightsOrObligationsForNonMonetaryConsideration.Indicator
        /// </summary>
        public bool? IDS138 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ShareBasedEmployeeRemuneration.Indicator
        /// </summary>
        public bool? IDS147 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.CostContributionArrangements.Indicator
        /// </summary>
        public bool? IDS150 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.RestructuringEvents.Indicator
        /// </summary>
        public bool? IDS151 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.TransactionsRestructuringEventsAssetRevaluation.Indicator
        /// </summary>
        public bool? IDS159 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.BranchOperations.Indicator
        /// </summary>
        public bool? IDS160 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.FinancialArrangements.Indicator
        /// </summary>
        public bool? IDS172 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.TaxationOfFinancialArrangements.Indicator
        /// </summary>
        public bool? IDS429 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.TaxationOfFinancialArrangementsRulesApplied.Indicator
        /// </summary>
        public bool? IDS177 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.TaxTimingMethodElections.Code
        /// </summary>
        public List<string> IDS178Collection = null;

        /// <summary>
        /// RP:tns:Miscellaneous.InterestInControlledForeignCompaniesAndControlledForeignTrusts.Indicator
        /// </summary>
        public bool? IDS184 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.ControlledForeignCompanyTrustInterestAcquired.Indicator
        /// </summary>
        public bool? IDS367 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.ControlledForeignCompanyTrustInterestDisposed.Indicator
        /// </summary>
        public bool? IDS371 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.ControlledForeignCompaniesExcludedTaintedInterestIncome.Indicator
        /// </summary>
        public bool? IDS433 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.ControlledForeignCompaniesBankingLicences.Indicator
        /// </summary>
        public bool? IDS434 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.ControlledForeignCompaniesIncomeMoneyLending.Indicator
        /// </summary>
        public bool? IDS435 = null;

        /// <summary>
        /// RP:tns:Income.ControlledForeignCompaniesExcludedTaintedInterestIncomeTotal.Amount
        /// </summary>
        public decimal? IDS439 = null;

        /// <summary>
        /// RP:tns:Income.ControlledForeignCompaniesAttributableIncomeTotal.Amount
        /// </summary>
        public decimal? IDS191 = null;

        /// <summary>
        /// RP:tns:Income.ControlledForeignCompaniesChangeOfResidenceIncome.Amount
        /// </summary>
        public decimal? IDS192 = null;

        /// <summary>
        /// RP:tns:Income.ControlledForeignCompaniesAndControlledForeignTrustsInterposedAustralianEntitiesAttributableIncomeTotal.Amount
        /// </summary>
        public decimal? IDS193 = null;

        /// <summary>
        /// RP:tns:Income.GrossRevenueActiveIncomeTestSatisfiedTotal.Amount
        /// </summary>
        public decimal? IDS446 = null;

        /// <summary>
        /// RP:tns:Income.GrossRevenueActiveIncomeTestNotSatisfiedTotal.Amount
        /// </summary>
        public decimal? IDS450 = null;

        /// <summary>
        /// RP:tns:Income.ControlledForeignCompaniesNotionalAssessableIncomeTotal.Amount
        /// </summary>
        public decimal? IDS388 = null;

        /// <summary>
        /// RP:tns:Income.ControlledForeignCompaniesNotionalAllowableDeductionsTotal.Amount
        /// </summary>
        public decimal? IDS454 = null;

        /// <summary>
        /// RP:tns:Income.ForeignBranchOperationsInterestsInForeignCompaniesOrForeignTrusts.Indicator
        /// </summary>
        public bool? IDS195 = null;

        /// <summary>
        /// RP:tns:Expense.NonDeductibleExemptIncome.Amount
        /// </summary>
        public decimal? IDS199 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.DebtEarningNonAssessableNonExemptForeignIncome.Indicator
        /// </summary>
        public bool? IDS206 = null;

        /// <summary>
        /// RP:tns:IncomeTax.Deduction.DebtEarningNonAssessableNonExemptForeignIncomeTotal.Amount
        /// </summary>
        public decimal? IDS207 = null;

        /// <summary>
        /// RP:tns:CapitalGainsTax.Event.Indicator
        /// </summary>
        public bool? IDS208 = null;

        /// <summary>
        /// RP:tns:CapitalGainsTax.ActiveForeignBusinessCapitalGains.Amount
        /// </summary>
        public decimal? IDS209 = null;

        /// <summary>
        /// RP:tns:IncomeTax.ActiveForeignBusinessCapitalGainsReduction.Amount
        /// </summary>
        public decimal? IDS210 = null;

        /// <summary>
        /// RP:tns:CapitalGainsTax.ActiveForeignBusinessCapitalLosses.Amount
        /// </summary>
        public decimal? IDS211 = null;

        /// <summary>
        /// RP:tns:IncomeTax.ActiveForeignBusinessCapitalLossesReduction.Amount
        /// </summary>
        public decimal? IDS212 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.TransferPropertyMoneyOrServices.Indicator
        /// </summary>
        public bool? IDS213 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.NonResidentTrustInterestEntitlementOrBeneficiary.Indicator
        /// </summary>
        public bool? IDS216 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.OffshoreDealingsCompliance.Indicator
        /// </summary>
        public bool? IDS393 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.ForeignHybridLimitedPartnershipOrForeignHybridCompanyShareholder.Indicator
        /// </summary>
        public bool? IDS217 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.ForeignHybridLimitedPartnershipOrForeignHybridCompanyInterestIn.Count
        /// </summary>
        public decimal? IDS218 = null;

        /// <summary>
        /// RP:tns:Assets.Investment.ForeignHybridLimitedPartnershipOrForeignHybridCompanyNetIncomeProfitTotal.Amount
        /// </summary>
        public decimal? IDS219 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.ProvisionsApplied.Indicator
        /// </summary>
        public bool? IDS220 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.2MillionThresholdTest.Indicator
        /// </summary>
        public bool? IDS400 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.90PercentAssetThresholdTest.Indicator
        /// </summary>
        public bool? IDS401 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.ExemptionSpecialPurposeEntities.Indicator
        /// </summary>
        public bool? IDS402 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.AustralianResidentCompanyElected.Indicator
        /// </summary>
        public bool? IDS221 = null;

        /// <summary>
        /// RP:tns:Identifiers.AustralianBusinessNumber.Identifier
        /// </summary>
        public string IDS222 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.EntityType.Code
        /// </summary>
        public string IDS223 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.GeneralToFinancialStatusChange.Indicator
        /// </summary>
        public bool? IDS224 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.AveragingMethodAdopted.Code
        /// </summary>
        public string IDS225 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.DeductionDebt.Amount
        /// </summary>
        public decimal? IDS226 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.RelatedNonResidentsDebtDeduction.Amount
        /// </summary>
        public decimal? IDS227 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.DeductionDebtDisallowed.Amount
        /// </summary>
        public decimal? IDS228 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.DebtAdjustedAverage.Amount
        /// </summary>
        public decimal? IDS229 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.AuthorisedDepositTakingInstitution.Indicator
        /// </summary>
        public bool? IDS230 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.EquityCapitalAdjustedAverage.Amount
        /// </summary>
        public decimal? IDS231 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.SafeHarbour.Amount
        /// </summary>
        public decimal? IDS232 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.EquityShortfall.Amount
        /// </summary>
        public decimal? IDS233 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.RiskWeightedAssetsAverageValue.Amount
        /// </summary>
        public decimal? IDS234 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.EquityCapitalAttributableToOverseasPermanentEstablishments.Amount
        /// </summary>
        public decimal? IDS235 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.RiskWeightedAssetsOverseasPermanentEstablishmentsAverageValueTotal.Amount
        /// </summary>
        public decimal? IDS236 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.ControlledForeignADIEntityEquityAverageValue.Amount
        /// </summary>
        public decimal? IDS237 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.Tier1PrudentialCapitalDeduction.Amount
        /// </summary>
        public decimal? IDS238 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.RiskWeightedAssetsAttributableToAustralianPermanentEstablishmentsAverage.Amount
        /// </summary>
        public decimal? IDS239 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.DotationCapitalAverageValue.Amount
        /// </summary>
        public decimal? IDS240 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.NonAuthorisedDepositTakingInstitution.Indicator
        /// </summary>
        public bool? IDS241 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.AssetsValueAverage.Amount
        /// </summary>
        public decimal? IDS242 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.AssetRevaluation.Amount
        /// </summary>
        public decimal? IDS243 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.DebtMaximumAllowable.Amount
        /// </summary>
        public decimal? IDS244 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.ExcessDebt.Amount
        /// </summary>
        public decimal? IDS245 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.NonDebtLiabilitiesAverageValue.Amount
        /// </summary>
        public decimal? IDS246 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.AssociateEntityDebtAverageValue.Amount
        /// </summary>
        public decimal? IDS247 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.AssociateEntityEquityAverageValue.Amount
        /// </summary>
        public decimal? IDS248 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.AssociateEntityExcessAverageValue.Amount
        /// </summary>
        public decimal? IDS249 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.ExcludedEquityInterestsAverage.Amount
        /// </summary>
        public decimal? IDS250 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.ZeroCapitalAverage.Amount
        /// </summary>
        public decimal? IDS251 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.OnLentAverage.Amount
        /// </summary>
        public decimal? IDS252 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.ControlledForeignNonAuthorisedDepositTakingInstitutionEntityEquityAverageValue.Amount
        /// </summary>
        public decimal? IDS253 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.ControlledForeignEntityDebtAverageValue.Amount
        /// </summary>
        public decimal? IDS254 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.ArmsLengthTests.Indicator
        /// </summary>
        public bool? IDS255 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.ArmsLengthDebt.Amount
        /// </summary>
        public decimal? IDS256 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.GearingDebtCapitalTest.Indicator
        /// </summary>
        public bool? IDS257 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.WorldwideGroupCapitalRatio.Fraction
        /// </summary>
        public decimal? IDS258 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.WorldwideCapital.Amount
        /// </summary>
        public decimal? IDS259 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.WorldwideDebtTotal.Amount
        /// </summary>
        public decimal? IDS260 = null;

        /// <summary>
        /// RP:tns:Liabilities.ThinCapitalisation.WorldwideEquity.Amount
        /// </summary>
        public decimal? IDS261 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.WorldwideGearingDebt.Amount
        /// </summary>
        public decimal? IDS262 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.StatementWorldwideAsset.Amount
        /// </summary>
        public decimal? IDS323 = null;

        /// <summary>
        /// RP:tns:Capital.ThinCapitalisation.AverageAustralianAsset.Amount
        /// </summary>
        public decimal? IDS324 = null;

        /// <summary>
        /// RP:tns:FinancialServices.ForeignBankOrQualifyingFinancialEntity.Indicator
        /// </summary>
        public bool? IDS263 = null;

        /// <summary>
        /// RP:tns:FinancialServices.NonOffshoreBankingUnitNotionalInterest.Amount
        /// </summary>
        public decimal? IDS265 = null;

        /// <summary>
        /// RP:tns:FinancialServices.OffshoreBankingUnitNotionalInterest.Amount
        /// </summary>
        public decimal? IDS266 = null;

        /// <summary>
        /// RP:tns:FinancialServices.NotionalInterestTaxWithholding.Amount
        /// </summary>
        public decimal? IDS267 = null;

        /// <summary>
        /// RP:tns:FinancialServices.NotionalDerivativePaid.Amount
        /// </summary>
        public decimal? IDS408 = null;

        /// <summary>
        /// RP:tns:FinancialServices.NotionalDerivativeReceived.Amount
        /// </summary>
        public decimal? IDS409 = null;

        /// <summary>
        /// RP:tns:FinancialServices.NotionalForeignExchangeTransactionPaid.Amount
        /// </summary>
        public decimal? IDS410 = null;

        /// <summary>
        /// RP:tns:FinancialServices.NotionalForeignExchangeTransactionReceived.Amount
        /// </summary>
        public decimal? IDS411 = null;

        /// <summary>
        /// RP:tns:FinancialServices.ForeignBankOrQualifyingFinancialEntityElectedOut.Indicator
        /// </summary>
        public bool? IDS412 = null;

        /// <summary>
        /// RP:tns:FinancialServices.ElectedOutNonOffshoreBankingUnitNotionalInterest.Amount
        /// </summary>
        public decimal? IDS415 = null;

        /// <summary>
        /// RP:tns:FinancialServices.ElectedOutOffshoreBankingUnitNotionalInterest.Amount
        /// </summary>
        public decimal? IDS416 = null;

        /// <summary>
        /// RP:tns:FinancialServices.ElectedOutNotionalInterestTaxWithholding.Amount
        /// </summary>
        public decimal? IDS417 = null;

        /// <summary>
        /// RP:tns:FinancialServices.NotionalPaymentDenied.Indicator
        /// </summary>
        public bool? IDS455 = null;

        /// <summary>
        /// RP:tns:FinancialServices.NotionalPaymentDenied.Amount
        /// </summary>
        public decimal? IDS456 = null;

        /// <summary>
        /// RP:tns:FinancialServices.OffshoreBankingUnitOrHeadConsolidatedGroup.Indicator
        /// </summary>
        public bool? IDS268 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ConduitForeignIncome.Indicator
        /// </summary>
        public bool? IDS309 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ConduitForeignIncomeBalance.Amount
        /// </summary>
        public decimal? IDS310 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.ConduitForeignIncomeDistributed.Amount
        /// </summary>
        public decimal? IDS311 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.UnfrankedNonPortfolioDividendAccount.Indicator
        /// </summary>
        public bool? IDS312 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.UnfrankedNonPortfolioDividendAccount.Amount
        /// </summary>
        public decimal? IDS313 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.UnfrankedNonPortfolioAccountConduitForeignIncomeIncluded.Indicator
        /// </summary>
        public bool? IDS314 = null;

        /// <summary>
        /// RP:tns:InternationalDealings.DoubleTaxAgreementFinancialInstitutionsWithholdingExemptionCountry.Code
        /// </summary>
        public string IDS317 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.HybridMismatch.Indicator
        /// </summary>
        public bool? IDS481 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.HybridMismatchDeductionNonInclusion.Indicator
        /// </summary>
        public bool? IDS458 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.HybridMismatchPayments.Amount
        /// </summary>
        public decimal? IDS482 = null;
    
        public bool MaterialArrangementsCollectionExists = false;
        public int MaterialArrangementsCollectionCount = 0;

        public List<MaterialArrangements> MaterialArrangementsCollection = null;

        public class MaterialArrangements 
        {
            public int OccurrenceIndex = 0;
    
            /// <summary>
            /// /xbrli:xbrl/tns:MaterialArrangements
            /// RP:tns:Miscellaneous.HybridMismatchArrangement.Code
            /// </summary>
            public string IDS460 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:MaterialArrangements
            /// RP:tns:OrganisationDetails.InternationalRelatedPartyCountry.Code
            /// </summary>
            public string IDS461 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:MaterialArrangements
            /// RP:tns:Miscellaneous.HybridMismatchPayments.Amount
            /// </summary>
            public decimal? IDS462 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:MaterialArrangements
            /// RP:tns:Miscellaneous.HybridMismatchDeductionsDeniedOrIncomeInclusion.Amount
            /// </summary>
            public decimal? IDS463 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:MaterialArrangements
            /// RP:tns:Miscellaneous.HybridMismatchDifferenceReason.Code
            /// </summary>
            public string IDS464 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:MaterialArrangements
            /// RP:tns:Miscellaneous.HybridMismatchPaymentRecipient.Indicator
            /// </summary>
            public bool? IDS465 = null;
        }

        /// <summary>
        /// RP:tns:Miscellaneous.OffshoreHybridMismatch.Indicator
        /// </summary>
        public bool? IDS466 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.HybridMismatchDeductionsDenied.Amount
        /// </summary>
        public decimal? IDS467 = null;

        /// <summary>
        /// RP:tns:Miscellaneous.PaymentNotTaxedOrTaxed10PercentOrLess.Indicator
        /// </summary>
        public bool? IDS468 = null;
    
        public bool HybridPayerMismatchCollectionExists = false;
        public int HybridPayerMismatchCollectionCount = 0;

        public List<HybridPayerMismatch> HybridPayerMismatchCollection = null;

        public class HybridPayerMismatch 
        {
            public int OccurrenceIndex = 0;
    
            /// <summary>
            /// /xbrli:xbrl/tns:HybridPayerMismatch
            /// RP:tns:OrganisationDetails.InternationalRelatedPartyCountry.Code
            /// </summary>
            public string IDS470 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:HybridPayerMismatch
            /// RP:tns:Miscellaneous.HybridMismatchPayments.Amount
            /// </summary>
            public decimal? IDS471 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:HybridPayerMismatch
            /// RP:tns:Miscellaneous.HybridMismatchDeductionsDenied.Amount
            /// </summary>
            public decimal? IDS472 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:HybridPayerMismatch
            /// RP:tns:Miscellaneous.HybridMismatchExceptionReason.Code
            /// </summary>
            public string IDS473 = null;
        }

        /// <summary>
        /// RP:tns:Miscellaneous.HybridArrangementRestructureReplacement.Indicator
        /// </summary>
        public bool? IDS474 = null;
    
        public bool HybridArrangementRestructureCollectionExists = false;
        public int HybridArrangementRestructureCollectionCount = 0;

        public List<HybridArrangementRestructure> HybridArrangementRestructureCollection = null;

        public class HybridArrangementRestructure 
        {
            public int OccurrenceIndex = 0;
    
            /// <summary>
            /// /xbrli:xbrl/tns:HybridArrangementRestructure
            /// RP:tns:InternationalDealings.Description.Text
            /// </summary>
            public string IDS475 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:HybridArrangementRestructure
            /// RP:tns:InternationalDealings.HybridEventAnalysis.Indicator
            /// </summary>
            public bool? IDS476 = null;
        }

        /// <summary>
        /// RP:tns:Income.ForeignEquityDistributionForeignTaxDeduction.Indicator
        /// </summary>
        public bool? IDS477 = null;

        /// <summary>
        /// RP:tns:Income.ForeignDeductionNotNonAssessableNonExempt.Amount
        /// </summary>
        public decimal? IDS478 = null;

        /// <summary>
        /// RP:tns:Income.DerivedBranchHybridMismatchIncome.Indicator
        /// </summary>
        public bool? IDS479 = null;

        /// <summary>
        /// RP:tns:Income.ForeignHybridIncomeNotNonAssessableNonExempt.Amount
        /// </summary>
        public decimal? IDS480 = null;

        public string RPQuarterlyId = null;
        public bool RPQuarterlyExists = false;
        public int RPQuarterlyCount = 0;
        public int RPQuarterlyOccurrenceIndex = 0;
        public int RPQuarterlyLastOccurrenceIndex = 0;
        public string RPQuarterlyIdentifier = null;
        public string RPQuarterlyIdentifierScheme = null;
        public string RPQuarterlyIdentifierTFN = null;
        public DateTime? RPQuarterlyStartDate = null;
        public DateTime? RPQuarterlyEndDate = null;

        /// <summary>
        /// RPQuarterly:tns:Expense.Interest.DebtReceivedAverageBalance.Amount
        /// </summary>
        public decimal? IDS173 = null;

        /// <summary>
        /// RPQuarterly:tns:Income.Interest.DebtProvidedAverageBalance.Amount
        /// </summary>
        public decimal? IDS174 = null;

        /// <summary>
        /// RPQuarterly:tns:Expense.Interest.EquityReceivedAverageBalance.Amount
        /// </summary>
        public decimal? IDS175 = null;

        /// <summary>
        /// RPQuarterly:tns:Income.Interest.EquityProvidedAverageBalance.Amount
        /// </summary>
        public decimal? IDS176 = null;

        /// <summary>
        /// RPQuarterly:tns:FinancialServices.NotionalAverageBorrowings.Amount
        /// </summary>
        public decimal? IDS264 = null;

        /// <summary>
        /// RPQuarterly:tns:FinancialServices.NotionalAverageBorrowings.Code
        /// </summary>
        public string IDS407 = null;

        /// <summary>
        /// RPQuarterly:tns:FinancialServices.ElectedOutNotionalAverageBorrowings.Amount
        /// </summary>
        public decimal? IDS413 = null;

        /// <summary>
        /// RPQuarterly:tns:FinancialServices.ElectedOutNotionalAverageBorrowings.Code
        /// </summary>
        public string IDS414 = null;

        public string RPAssetManagementId = null;
        public bool RPAssetManagementExists = false;
        public int RPAssetManagementCount = 0;
        public int RPAssetManagementOccurrenceIndex = 0;
        public int RPAssetManagementLastOccurrenceIndex = 0;
        public string RPAssetManagementIdentifier = null;
        public string RPAssetManagementIdentifierScheme = null;
        public string RPAssetManagementIdentifierTFN = null;
        public DateTime? RPAssetManagementStartDate = null;
        public DateTime? RPAssetManagementEndDate = null;

        /// <summary>
        /// RPAssetManagement:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS72 = null;

        /// <summary>
        /// RPAssetManagement:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS73 = null;

        /// <summary>
        /// RPAssetManagement:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS74 = null;

        /// <summary>
        /// RPAssetManagement:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS75 = null;

        public string RPBranchOperationsId = null;
        public bool RPBranchOperationsExists = false;
        public int RPBranchOperationsCount = 0;
        public int RPBranchOperationsOccurrenceIndex = 0;
        public int RPBranchOperationsLastOccurrenceIndex = 0;
        public string RPBranchOperationsIdentifier = null;
        public string RPBranchOperationsIdentifierScheme = null;
        public string RPBranchOperationsIdentifierTFN = null;
        public DateTime? RPBranchOperationsStartDate = null;
        public DateTime? RPBranchOperationsEndDate = null;

        /// <summary>
        /// RPBranchOperations:tns:Expense.TradingStockPurchaseCosts.Amount
        /// </summary>
        public decimal? IDS167 = null;

        /// <summary>
        /// RPBranchOperations:tns:Income.TradingStockSalesTotal.Amount
        /// </summary>
        public decimal? IDS168 = null;

        public string RPCapitalNonMonetaryPaymentId = null;
        public bool RPCapitalNonMonetaryPaymentExists = false;
        public int RPCapitalNonMonetaryPaymentCount = 0;
        public int RPCapitalNonMonetaryPaymentOccurrenceIndex = 0;
        public int RPCapitalNonMonetaryPaymentLastOccurrenceIndex = 0;
        public string RPCapitalNonMonetaryPaymentIdentifier = null;
        public string RPCapitalNonMonetaryPaymentIdentifierScheme = null;
        public string RPCapitalNonMonetaryPaymentIdentifierTFN = null;
        public DateTime? RPCapitalNonMonetaryPaymentStartDate = null;
        public DateTime? RPCapitalNonMonetaryPaymentEndDate = null;

        /// <summary>
        /// RPCapitalNonMonetaryPayment:tns:OrganisationDetails.InternationalRelatedPartyCountry.Code
        /// </summary>
        public string IDS143 = null;

        /// <summary>
        /// RPCapitalNonMonetaryPayment:tns:Miscellaneous.NatureOfItem.Code
        /// </summary>
        public string IDS144 = null;

        public string RPCapitalNoPaymentId = null;
        public bool RPCapitalNoPaymentExists = false;
        public int RPCapitalNoPaymentCount = 0;
        public int RPCapitalNoPaymentOccurrenceIndex = 0;
        public int RPCapitalNoPaymentLastOccurrenceIndex = 0;
        public string RPCapitalNoPaymentIdentifier = null;
        public string RPCapitalNoPaymentIdentifierScheme = null;
        public string RPCapitalNoPaymentIdentifierTFN = null;
        public DateTime? RPCapitalNoPaymentStartDate = null;
        public DateTime? RPCapitalNoPaymentEndDate = null;

        /// <summary>
        /// RPCapitalNoPayment:tns:OrganisationDetails.InternationalRelatedPartyCountry.Code
        /// </summary>
        public string IDS139 = null;

        /// <summary>
        /// RPCapitalNoPayment:tns:Miscellaneous.NatureOfItem.Code
        /// </summary>
        public string IDS140 = null;

        public string RPDebtFactoringId = null;
        public bool RPDebtFactoringExists = false;
        public int RPDebtFactoringCount = 0;
        public int RPDebtFactoringOccurrenceIndex = 0;
        public int RPDebtFactoringLastOccurrenceIndex = 0;
        public string RPDebtFactoringIdentifier = null;
        public string RPDebtFactoringIdentifierScheme = null;
        public string RPDebtFactoringIdentifierTFN = null;
        public DateTime? RPDebtFactoringStartDate = null;
        public DateTime? RPDebtFactoringEndDate = null;

        /// <summary>
        /// RPDebtFactoring:tns:Expense.BookValue.Amount
        /// </summary>
        public decimal? IDS89 = null;

        /// <summary>
        /// RPDebtFactoring:tns:Expense.Consideration.Amount
        /// </summary>
        public decimal? IDS90 = null;

        /// <summary>
        /// RPDebtFactoring:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS91 = null;

        /// <summary>
        /// RPDebtFactoring:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS92 = null;

        public string RPDerivativesId = null;
        public bool RPDerivativesExists = false;
        public int RPDerivativesCount = 0;
        public int RPDerivativesOccurrenceIndex = 0;
        public int RPDerivativesLastOccurrenceIndex = 0;
        public string RPDerivativesIdentifier = null;
        public string RPDerivativesIdentifierScheme = null;
        public string RPDerivativesIdentifierTFN = null;
        public DateTime? RPDerivativesStartDate = null;
        public DateTime? RPDerivativesEndDate = null;

        /// <summary>
        /// RPDerivatives:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS82 = null;

        /// <summary>
        /// RPDerivatives:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS83 = null;

        /// <summary>
        /// RPDerivatives:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS84 = null;

        /// <summary>
        /// RPDerivatives:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS85 = null;

        /// <summary>
        /// RPDerivatives:tns:InternationalDealings.RelatedPartyTransactionType.Code
        /// </summary>
        public List<string> IDS332Collection = null;

        public string RPInsuranceId = null;
        public bool RPInsuranceExists = false;
        public int RPInsuranceCount = 0;
        public int RPInsuranceOccurrenceIndex = 0;
        public int RPInsuranceLastOccurrenceIndex = 0;
        public string RPInsuranceIdentifier = null;
        public string RPInsuranceIdentifierScheme = null;
        public string RPInsuranceIdentifierTFN = null;
        public DateTime? RPInsuranceStartDate = null;
        public DateTime? RPInsuranceEndDate = null;

        /// <summary>
        /// RPInsurance:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS44 = null;

        /// <summary>
        /// RPInsurance:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS45 = null;

        /// <summary>
        /// RPInsurance:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS46 = null;

        /// <summary>
        /// RPInsurance:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS47 = null;

        public string RPLicenceFeesId = null;
        public bool RPLicenceFeesExists = false;
        public int RPLicenceFeesCount = 0;
        public int RPLicenceFeesOccurrenceIndex = 0;
        public int RPLicenceFeesLastOccurrenceIndex = 0;
        public string RPLicenceFeesIdentifier = null;
        public string RPLicenceFeesIdentifierScheme = null;
        public string RPLicenceFeesIdentifierTFN = null;
        public DateTime? RPLicenceFeesStartDate = null;
        public DateTime? RPLicenceFeesEndDate = null;

        /// <summary>
        /// RPLicenceFees:tns:Expense.DeductionsTotal.Amount
        /// </summary>
        public decimal? IDS26 = null;

        /// <summary>
        /// RPLicenceFees:tns:Income.IncludedInAssessableTotal.Amount
        /// </summary>
        public decimal? IDS27 = null;

        /// <summary>
        /// RPLicenceFees:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS28 = null;

        /// <summary>
        /// RPLicenceFees:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS29 = null;

        public string RPLogisticsId = null;
        public bool RPLogisticsExists = false;
        public int RPLogisticsCount = 0;
        public int RPLogisticsOccurrenceIndex = 0;
        public int RPLogisticsLastOccurrenceIndex = 0;
        public string RPLogisticsIdentifier = null;
        public string RPLogisticsIdentifierScheme = null;
        public string RPLogisticsIdentifierTFN = null;
        public DateTime? RPLogisticsStartDate = null;
        public DateTime? RPLogisticsEndDate = null;

        /// <summary>
        /// RPLogistics:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS68 = null;

        /// <summary>
        /// RPLogistics:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS69 = null;

        /// <summary>
        /// RPLogistics:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS70 = null;

        /// <summary>
        /// RPLogistics:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS71 = null;

        public string RPManagementAndAdminId = null;
        public bool RPManagementAndAdminExists = false;
        public int RPManagementAndAdminCount = 0;
        public int RPManagementAndAdminOccurrenceIndex = 0;
        public int RPManagementAndAdminLastOccurrenceIndex = 0;
        public string RPManagementAndAdminIdentifier = null;
        public string RPManagementAndAdminIdentifierScheme = null;
        public string RPManagementAndAdminIdentifierTFN = null;
        public DateTime? RPManagementAndAdminStartDate = null;
        public DateTime? RPManagementAndAdminEndDate = null;

        /// <summary>
        /// RPManagementAndAdmin:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS40 = null;

        /// <summary>
        /// RPManagementAndAdmin:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS41 = null;

        /// <summary>
        /// RPManagementAndAdmin:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS42 = null;

        /// <summary>
        /// RPManagementAndAdmin:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS43 = null;

        public string RPOtherFinancialDealingsId = null;
        public bool RPOtherFinancialDealingsExists = false;
        public int RPOtherFinancialDealingsCount = 0;
        public int RPOtherFinancialDealingsOccurrenceIndex = 0;
        public int RPOtherFinancialDealingsLastOccurrenceIndex = 0;
        public string RPOtherFinancialDealingsIdentifier = null;
        public string RPOtherFinancialDealingsIdentifierScheme = null;
        public string RPOtherFinancialDealingsIdentifierTFN = null;
        public DateTime? RPOtherFinancialDealingsStartDate = null;
        public DateTime? RPOtherFinancialDealingsEndDate = null;

        /// <summary>
        /// RPOtherFinancialDealings:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS118 = null;

        /// <summary>
        /// RPOtherFinancialDealings:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS119 = null;

        /// <summary>
        /// RPOtherFinancialDealings:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS120 = null;

        /// <summary>
        /// RPOtherFinancialDealings:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS121 = null;

        /// <summary>
        /// RPOtherFinancialDealings:tns:InternationalDealings.Description.Text
        /// </summary>
        public string IDS122 = null;

        public string RPOtherGuaranteesId = null;
        public bool RPOtherGuaranteesExists = false;
        public int RPOtherGuaranteesCount = 0;
        public int RPOtherGuaranteesOccurrenceIndex = 0;
        public int RPOtherGuaranteesLastOccurrenceIndex = 0;
        public string RPOtherGuaranteesIdentifier = null;
        public string RPOtherGuaranteesIdentifierScheme = null;
        public string RPOtherGuaranteesIdentifierTFN = null;
        public DateTime? RPOtherGuaranteesStartDate = null;
        public DateTime? RPOtherGuaranteesEndDate = null;

        /// <summary>
        /// RPOtherGuarantees:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS106 = null;

        /// <summary>
        /// RPOtherGuarantees:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS107 = null;

        /// <summary>
        /// RPOtherGuarantees:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS108 = null;

        /// <summary>
        /// RPOtherGuarantees:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS109 = null;

        public string RPOtherInsuranceId = null;
        public bool RPOtherInsuranceExists = false;
        public int RPOtherInsuranceCount = 0;
        public int RPOtherInsuranceOccurrenceIndex = 0;
        public int RPOtherInsuranceLastOccurrenceIndex = 0;
        public string RPOtherInsuranceIdentifier = null;
        public string RPOtherInsuranceIdentifierScheme = null;
        public string RPOtherInsuranceIdentifierTFN = null;
        public DateTime? RPOtherInsuranceStartDate = null;
        public DateTime? RPOtherInsuranceEndDate = null;

        /// <summary>
        /// RPOtherInsurance:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS110 = null;

        /// <summary>
        /// RPOtherInsurance:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS111 = null;

        /// <summary>
        /// RPOtherInsurance:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS112 = null;

        /// <summary>
        /// RPOtherInsurance:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS113 = null;

        public string RPOtherInterestId = null;
        public bool RPOtherInterestExists = false;
        public int RPOtherInterestCount = 0;
        public int RPOtherInterestOccurrenceIndex = 0;
        public int RPOtherInterestLastOccurrenceIndex = 0;
        public string RPOtherInterestIdentifier = null;
        public string RPOtherInterestIdentifierScheme = null;
        public string RPOtherInterestIdentifierTFN = null;
        public DateTime? RPOtherInterestStartDate = null;
        public DateTime? RPOtherInterestEndDate = null;

        /// <summary>
        /// RPOtherInterest:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS102 = null;

        /// <summary>
        /// RPOtherInterest:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS103 = null;

        /// <summary>
        /// RPOtherInterest:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS104 = null;

        /// <summary>
        /// RPOtherInterest:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS105 = null;

        public string RPOtherNotReportedIntangibleNonRevenueId = null;
        public bool RPOtherNotReportedIntangibleNonRevenueExists = false;
        public int RPOtherNotReportedIntangibleNonRevenueCount = 0;
        public int RPOtherNotReportedIntangibleNonRevenueOccurrenceIndex = 0;
        public int RPOtherNotReportedIntangibleNonRevenueLastOccurrenceIndex = 0;
        public string RPOtherNotReportedIntangibleNonRevenueIdentifier = null;
        public string RPOtherNotReportedIntangibleNonRevenueIdentifierScheme = null;
        public string RPOtherNotReportedIntangibleNonRevenueIdentifierTFN = null;
        public DateTime? RPOtherNotReportedIntangibleNonRevenueStartDate = null;
        public DateTime? RPOtherNotReportedIntangibleNonRevenueEndDate = null;

        /// <summary>
        /// RPOtherNotReportedIntangibleNonRevenue:tns:Assets.ConsiderationPaid.Amount
        /// </summary>
        public decimal? IDS134 = null;

        /// <summary>
        /// RPOtherNotReportedIntangibleNonRevenue:tns:Assets.ConsiderationReceived.Amount
        /// </summary>
        public decimal? IDS135 = null;

        /// <summary>
        /// RPOtherNotReportedIntangibleNonRevenue:tns:Miscellaneous.AcquisitionsAndDisposalsPricingMethod.Code
        /// </summary>
        public string IDS136 = null;

        /// <summary>
        /// RPOtherNotReportedIntangibleNonRevenue:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS137 = null;

        public string RPOtherNotReportedRevenueId = null;
        public bool RPOtherNotReportedRevenueExists = false;
        public int RPOtherNotReportedRevenueCount = 0;
        public int RPOtherNotReportedRevenueOccurrenceIndex = 0;
        public int RPOtherNotReportedRevenueLastOccurrenceIndex = 0;
        public string RPOtherNotReportedRevenueIdentifier = null;
        public string RPOtherNotReportedRevenueIdentifierScheme = null;
        public string RPOtherNotReportedRevenueIdentifierTFN = null;
        public DateTime? RPOtherNotReportedRevenueStartDate = null;
        public DateTime? RPOtherNotReportedRevenueEndDate = null;

        /// <summary>
        /// RPOtherNotReportedRevenue:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS124 = null;

        /// <summary>
        /// RPOtherNotReportedRevenue:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS125 = null;

        /// <summary>
        /// RPOtherNotReportedRevenue:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS126 = null;

        /// <summary>
        /// RPOtherNotReportedRevenue:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS127 = null;

        /// <summary>
        /// RPOtherNotReportedRevenue:tns:InternationalDealings.Description.Text
        /// </summary>
        public string IDS128 = null;

        public string RPOtherNotReportedTangibleNonRevenueId = null;
        public bool RPOtherNotReportedTangibleNonRevenueExists = false;
        public int RPOtherNotReportedTangibleNonRevenueCount = 0;
        public int RPOtherNotReportedTangibleNonRevenueOccurrenceIndex = 0;
        public int RPOtherNotReportedTangibleNonRevenueLastOccurrenceIndex = 0;
        public string RPOtherNotReportedTangibleNonRevenueIdentifier = null;
        public string RPOtherNotReportedTangibleNonRevenueIdentifierScheme = null;
        public string RPOtherNotReportedTangibleNonRevenueIdentifierTFN = null;
        public DateTime? RPOtherNotReportedTangibleNonRevenueStartDate = null;
        public DateTime? RPOtherNotReportedTangibleNonRevenueEndDate = null;

        /// <summary>
        /// RPOtherNotReportedTangibleNonRevenue:tns:Assets.ConsiderationPaid.Amount
        /// </summary>
        public decimal? IDS130 = null;

        /// <summary>
        /// RPOtherNotReportedTangibleNonRevenue:tns:Assets.ConsiderationReceived.Amount
        /// </summary>
        public decimal? IDS131 = null;

        /// <summary>
        /// RPOtherNotReportedTangibleNonRevenue:tns:Miscellaneous.AcquisitionsAndDisposalsPricingMethod.Code
        /// </summary>
        public string IDS132 = null;

        /// <summary>
        /// RPOtherNotReportedTangibleNonRevenue:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS133 = null;

        public string RPOtherReinsuranceId = null;
        public bool RPOtherReinsuranceExists = false;
        public int RPOtherReinsuranceCount = 0;
        public int RPOtherReinsuranceOccurrenceIndex = 0;
        public int RPOtherReinsuranceLastOccurrenceIndex = 0;
        public string RPOtherReinsuranceIdentifier = null;
        public string RPOtherReinsuranceIdentifierScheme = null;
        public string RPOtherReinsuranceIdentifierTFN = null;
        public DateTime? RPOtherReinsuranceStartDate = null;
        public DateTime? RPOtherReinsuranceEndDate = null;

        /// <summary>
        /// RPOtherReinsurance:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS114 = null;

        /// <summary>
        /// RPOtherReinsurance:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS115 = null;

        /// <summary>
        /// RPOtherReinsurance:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS116 = null;

        /// <summary>
        /// RPOtherReinsurance:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS117 = null;

        public string RPOtherServicesId = null;
        public bool RPOtherServicesExists = false;
        public int RPOtherServicesCount = 0;
        public int RPOtherServicesOccurrenceIndex = 0;
        public int RPOtherServicesLastOccurrenceIndex = 0;
        public string RPOtherServicesIdentifier = null;
        public string RPOtherServicesIdentifierScheme = null;
        public string RPOtherServicesIdentifierTFN = null;
        public DateTime? RPOtherServicesStartDate = null;
        public DateTime? RPOtherServicesEndDate = null;

        /// <summary>
        /// RPOtherServices:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS76 = null;

        /// <summary>
        /// RPOtherServices:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS77 = null;

        /// <summary>
        /// RPOtherServices:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS78 = null;

        /// <summary>
        /// RPOtherServices:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS79 = null;

        /// <summary>
        /// RPOtherServices:tns:InternationalDealings.Description.Text
        /// </summary>
        public string IDS80 = null;

        public string RPRechargeAmountsId = null;
        public bool RPRechargeAmountsExists = false;
        public int RPRechargeAmountsCount = 0;
        public int RPRechargeAmountsOccurrenceIndex = 0;
        public int RPRechargeAmountsLastOccurrenceIndex = 0;
        public string RPRechargeAmountsIdentifier = null;
        public string RPRechargeAmountsIdentifierScheme = null;
        public string RPRechargeAmountsIdentifierTFN = null;
        public DateTime? RPRechargeAmountsStartDate = null;
        public DateTime? RPRechargeAmountsEndDate = null;

        /// <summary>
        /// RPRechargeAmounts:tns:Expense.DeductionsTotal.Amount
        /// </summary>
        public decimal? IDS148 = null;

        /// <summary>
        /// RPRechargeAmounts:tns:Income.IncludedInAssessableTotal.Amount
        /// </summary>
        public decimal? IDS149 = null;

        public string RPReinsuranceId = null;
        public bool RPReinsuranceExists = false;
        public int RPReinsuranceCount = 0;
        public int RPReinsuranceOccurrenceIndex = 0;
        public int RPReinsuranceLastOccurrenceIndex = 0;
        public string RPReinsuranceIdentifier = null;
        public string RPReinsuranceIdentifierScheme = null;
        public string RPReinsuranceIdentifierTFN = null;
        public DateTime? RPReinsuranceStartDate = null;
        public DateTime? RPReinsuranceEndDate = null;

        /// <summary>
        /// RPReinsurance:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS48 = null;

        /// <summary>
        /// RPReinsurance:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS49 = null;

        /// <summary>
        /// RPReinsurance:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS50 = null;

        /// <summary>
        /// RPReinsurance:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS51 = null;

        public string RPRentLeaseId = null;
        public bool RPRentLeaseExists = false;
        public int RPRentLeaseCount = 0;
        public int RPRentLeaseOccurrenceIndex = 0;
        public int RPRentLeaseLastOccurrenceIndex = 0;
        public string RPRentLeaseIdentifier = null;
        public string RPRentLeaseIdentifierScheme = null;
        public string RPRentLeaseIdentifierTFN = null;
        public DateTime? RPRentLeaseStartDate = null;
        public DateTime? RPRentLeaseEndDate = null;

        /// <summary>
        /// RPRentLease:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS31 = null;

        /// <summary>
        /// RPRentLease:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS32 = null;

        /// <summary>
        /// RPRentLease:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS33 = null;

        /// <summary>
        /// RPRentLease:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS34 = null;

        public string RPResearchAndDevelopmentId = null;
        public bool RPResearchAndDevelopmentExists = false;
        public int RPResearchAndDevelopmentCount = 0;
        public int RPResearchAndDevelopmentOccurrenceIndex = 0;
        public int RPResearchAndDevelopmentLastOccurrenceIndex = 0;
        public string RPResearchAndDevelopmentIdentifier = null;
        public string RPResearchAndDevelopmentIdentifierScheme = null;
        public string RPResearchAndDevelopmentIdentifierTFN = null;
        public DateTime? RPResearchAndDevelopmentStartDate = null;
        public DateTime? RPResearchAndDevelopmentEndDate = null;

        /// <summary>
        /// RPResearchAndDevelopment:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS52 = null;

        /// <summary>
        /// RPResearchAndDevelopment:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS53 = null;

        /// <summary>
        /// RPResearchAndDevelopment:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS54 = null;

        /// <summary>
        /// RPResearchAndDevelopment:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS55 = null;

        public string RPRevenueNonMonetaryPaymentId = null;
        public bool RPRevenueNonMonetaryPaymentExists = false;
        public int RPRevenueNonMonetaryPaymentCount = 0;
        public int RPRevenueNonMonetaryPaymentOccurrenceIndex = 0;
        public int RPRevenueNonMonetaryPaymentLastOccurrenceIndex = 0;
        public string RPRevenueNonMonetaryPaymentIdentifier = null;
        public string RPRevenueNonMonetaryPaymentIdentifierScheme = null;
        public string RPRevenueNonMonetaryPaymentIdentifierTFN = null;
        public DateTime? RPRevenueNonMonetaryPaymentStartDate = null;
        public DateTime? RPRevenueNonMonetaryPaymentEndDate = null;

        /// <summary>
        /// RPRevenueNonMonetaryPayment:tns:OrganisationDetails.InternationalRelatedPartyCountry.Code
        /// </summary>
        public string IDS145 = null;

        /// <summary>
        /// RPRevenueNonMonetaryPayment:tns:Miscellaneous.NatureOfItem.Code
        /// </summary>
        public string IDS146 = null;

        public string RPRevenueNoPaymentId = null;
        public bool RPRevenueNoPaymentExists = false;
        public int RPRevenueNoPaymentCount = 0;
        public int RPRevenueNoPaymentOccurrenceIndex = 0;
        public int RPRevenueNoPaymentLastOccurrenceIndex = 0;
        public string RPRevenueNoPaymentIdentifier = null;
        public string RPRevenueNoPaymentIdentifierScheme = null;
        public string RPRevenueNoPaymentIdentifierTFN = null;
        public DateTime? RPRevenueNoPaymentStartDate = null;
        public DateTime? RPRevenueNoPaymentEndDate = null;

        /// <summary>
        /// RPRevenueNoPayment:tns:OrganisationDetails.InternationalRelatedPartyCountry.Code
        /// </summary>
        public string IDS141 = null;

        /// <summary>
        /// RPRevenueNoPayment:tns:Miscellaneous.NatureOfItem.Code
        /// </summary>
        public string IDS142 = null;

        public string RPRoyaltiesId = null;
        public bool RPRoyaltiesExists = false;
        public int RPRoyaltiesCount = 0;
        public int RPRoyaltiesOccurrenceIndex = 0;
        public int RPRoyaltiesLastOccurrenceIndex = 0;
        public string RPRoyaltiesIdentifier = null;
        public string RPRoyaltiesIdentifierScheme = null;
        public string RPRoyaltiesIdentifierTFN = null;
        public DateTime? RPRoyaltiesStartDate = null;
        public DateTime? RPRoyaltiesEndDate = null;

        /// <summary>
        /// RPRoyalties:tns:Expense.DeductionsTotal.Amount
        /// </summary>
        public decimal? IDS22 = null;

        /// <summary>
        /// RPRoyalties:tns:Income.IncludedInAssessableTotal.Amount
        /// </summary>
        public decimal? IDS23 = null;

        /// <summary>
        /// RPRoyalties:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS24 = null;

        /// <summary>
        /// RPRoyalties:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS25 = null;

        public string RPSalesAndMarketingId = null;
        public bool RPSalesAndMarketingExists = false;
        public int RPSalesAndMarketingCount = 0;
        public int RPSalesAndMarketingOccurrenceIndex = 0;
        public int RPSalesAndMarketingLastOccurrenceIndex = 0;
        public string RPSalesAndMarketingIdentifier = null;
        public string RPSalesAndMarketingIdentifierScheme = null;
        public string RPSalesAndMarketingIdentifierTFN = null;
        public DateTime? RPSalesAndMarketingStartDate = null;
        public DateTime? RPSalesAndMarketingEndDate = null;

        /// <summary>
        /// RPSalesAndMarketing:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS56 = null;

        /// <summary>
        /// RPSalesAndMarketing:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS57 = null;

        /// <summary>
        /// RPSalesAndMarketing:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS58 = null;

        /// <summary>
        /// RPSalesAndMarketing:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS59 = null;

        public string RPSecuritisationId = null;
        public bool RPSecuritisationExists = false;
        public int RPSecuritisationCount = 0;
        public int RPSecuritisationOccurrenceIndex = 0;
        public int RPSecuritisationLastOccurrenceIndex = 0;
        public string RPSecuritisationIdentifier = null;
        public string RPSecuritisationIdentifierScheme = null;
        public string RPSecuritisationIdentifierTFN = null;
        public DateTime? RPSecuritisationStartDate = null;
        public DateTime? RPSecuritisationEndDate = null;

        /// <summary>
        /// RPSecuritisation:tns:Expense.BookValue.Amount
        /// </summary>
        public decimal? IDS93 = null;

        /// <summary>
        /// RPSecuritisation:tns:Expense.Consideration.Amount
        /// </summary>
        public decimal? IDS94 = null;

        /// <summary>
        /// RPSecuritisation:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS95 = null;

        /// <summary>
        /// RPSecuritisation:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS96 = null;

        public string RPSoftwareAndITServicesId = null;
        public bool RPSoftwareAndITServicesExists = false;
        public int RPSoftwareAndITServicesCount = 0;
        public int RPSoftwareAndITServicesOccurrenceIndex = 0;
        public int RPSoftwareAndITServicesLastOccurrenceIndex = 0;
        public string RPSoftwareAndITServicesIdentifier = null;
        public string RPSoftwareAndITServicesIdentifierScheme = null;
        public string RPSoftwareAndITServicesIdentifierTFN = null;
        public DateTime? RPSoftwareAndITServicesStartDate = null;
        public DateTime? RPSoftwareAndITServicesEndDate = null;

        /// <summary>
        /// RPSoftwareAndITServices:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS60 = null;

        /// <summary>
        /// RPSoftwareAndITServices:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS61 = null;

        /// <summary>
        /// RPSoftwareAndITServices:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS62 = null;

        /// <summary>
        /// RPSoftwareAndITServices:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS63 = null;

        public string RPTangibleRevenueId = null;
        public bool RPTangibleRevenueExists = false;
        public int RPTangibleRevenueCount = 0;
        public int RPTangibleRevenueOccurrenceIndex = 0;
        public int RPTangibleRevenueLastOccurrenceIndex = 0;
        public string RPTangibleRevenueIdentifier = null;
        public string RPTangibleRevenueIdentifierScheme = null;
        public string RPTangibleRevenueIdentifierTFN = null;
        public DateTime? RPTangibleRevenueStartDate = null;
        public DateTime? RPTangibleRevenueEndDate = null;

        /// <summary>
        /// RPTangibleRevenue:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS17 = null;

        /// <summary>
        /// RPTangibleRevenue:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS18 = null;

        /// <summary>
        /// RPTangibleRevenue:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS19 = null;

        /// <summary>
        /// RPTangibleRevenue:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS20 = null;

        public string RPTechnicalId = null;
        public bool RPTechnicalExists = false;
        public int RPTechnicalCount = 0;
        public int RPTechnicalOccurrenceIndex = 0;
        public int RPTechnicalLastOccurrenceIndex = 0;
        public string RPTechnicalIdentifier = null;
        public string RPTechnicalIdentifierScheme = null;
        public string RPTechnicalIdentifierTFN = null;
        public DateTime? RPTechnicalStartDate = null;
        public DateTime? RPTechnicalEndDate = null;

        /// <summary>
        /// RPTechnical:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS64 = null;

        /// <summary>
        /// RPTechnical:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS65 = null;

        /// <summary>
        /// RPTechnical:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS66 = null;

        /// <summary>
        /// RPTechnical:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS67 = null;

        public string RPTreasuryRelatedId = null;
        public bool RPTreasuryRelatedExists = false;
        public int RPTreasuryRelatedCount = 0;
        public int RPTreasuryRelatedOccurrenceIndex = 0;
        public int RPTreasuryRelatedLastOccurrenceIndex = 0;
        public string RPTreasuryRelatedIdentifier = null;
        public string RPTreasuryRelatedIdentifierScheme = null;
        public string RPTreasuryRelatedIdentifierTFN = null;
        public DateTime? RPTreasuryRelatedStartDate = null;
        public DateTime? RPTreasuryRelatedEndDate = null;

        /// <summary>
        /// RPTreasuryRelated:tns:Expense.Total.Amount
        /// </summary>
        public decimal? IDS36 = null;

        /// <summary>
        /// RPTreasuryRelated:tns:Revenue.Total.Amount
        /// </summary>
        public decimal? IDS37 = null;

        /// <summary>
        /// RPTreasuryRelated:tns:Miscellaneous.ArmsLengthPricingMethod.Code
        /// </summary>
        public string IDS38 = null;

        /// <summary>
        /// RPTreasuryRelated:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS39 = null;

        public string RPOtherNotReportedAssignmentOfIntangibleNonRevenueId = null;
        public bool RPOtherNotReportedAssignmentOfIntangibleNonRevenueExists = false;
        public int RPOtherNotReportedAssignmentOfIntangibleNonRevenueCount = 0;
        public int RPOtherNotReportedAssignmentOfIntangibleNonRevenueOccurrenceIndex = 0;
        public int RPOtherNotReportedAssignmentOfIntangibleNonRevenueLastOccurrenceIndex = 0;
        public string RPOtherNotReportedAssignmentOfIntangibleNonRevenueIdentifier = null;
        public string RPOtherNotReportedAssignmentOfIntangibleNonRevenueIdentifierScheme = null;
        public string RPOtherNotReportedAssignmentOfIntangibleNonRevenueIdentifierTFN = null;
        public DateTime? RPOtherNotReportedAssignmentOfIntangibleNonRevenueStartDate = null;
        public DateTime? RPOtherNotReportedAssignmentOfIntangibleNonRevenueEndDate = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfIntangibleNonRevenue:tns:Assets.ConsiderationPaid.Amount
        /// </summary>
        public decimal? IDS340 = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfIntangibleNonRevenue:tns:Assets.ConsiderationReceived.Amount
        /// </summary>
        public decimal? IDS341 = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfIntangibleNonRevenue:tns:Miscellaneous.AcquisitionsAndDisposalsPricingMethod.Code
        /// </summary>
        public string IDS342 = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfIntangibleNonRevenue:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS343 = null;

        public string RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueId = null;
        public bool RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueExists = false;
        public int RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueCount = 0;
        public int RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueOccurrenceIndex = 0;
        public int RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueLastOccurrenceIndex = 0;
        public string RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueIdentifier = null;
        public string RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueIdentifierScheme = null;
        public string RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueIdentifierTFN = null;
        public DateTime? RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueStartDate = null;
        public DateTime? RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenueEndDate = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenue:tns:Assets.ConsiderationPaid.Amount
        /// </summary>
        public decimal? IDS344 = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenue:tns:Assets.ConsiderationReceived.Amount
        /// </summary>
        public decimal? IDS345 = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenue:tns:Miscellaneous.AcquisitionsAndDisposalsPricingMethod.Code
        /// </summary>
        public string IDS346 = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfSharesOrEquityInterestsNonRevenue:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS347 = null;

        public string RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueId = null;
        public bool RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueExists = false;
        public int RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueCount = 0;
        public int RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueOccurrenceIndex = 0;
        public int RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueLastOccurrenceIndex = 0;
        public string RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueIdentifier = null;
        public string RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueIdentifierScheme = null;
        public string RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueIdentifierTFN = null;
        public DateTime? RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueStartDate = null;
        public DateTime? RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenueEndDate = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenue:tns:Assets.ConsiderationPaid.Amount
        /// </summary>
        public decimal? IDS348 = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenue:tns:Assets.ConsiderationReceived.Amount
        /// </summary>
        public decimal? IDS349 = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenue:tns:Miscellaneous.AcquisitionsAndDisposalsPricingMethod.Code
        /// </summary>
        public string IDS350 = null;

        /// <summary>
        /// RPOtherNotReportedAssignmentOfLoansOrDebtsNonRevenue:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
        /// </summary>
        public string IDS351 = null;

        public string RPCostPlusRemunerationId = null;
        public bool RPCostPlusRemunerationExists = false;
        public int RPCostPlusRemunerationCount = 0;
        public int RPCostPlusRemunerationOccurrenceIndex = 0;
        public int RPCostPlusRemunerationLastOccurrenceIndex = 0;
        public string RPCostPlusRemunerationIdentifier = null;
        public string RPCostPlusRemunerationIdentifierScheme = null;
        public string RPCostPlusRemunerationIdentifierTFN = null;
        public DateTime? RPCostPlusRemunerationStartDate = null;
        public DateTime? RPCostPlusRemunerationEndDate = null;

        /// <summary>
        /// RPCostPlusRemuneration:tns:Expense.ResearchAndDevelopment.CostPlusRemuneration.Amount
        /// </summary>
        public decimal? IDS427 = null;

        /// <summary>
        /// RPCostPlusRemuneration:tns:Income.ResearchAndDevelopment.CostPlusRemuneration.Amount
        /// </summary>
        public decimal? IDS428 = null;
        public List<RPTrustExemptionCodeContext> RPTrustExemptionCodeContextCollection = null;
        public class RPTrustExemptionCodeContext
        {
    
            public string Id = null;
            public bool Exists = false;
            public int Count = 0;
            public int OccurrenceIndex = 0;
            public int LastOccurrenceIndex = 0;
            public string Identifier = null;
            public string IdentifierScheme = null;
            public string IdentifierTFN = null;
            public DateTime? StartDate = null;
            public DateTime? EndDate = null;

            public string TransferorTrustExemptionCodeDimensionValue = null;
    
            /// <summary>
            /// RPTrustExemptionCode:tns:Report.ItemOrder.Number
            /// </summary>
            public string IDS215 = null;
    
            /// <summary>
            /// RPTrustExemptionCode:tns:Miscellaneous.TransferPropertyMoneyOrServices.Amount
            /// </summary>
            public decimal? IDS214 = null;
        }

        public string RPAdvisoryId = null;
        public bool RPAdvisoryExists = false;
        public int RPAdvisoryCount = 0;
        public int RPAdvisoryOccurrenceIndex = 0;
        public int RPAdvisoryLastOccurrenceIndex = 0;
        public string RPAdvisoryIdentifier = null;
        public string RPAdvisoryIdentifierScheme = null;
        public string RPAdvisoryIdentifierTFN = null;
        public DateTime? RPAdvisoryStartDate = null;
        public DateTime? RPAdvisoryEndDate = null;

        /// <summary>
        /// RPAdvisory:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS287 = null;

        /// <summary>
        /// RPAdvisory:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS288 = null;

        public string RPBorrowingId = null;
        public bool RPBorrowingExists = false;
        public int RPBorrowingCount = 0;
        public int RPBorrowingOccurrenceIndex = 0;
        public int RPBorrowingLastOccurrenceIndex = 0;
        public string RPBorrowingIdentifier = null;
        public string RPBorrowingIdentifierScheme = null;
        public string RPBorrowingIdentifierTFN = null;
        public DateTime? RPBorrowingStartDate = null;
        public DateTime? RPBorrowingEndDate = null;

        /// <summary>
        /// RPBorrowing:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS269 = null;

        /// <summary>
        /// RPBorrowing:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS270 = null;

        public string RPDivision770Id = null;
        public bool RPDivision770Exists = false;
        public int RPDivision770Count = 0;
        public int RPDivision770OccurrenceIndex = 0;
        public int RPDivision770LastOccurrenceIndex = 0;
        public string RPDivision770Identifier = null;
        public string RPDivision770IdentifierScheme = null;
        public string RPDivision770IdentifierTFN = null;
        public DateTime? RPDivision770StartDate = null;
        public DateTime? RPDivision770EndDate = null;

        /// <summary>
        /// RPDivision770:tns:FinancialServices.OffshoreBankingIncomeForeignIncomeTaxEligibleFractionClaimed.Amount
        /// </summary>
        public decimal? IDS306 = null;

        public string RPEligibleContractId = null;
        public bool RPEligibleContractExists = false;
        public int RPEligibleContractCount = 0;
        public int RPEligibleContractOccurrenceIndex = 0;
        public int RPEligibleContractLastOccurrenceIndex = 0;
        public string RPEligibleContractIdentifier = null;
        public string RPEligibleContractIdentifierScheme = null;
        public string RPEligibleContractIdentifierTFN = null;
        public DateTime? RPEligibleContractStartDate = null;
        public DateTime? RPEligibleContractEndDate = null;

        /// <summary>
        /// RPEligibleContract:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS281 = null;

        /// <summary>
        /// RPEligibleContract:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS282 = null;

        public string RPGuaranteeTypeId = null;
        public bool RPGuaranteeTypeExists = false;
        public int RPGuaranteeTypeCount = 0;
        public int RPGuaranteeTypeOccurrenceIndex = 0;
        public int RPGuaranteeTypeLastOccurrenceIndex = 0;
        public string RPGuaranteeTypeIdentifier = null;
        public string RPGuaranteeTypeIdentifierScheme = null;
        public string RPGuaranteeTypeIdentifierTFN = null;
        public DateTime? RPGuaranteeTypeStartDate = null;
        public DateTime? RPGuaranteeTypeEndDate = null;

        /// <summary>
        /// RPGuaranteeType:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS275 = null;

        /// <summary>
        /// RPGuaranteeType:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS276 = null;

        public string RPGeneralDeductionId = null;
        public bool RPGeneralDeductionExists = false;
        public int RPGeneralDeductionCount = 0;
        public int RPGeneralDeductionOccurrenceIndex = 0;
        public int RPGeneralDeductionLastOccurrenceIndex = 0;
        public string RPGeneralDeductionIdentifier = null;
        public string RPGeneralDeductionIdentifierScheme = null;
        public string RPGeneralDeductionIdentifierTFN = null;
        public DateTime? RPGeneralDeductionStartDate = null;
        public DateTime? RPGeneralDeductionEndDate = null;

        /// <summary>
        /// RPGeneralDeduction:tns:FinancialServices.GeneralOffshoreBankingDeductionAndApportionableOffshoreBankingDeduction.Amount
        /// </summary>
        public decimal? IDS296 = null;

        public string RPHedgingId = null;
        public bool RPHedgingExists = false;
        public int RPHedgingCount = 0;
        public int RPHedgingOccurrenceIndex = 0;
        public int RPHedgingLastOccurrenceIndex = 0;
        public string RPHedgingIdentifier = null;
        public string RPHedgingIdentifierScheme = null;
        public string RPHedgingIdentifierTFN = null;
        public DateTime? RPHedgingStartDate = null;
        public DateTime? RPHedgingEndDate = null;

        /// <summary>
        /// RPHedging:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS290 = null;

        /// <summary>
        /// RPHedging:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS291 = null;

        public string RPInvestmentId = null;
        public bool RPInvestmentExists = false;
        public int RPInvestmentCount = 0;
        public int RPInvestmentOccurrenceIndex = 0;
        public int RPInvestmentLastOccurrenceIndex = 0;
        public string RPInvestmentIdentifier = null;
        public string RPInvestmentIdentifierScheme = null;
        public string RPInvestmentIdentifierTFN = null;
        public DateTime? RPInvestmentStartDate = null;
        public DateTime? RPInvestmentEndDate = null;

        /// <summary>
        /// RPInvestment:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS284 = null;

        /// <summary>
        /// RPInvestment:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS285 = null;

        public string RPLendingId = null;
        public bool RPLendingExists = false;
        public int RPLendingCount = 0;
        public int RPLendingOccurrenceIndex = 0;
        public int RPLendingLastOccurrenceIndex = 0;
        public string RPLendingIdentifier = null;
        public string RPLendingIdentifierScheme = null;
        public string RPLendingIdentifierTFN = null;
        public DateTime? RPLendingStartDate = null;
        public DateTime? RPLendingEndDate = null;

        /// <summary>
        /// RPLending:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS272 = null;

        /// <summary>
        /// RPLending:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS273 = null;

        public string RPOtherId = null;
        public bool RPOtherExists = false;
        public int RPOtherCount = 0;
        public int RPOtherOccurrenceIndex = 0;
        public int RPOtherLastOccurrenceIndex = 0;
        public string RPOtherIdentifier = null;
        public string RPOtherIdentifierScheme = null;
        public string RPOtherIdentifierTFN = null;
        public DateTime? RPOtherStartDate = null;
        public DateTime? RPOtherEndDate = null;

        /// <summary>
        /// RPOther:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS293 = null;

        /// <summary>
        /// RPOther:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS294 = null;

        public string RPTotalNetId = null;
        public bool RPTotalNetExists = false;
        public int RPTotalNetCount = 0;
        public int RPTotalNetOccurrenceIndex = 0;
        public int RPTotalNetLastOccurrenceIndex = 0;
        public string RPTotalNetIdentifier = null;
        public string RPTotalNetIdentifierScheme = null;
        public string RPTotalNetIdentifierTFN = null;
        public DateTime? RPTotalNetStartDate = null;
        public DateTime? RPTotalNetEndDate = null;

        /// <summary>
        /// RPTotalNet:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS303 = null;

        /// <summary>
        /// RPTotalNet:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS304 = null;

        public string RPTradingId = null;
        public bool RPTradingExists = false;
        public int RPTradingCount = 0;
        public int RPTradingOccurrenceIndex = 0;
        public int RPTradingLastOccurrenceIndex = 0;
        public string RPTradingIdentifier = null;
        public string RPTradingIdentifierScheme = null;
        public string RPTradingIdentifierTFN = null;
        public DateTime? RPTradingStartDate = null;
        public DateTime? RPTradingEndDate = null;

        /// <summary>
        /// RPTrading:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS278 = null;

        /// <summary>
        /// RPTrading:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS279 = null;

        public string RPLeasingId = null;
        public bool RPLeasingExists = false;
        public int RPLeasingCount = 0;
        public int RPLeasingOccurrenceIndex = 0;
        public int RPLeasingLastOccurrenceIndex = 0;
        public string RPLeasingIdentifier = null;
        public string RPLeasingIdentifierScheme = null;
        public string RPLeasingIdentifierTFN = null;
        public DateTime? RPLeasingStartDate = null;
        public DateTime? RPLeasingEndDate = null;

        /// <summary>
        /// RPLeasing:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS326 = null;

        /// <summary>
        /// RPLeasing:tns:FinancialServices.OffshoreBankingIncomeOrLossNet.Amount
        /// </summary>
        public decimal? IDS327 = null;

        public string RPCFCLCId = null;
        public bool RPCFCLCExists = false;
        public int RPCFCLCCount = 0;
        public int RPCFCLCOccurrenceIndex = 0;
        public int RPCFCLCLastOccurrenceIndex = 0;
        public string RPCFCLCIdentifier = null;
        public string RPCFCLCIdentifierScheme = null;
        public string RPCFCLCIdentifierTFN = null;
        public DateTime? RPCFCLCStartDate = null;
        public DateTime? RPCFCLCEndDate = null;

        /// <summary>
        /// RPCFCLC:tns:Miscellaneous.ControlledForeignCompaniesTrustsInterest.Count
        /// </summary>
        public decimal? IDS185 = null;

        /// <summary>
        /// RPCFCLC:tns:Miscellaneous.ControlledForeignCompanyTrustInterestAcquired.Count
        /// </summary>
        public decimal? IDS368 = null;

        /// <summary>
        /// RPCFCLC:tns:Miscellaneous.ControlledForeignCompanyTrustInterestDisposed.Count
        /// </summary>
        public decimal? IDS372 = null;

        /// <summary>
        /// RPCFCLC:tns:Miscellaneous.ControlledForeignCompaniesActiveIncomeTestSatisfied.Code
        /// </summary>
        public string IDS375 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.ControlledForeignCompaniesExcludedTaintedInterestIncome.Amount
        /// </summary>
        public decimal? IDS436 = null;

        /// <summary>
        /// RPCFCLC:tns:Miscellaneous.ControlledForeignCompanyExcludedTaintedInterestIncome.Count
        /// </summary>
        public decimal? IDS440 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.ControlledForeignCompaniesAttributableIncome.Amount
        /// </summary>
        public decimal? IDS188 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.GrossRevenueActiveIncomeTestSatisfied.Amount
        /// </summary>
        public decimal? IDS443 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.GrossRevenueActiveIncomeTestNotSatisfied.Amount
        /// </summary>
        public decimal? IDS447 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.ControlledForeignCompaniesAdjustedTaintedConcessionIncome.Amount
        /// </summary>
        public decimal? IDS378 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.ControlledForeignCompaniesAdjustedTaintedIncomeNotDerived.Amount
        /// </summary>
        public decimal? IDS379 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.ControlledForeignCompaniesOtherNotionalAssessableIncome.Amount
        /// </summary>
        public decimal? IDS380 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.ControlledForeignCompaniesNotionalAssessableIncomeTotal.Amount
        /// </summary>
        public decimal? IDS381 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.ControlledForeignCompaniesNotionalAllowableDeductions.Amount
        /// </summary>
        public decimal? IDS451 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.ForeignBranchProfitsOfAustralianCompaniesNonAssessableNonExemptIncome.Amount
        /// </summary>
        public decimal? IDS196 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.PaidOutOfAttributedControlledForeignCompanyIncomeNonAssessableNonExemptIncome.Amount
        /// </summary>
        public decimal? IDS200 = null;

        /// <summary>
        /// RPCFCLC:tns:Income.NonPortfolioDividendFromForeignCompanyNonAssessableNonExemptIncome.Amount
        /// </summary>
        public decimal? IDS320 = null;

        public string RPCFCSPId = null;
        public bool RPCFCSPExists = false;
        public int RPCFCSPCount = 0;
        public int RPCFCSPOccurrenceIndex = 0;
        public int RPCFCSPLastOccurrenceIndex = 0;
        public string RPCFCSPIdentifier = null;
        public string RPCFCSPIdentifierScheme = null;
        public string RPCFCSPIdentifierTFN = null;
        public DateTime? RPCFCSPStartDate = null;
        public DateTime? RPCFCSPEndDate = null;

        /// <summary>
        /// RPCFCSP:tns:Miscellaneous.ControlledForeignCompaniesTrustsInterest.Count
        /// </summary>
        public decimal? IDS186 = null;

        /// <summary>
        /// RPCFCSP:tns:Miscellaneous.ControlledForeignCompanyTrustInterestAcquired.Count
        /// </summary>
        public decimal? IDS369 = null;

        /// <summary>
        /// RPCFCSP:tns:Miscellaneous.ControlledForeignCompanyTrustInterestDisposed.Count
        /// </summary>
        public decimal? IDS373 = null;

        /// <summary>
        /// RPCFCSP:tns:Miscellaneous.ControlledForeignCompaniesActiveIncomeTestSatisfied.Code
        /// </summary>
        public string IDS376 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.ControlledForeignCompaniesExcludedTaintedInterestIncome.Amount
        /// </summary>
        public decimal? IDS437 = null;

        /// <summary>
        /// RPCFCSP:tns:Miscellaneous.ControlledForeignCompanyExcludedTaintedInterestIncome.Count
        /// </summary>
        public decimal? IDS441 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.ControlledForeignCompaniesAttributableIncome.Amount
        /// </summary>
        public decimal? IDS189 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.GrossRevenueActiveIncomeTestSatisfied.Amount
        /// </summary>
        public decimal? IDS444 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.GrossRevenueActiveIncomeTestNotSatisfied.Amount
        /// </summary>
        public decimal? IDS448 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.ControlledForeignCompaniesAdjustedTaintedIncome.Amount
        /// </summary>
        public decimal? IDS382 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.ControlledForeignCompaniesOtherNotionalAssessableIncome.Amount
        /// </summary>
        public decimal? IDS383 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.ControlledForeignCompaniesNotionalAssessableIncomeTotal.Amount
        /// </summary>
        public decimal? IDS384 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.ControlledForeignCompaniesNotionalAllowableDeductions.Amount
        /// </summary>
        public decimal? IDS452 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.ForeignBranchProfitsOfAustralianCompaniesNonAssessableNonExemptIncome.Amount
        /// </summary>
        public decimal? IDS197 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.PaidOutOfAttributedControlledForeignCompanyIncomeNonAssessableNonExemptIncome.Amount
        /// </summary>
        public decimal? IDS201 = null;

        /// <summary>
        /// RPCFCSP:tns:Income.NonPortfolioDividendFromForeignCompanyNonAssessableNonExemptIncome.Amount
        /// </summary>
        public decimal? IDS321 = null;

        public string RPCFCUCId = null;
        public bool RPCFCUCExists = false;
        public int RPCFCUCCount = 0;
        public int RPCFCUCOccurrenceIndex = 0;
        public int RPCFCUCLastOccurrenceIndex = 0;
        public string RPCFCUCIdentifier = null;
        public string RPCFCUCIdentifierScheme = null;
        public string RPCFCUCIdentifierTFN = null;
        public DateTime? RPCFCUCStartDate = null;
        public DateTime? RPCFCUCEndDate = null;

        /// <summary>
        /// RPCFCUC:tns:Miscellaneous.ControlledForeignCompaniesTrustsInterest.Count
        /// </summary>
        public decimal? IDS187 = null;

        /// <summary>
        /// RPCFCUC:tns:Miscellaneous.ControlledForeignCompanyTrustInterestAcquired.Count
        /// </summary>
        public decimal? IDS370 = null;

        /// <summary>
        /// RPCFCUC:tns:Miscellaneous.ControlledForeignCompanyTrustInterestDisposed.Count
        /// </summary>
        public decimal? IDS374 = null;

        /// <summary>
        /// RPCFCUC:tns:Miscellaneous.ControlledForeignCompaniesActiveIncomeTestSatisfied.Code
        /// </summary>
        public string IDS377 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.ControlledForeignCompaniesExcludedTaintedInterestIncome.Amount
        /// </summary>
        public decimal? IDS438 = null;

        /// <summary>
        /// RPCFCUC:tns:Miscellaneous.ControlledForeignCompanyExcludedTaintedInterestIncome.Count
        /// </summary>
        public decimal? IDS442 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.ControlledForeignCompaniesAttributableIncome.Amount
        /// </summary>
        public decimal? IDS190 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.GrossRevenueActiveIncomeTestSatisfied.Amount
        /// </summary>
        public decimal? IDS445 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.GrossRevenueActiveIncomeTestNotSatisfied.Amount
        /// </summary>
        public decimal? IDS449 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.ControlledForeignCompaniesAdjustedTaintedIncome.Amount
        /// </summary>
        public decimal? IDS385 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.ControlledForeignCompaniesOtherNotionalAssessableIncome.Amount
        /// </summary>
        public decimal? IDS386 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.ControlledForeignCompaniesNotionalAssessableIncomeTotal.Amount
        /// </summary>
        public decimal? IDS387 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.ControlledForeignCompaniesNotionalAllowableDeductions.Amount
        /// </summary>
        public decimal? IDS453 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.ForeignBranchProfitsOfAustralianCompaniesNonAssessableNonExemptIncome.Amount
        /// </summary>
        public decimal? IDS198 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.PaidOutOfAttributedControlledForeignCompanyIncomeNonAssessableNonExemptIncome.Amount
        /// </summary>
        public decimal? IDS202 = null;

        /// <summary>
        /// RPCFCUC:tns:Income.NonPortfolioDividendFromForeignCompanyNonAssessableNonExemptIncome.Amount
        /// </summary>
        public decimal? IDS322 = null;
        public List<RPRestructuringEventContext> RPRestructuringEventContextCollection = null;
        public class RPRestructuringEventContext
        {
    
            public string Id = null;
            public bool Exists = false;
            public int Count = 0;
            public int OccurrenceIndex = 0;
            public int LastOccurrenceIndex = 0;
            public string Identifier = null;
            public string IdentifierScheme = null;
            public string IdentifierTFN = null;
            public DateTime? StartDate = null;
            public DateTime? EndDate = null;

            public string RestructuringEventDimensionValue = null;
    
            /// <summary>
            /// RPRestructuringEvent:tns:InternationalDealings.Description.Text
            /// </summary>
            public string IDS157 = null;
    
            /// <summary>
            /// RPRestructuringEvent:tns:OrganisationDetails.RestructuringEventEntity.Code
            /// </summary>
            public string IDS152 = null;
    
            /// <summary>
            /// RPRestructuringEvent:tns:Miscellaneous.CapitalValue.Code
            /// </summary>
            public string IDS153 = null;
    
            /// <summary>
            /// RPRestructuringEvent:tns:Miscellaneous.NatureOfItem.Code
            /// </summary>
            public string IDS154 = null;
    
            /// <summary>
            /// RPRestructuringEvent:tns:OrganisationDetails.InternationalRelatedPartyCountry.Code
            /// </summary>
            public string IDS155 = null;
    
            /// <summary>
            /// RPRestructuringEvent:tns:Miscellaneous.PercentageOfDealingsWithDocumentation.Code
            /// </summary>
            public string IDS156 = null;
    
            /// <summary>
            /// RPRestructuringEvent:tns:InternationalDealings.EventAnalysis.Indicator
            /// </summary>
            public bool? IDS158 = null;
        }

        public string RPDTAId = null;
        public bool RPDTAExists = false;
        public int RPDTACount = 0;
        public int RPDTAOccurrenceIndex = 0;
        public int RPDTALastOccurrenceIndex = 0;
        public string RPDTAIdentifier = null;
        public string RPDTAIdentifierScheme = null;
        public string RPDTAIdentifierTFN = null;
        public DateTime? RPDTAStartDate = null;
        public DateTime? RPDTAEndDate = null;

        /// <summary>
        /// RPDTA:tns:InternationalDealings.WithholdingTaxExemptNonResidentInterestPaid.Indicator
        /// </summary>
        public bool? IDS315 = null;

        /// <summary>
        /// RPDTA:tns:InternationalDealings.WithholdingTaxExemptNonResidentInterestPaid.Amount
        /// </summary>
        public decimal? IDS316 = null;

        public string RPs128FId = null;
        public bool RPs128FExists = false;
        public int RPs128FCount = 0;
        public int RPs128FOccurrenceIndex = 0;
        public int RPs128FLastOccurrenceIndex = 0;
        public string RPs128FIdentifier = null;
        public string RPs128FIdentifierScheme = null;
        public string RPs128FIdentifierTFN = null;
        public DateTime? RPs128FStartDate = null;
        public DateTime? RPs128FEndDate = null;

        /// <summary>
        /// RPs128F:tns:InternationalDealings.WithholdingTaxExemptNonResidentInterestPaid.Amount
        /// </summary>
        public decimal? IDS318 = null;

        public string RPs128FAId = null;
        public bool RPs128FAExists = false;
        public int RPs128FACount = 0;
        public int RPs128FAOccurrenceIndex = 0;
        public int RPs128FALastOccurrenceIndex = 0;
        public string RPs128FAIdentifier = null;
        public string RPs128FAIdentifierScheme = null;
        public string RPs128FAIdentifierTFN = null;
        public DateTime? RPs128FAStartDate = null;
        public DateTime? RPs128FAEndDate = null;

        /// <summary>
        /// RPs128FA:tns:InternationalDealings.WithholdingTaxExemptNonResidentInterestPaid.Amount
        /// </summary>
        public decimal? IDS319 = null;

        public string RPAdvisoryRelatedPartyId = null;
        public bool RPAdvisoryRelatedPartyExists = false;
        public int RPAdvisoryRelatedPartyCount = 0;
        public int RPAdvisoryRelatedPartyOccurrenceIndex = 0;
        public int RPAdvisoryRelatedPartyLastOccurrenceIndex = 0;
        public string RPAdvisoryRelatedPartyIdentifier = null;
        public string RPAdvisoryRelatedPartyIdentifierScheme = null;
        public string RPAdvisoryRelatedPartyIdentifierTFN = null;
        public DateTime? RPAdvisoryRelatedPartyStartDate = null;
        public DateTime? RPAdvisoryRelatedPartyEndDate = null;

        /// <summary>
        /// RPAdvisoryRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS289 = null;

        public string RPBorrowingRelatedPartyId = null;
        public bool RPBorrowingRelatedPartyExists = false;
        public int RPBorrowingRelatedPartyCount = 0;
        public int RPBorrowingRelatedPartyOccurrenceIndex = 0;
        public int RPBorrowingRelatedPartyLastOccurrenceIndex = 0;
        public string RPBorrowingRelatedPartyIdentifier = null;
        public string RPBorrowingRelatedPartyIdentifierScheme = null;
        public string RPBorrowingRelatedPartyIdentifierTFN = null;
        public DateTime? RPBorrowingRelatedPartyStartDate = null;
        public DateTime? RPBorrowingRelatedPartyEndDate = null;

        /// <summary>
        /// RPBorrowingRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS271 = null;

        public string RPEligibleContractRelatedPartyId = null;
        public bool RPEligibleContractRelatedPartyExists = false;
        public int RPEligibleContractRelatedPartyCount = 0;
        public int RPEligibleContractRelatedPartyOccurrenceIndex = 0;
        public int RPEligibleContractRelatedPartyLastOccurrenceIndex = 0;
        public string RPEligibleContractRelatedPartyIdentifier = null;
        public string RPEligibleContractRelatedPartyIdentifierScheme = null;
        public string RPEligibleContractRelatedPartyIdentifierTFN = null;
        public DateTime? RPEligibleContractRelatedPartyStartDate = null;
        public DateTime? RPEligibleContractRelatedPartyEndDate = null;

        /// <summary>
        /// RPEligibleContractRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS283 = null;

        public string RPGuaranteeTypeRelatedPartyId = null;
        public bool RPGuaranteeTypeRelatedPartyExists = false;
        public int RPGuaranteeTypeRelatedPartyCount = 0;
        public int RPGuaranteeTypeRelatedPartyOccurrenceIndex = 0;
        public int RPGuaranteeTypeRelatedPartyLastOccurrenceIndex = 0;
        public string RPGuaranteeTypeRelatedPartyIdentifier = null;
        public string RPGuaranteeTypeRelatedPartyIdentifierScheme = null;
        public string RPGuaranteeTypeRelatedPartyIdentifierTFN = null;
        public DateTime? RPGuaranteeTypeRelatedPartyStartDate = null;
        public DateTime? RPGuaranteeTypeRelatedPartyEndDate = null;

        /// <summary>
        /// RPGuaranteeTypeRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS277 = null;

        public string RPHedgingRelatedPartyId = null;
        public bool RPHedgingRelatedPartyExists = false;
        public int RPHedgingRelatedPartyCount = 0;
        public int RPHedgingRelatedPartyOccurrenceIndex = 0;
        public int RPHedgingRelatedPartyLastOccurrenceIndex = 0;
        public string RPHedgingRelatedPartyIdentifier = null;
        public string RPHedgingRelatedPartyIdentifierScheme = null;
        public string RPHedgingRelatedPartyIdentifierTFN = null;
        public DateTime? RPHedgingRelatedPartyStartDate = null;
        public DateTime? RPHedgingRelatedPartyEndDate = null;

        /// <summary>
        /// RPHedgingRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS292 = null;

        public string RPInvestmentRelatedPartyId = null;
        public bool RPInvestmentRelatedPartyExists = false;
        public int RPInvestmentRelatedPartyCount = 0;
        public int RPInvestmentRelatedPartyOccurrenceIndex = 0;
        public int RPInvestmentRelatedPartyLastOccurrenceIndex = 0;
        public string RPInvestmentRelatedPartyIdentifier = null;
        public string RPInvestmentRelatedPartyIdentifierScheme = null;
        public string RPInvestmentRelatedPartyIdentifierTFN = null;
        public DateTime? RPInvestmentRelatedPartyStartDate = null;
        public DateTime? RPInvestmentRelatedPartyEndDate = null;

        /// <summary>
        /// RPInvestmentRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS286 = null;

        public string RPLendingRelatedPartyId = null;
        public bool RPLendingRelatedPartyExists = false;
        public int RPLendingRelatedPartyCount = 0;
        public int RPLendingRelatedPartyOccurrenceIndex = 0;
        public int RPLendingRelatedPartyLastOccurrenceIndex = 0;
        public string RPLendingRelatedPartyIdentifier = null;
        public string RPLendingRelatedPartyIdentifierScheme = null;
        public string RPLendingRelatedPartyIdentifierTFN = null;
        public DateTime? RPLendingRelatedPartyStartDate = null;
        public DateTime? RPLendingRelatedPartyEndDate = null;

        /// <summary>
        /// RPLendingRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS274 = null;

        public string RPOtherRelatedPartyId = null;
        public bool RPOtherRelatedPartyExists = false;
        public int RPOtherRelatedPartyCount = 0;
        public int RPOtherRelatedPartyOccurrenceIndex = 0;
        public int RPOtherRelatedPartyLastOccurrenceIndex = 0;
        public string RPOtherRelatedPartyIdentifier = null;
        public string RPOtherRelatedPartyIdentifierScheme = null;
        public string RPOtherRelatedPartyIdentifierTFN = null;
        public DateTime? RPOtherRelatedPartyStartDate = null;
        public DateTime? RPOtherRelatedPartyEndDate = null;

        /// <summary>
        /// RPOtherRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS295 = null;

        public string RPTotalNetRelatedPartyId = null;
        public bool RPTotalNetRelatedPartyExists = false;
        public int RPTotalNetRelatedPartyCount = 0;
        public int RPTotalNetRelatedPartyOccurrenceIndex = 0;
        public int RPTotalNetRelatedPartyLastOccurrenceIndex = 0;
        public string RPTotalNetRelatedPartyIdentifier = null;
        public string RPTotalNetRelatedPartyIdentifierScheme = null;
        public string RPTotalNetRelatedPartyIdentifierTFN = null;
        public DateTime? RPTotalNetRelatedPartyStartDate = null;
        public DateTime? RPTotalNetRelatedPartyEndDate = null;

        /// <summary>
        /// RPTotalNetRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS305 = null;

        public string RPTradingRelatedPartyId = null;
        public bool RPTradingRelatedPartyExists = false;
        public int RPTradingRelatedPartyCount = 0;
        public int RPTradingRelatedPartyOccurrenceIndex = 0;
        public int RPTradingRelatedPartyLastOccurrenceIndex = 0;
        public string RPTradingRelatedPartyIdentifier = null;
        public string RPTradingRelatedPartyIdentifierScheme = null;
        public string RPTradingRelatedPartyIdentifierTFN = null;
        public DateTime? RPTradingRelatedPartyStartDate = null;
        public DateTime? RPTradingRelatedPartyEndDate = null;

        /// <summary>
        /// RPTradingRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS280 = null;

        public string RPLeasingRelatedPartyId = null;
        public bool RPLeasingRelatedPartyExists = false;
        public int RPLeasingRelatedPartyCount = 0;
        public int RPLeasingRelatedPartyOccurrenceIndex = 0;
        public int RPLeasingRelatedPartyLastOccurrenceIndex = 0;
        public string RPLeasingRelatedPartyIdentifier = null;
        public string RPLeasingRelatedPartyIdentifierScheme = null;
        public string RPLeasingRelatedPartyIdentifierTFN = null;
        public DateTime? RPLeasingRelatedPartyStartDate = null;
        public DateTime? RPLeasingRelatedPartyEndDate = null;

        /// <summary>
        /// RPLeasingRelatedParty:tns:FinancialServices.OffshoreBankingIncomeAssessable.Amount
        /// </summary>
        public decimal? IDS328 = null;
        public List<RPBranchOperationsInternallyRecordedDealingsContext> RPBranchOperationsInternallyRecordedDealingsContextCollection = null;
        public class RPBranchOperationsInternallyRecordedDealingsContext
        {
    
            public string Id = null;
            public bool Exists = false;
            public int Count = 0;
            public int OccurrenceIndex = 0;
            public int LastOccurrenceIndex = 0;
            public string Identifier = null;
            public string IdentifierScheme = null;
            public string IdentifierTFN = null;
            public DateTime? StartDate = null;
            public DateTime? EndDate = null;

            public string InternallyRecordedDealingsDimensionValue = null;
    
            /// <summary>
            /// RPBranchOperationsInternallyRecordedDealings:tns:Income.Other.Description
            /// </summary>
            public string IDS171 = null;
    
            /// <summary>
            /// RPBranchOperationsInternallyRecordedDealings:tns:Miscellaneous.InternallyRecordedDealingsAmountsClaimedTotal.Amount
            /// </summary>
            public decimal? IDS169 = null;
    
            /// <summary>
            /// RPBranchOperationsInternallyRecordedDealings:tns:Miscellaneous.InternallyRecordedDealingsAmountsReturnedTotal.Amount
            /// </summary>
            public decimal? IDS170 = null;
        }

        public string RPBranchOperationsInterestFreeId = null;
        public bool RPBranchOperationsInterestFreeExists = false;
        public int RPBranchOperationsInterestFreeCount = 0;
        public int RPBranchOperationsInterestFreeOccurrenceIndex = 0;
        public int RPBranchOperationsInterestFreeLastOccurrenceIndex = 0;
        public string RPBranchOperationsInterestFreeIdentifier = null;
        public string RPBranchOperationsInterestFreeIdentifierScheme = null;
        public string RPBranchOperationsInterestFreeIdentifierTFN = null;
        public DateTime? RPBranchOperationsInterestFreeStartDate = null;
        public DateTime? RPBranchOperationsInterestFreeEndDate = null;

        /// <summary>
        /// RPBranchOperationsInterestFree:tns:Liabilities.BorrowedAverageBalance.Amount
        /// </summary>
        public decimal? IDS165 = null;

        /// <summary>
        /// RPBranchOperationsInterestFree:tns:Assets.LoanedAverageBalance.Amount
        /// </summary>
        public decimal? IDS166 = null;

        public string RPBranchOperationsInterestBearingId = null;
        public bool RPBranchOperationsInterestBearingExists = false;
        public int RPBranchOperationsInterestBearingCount = 0;
        public int RPBranchOperationsInterestBearingOccurrenceIndex = 0;
        public int RPBranchOperationsInterestBearingLastOccurrenceIndex = 0;
        public string RPBranchOperationsInterestBearingIdentifier = null;
        public string RPBranchOperationsInterestBearingIdentifierScheme = null;
        public string RPBranchOperationsInterestBearingIdentifierTFN = null;
        public DateTime? RPBranchOperationsInterestBearingStartDate = null;
        public DateTime? RPBranchOperationsInterestBearingEndDate = null;

        /// <summary>
        /// RPBranchOperationsInterestBearing:tns:Liabilities.BorrowedAverageBalance.Amount
        /// </summary>
        public decimal? IDS161 = null;

        /// <summary>
        /// RPBranchOperationsInterestBearing:tns:Assets.LoanedAverageBalance.Amount
        /// </summary>
        public decimal? IDS162 = null;

        /// <summary>
        /// RPBranchOperationsInterestBearing:tns:Expense.InterestBorrowedTotal.Amount
        /// </summary>
        public decimal? IDS163 = null;

        /// <summary>
        /// RPBranchOperationsInterestBearing:tns:Income.InterestLoanedTotal.Amount
        /// </summary>
        public decimal? IDS164 = null;

        public string RPOtherFinancialDealingsInterestFreeId = null;
        public bool RPOtherFinancialDealingsInterestFreeExists = false;
        public int RPOtherFinancialDealingsInterestFreeCount = 0;
        public int RPOtherFinancialDealingsInterestFreeOccurrenceIndex = 0;
        public int RPOtherFinancialDealingsInterestFreeLastOccurrenceIndex = 0;
        public string RPOtherFinancialDealingsInterestFreeIdentifier = null;
        public string RPOtherFinancialDealingsInterestFreeIdentifierScheme = null;
        public string RPOtherFinancialDealingsInterestFreeIdentifierTFN = null;
        public DateTime? RPOtherFinancialDealingsInterestFreeStartDate = null;
        public DateTime? RPOtherFinancialDealingsInterestFreeEndDate = null;

        /// <summary>
        /// RPOtherFinancialDealingsInterestFree:tns:Liabilities.BorrowedAverageBalance.Amount
        /// </summary>
        public decimal? IDS99 = null;

        /// <summary>
        /// RPOtherFinancialDealingsInterestFree:tns:Assets.LoanedAverageBalance.Amount
        /// </summary>
        public decimal? IDS101 = null;

        public string RPOtherFinancialDealingsInterestBearingId = null;
        public bool RPOtherFinancialDealingsInterestBearingExists = false;
        public int RPOtherFinancialDealingsInterestBearingCount = 0;
        public int RPOtherFinancialDealingsInterestBearingOccurrenceIndex = 0;
        public int RPOtherFinancialDealingsInterestBearingLastOccurrenceIndex = 0;
        public string RPOtherFinancialDealingsInterestBearingIdentifier = null;
        public string RPOtherFinancialDealingsInterestBearingIdentifierScheme = null;
        public string RPOtherFinancialDealingsInterestBearingIdentifierTFN = null;
        public DateTime? RPOtherFinancialDealingsInterestBearingStartDate = null;
        public DateTime? RPOtherFinancialDealingsInterestBearingEndDate = null;

        /// <summary>
        /// RPOtherFinancialDealingsInterestBearing:tns:Liabilities.BorrowedAverageBalance.Amount
        /// </summary>
        public decimal? IDS98 = null;

        /// <summary>
        /// RPOtherFinancialDealingsInterestBearing:tns:Assets.LoanedAverageBalance.Amount
        /// </summary>
        public decimal? IDS100 = null;

        public string RPForeignHubsId = null;
        public bool RPForeignHubsExists = false;
        public int RPForeignHubsCount = 0;
        public int RPForeignHubsOccurrenceIndex = 0;
        public int RPForeignHubsLastOccurrenceIndex = 0;
        public string RPForeignHubsIdentifier = null;
        public string RPForeignHubsIdentifierScheme = null;
        public string RPForeignHubsIdentifierTFN = null;
        public DateTime? RPForeignHubsStartDate = null;
        public DateTime? RPForeignHubsEndDate = null;
    
        public bool HubArrangementCollectionExists = false;
        public int HubArrangementCollectionCount = 0;

        public List<HubArrangement> HubArrangementCollection = null;

        public class HubArrangement 
        {
            public int OccurrenceIndex = 0;
    
            /// <summary>
            /// /xbrli:xbrl/tns:HubArrangement
            /// RPForeignHubs:tns:Miscellaneous.HubArrangement.Code
            /// </summary>
            public string IDS394 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:HubArrangement
            /// RPForeignHubs:tns:Expense.HubArrangementImports.Amount
            /// </summary>
            public decimal? IDS395 = null;
    
            /// <summary>
            /// /xbrli:xbrl/tns:HubArrangement
            /// RPForeignHubs:tns:Revenue.HubArrangementExports.Amount
            /// </summary>
            public decimal? IDS396 = null;
        }

        public string RPHybridInstrumentsId = null;
        public bool RPHybridInstrumentsExists = false;
        public int RPHybridInstrumentsCount = 0;
        public int RPHybridInstrumentsOccurrenceIndex = 0;
        public int RPHybridInstrumentsLastOccurrenceIndex = 0;
        public string RPHybridInstrumentsIdentifier = null;
        public string RPHybridInstrumentsIdentifierScheme = null;
        public string RPHybridInstrumentsIdentifierTFN = null;
        public DateTime? RPHybridInstrumentsStartDate = null;
        public DateTime? RPHybridInstrumentsEndDate = null;

        /// <summary>
        /// RPHybridInstruments:tns:Miscellaneous.HybridMismatchDeductions.Amount
        /// </summary>
        public decimal? IDS483 = null;

        public string RPTOFAId = null;
        public bool RPTOFAExists = false;
        public int RPTOFACount = 0;
        public int RPTOFAOccurrenceIndex = 0;
        public int RPTOFALastOccurrenceIndex = 0;
        public string RPTOFAIdentifier = null;
        public string RPTOFAIdentifierScheme = null;
        public string RPTOFAIdentifierTFN = null;
        public DateTime? RPTOFAStartDate = null;
        public DateTime? RPTOFAEndDate = null;

        /// <summary>
        /// RPTOFA:tns:InternationalDealings.TaxationOfFinancialArrangementsTotalValue.Amount
        /// </summary>
        public decimal? IDS430 = null;

        /// <summary>
        /// RPTOFA:tns:InternationalDealings.TaxationOfFinancialArrangementsTotalGains.Amount
        /// </summary>
        public decimal? IDS431 = null;

        /// <summary>
        /// RPTOFA:tns:InternationalDealings.TaxationOfFinancialArrangementsTotalLosses.Amount
        /// </summary>
        public decimal? IDS432 = null;

    }
}
