using System;
using System.Collections.Generic;

namespace Ato.EN.IntegrationServices.CodeGenerationRDTIS
{
    public class RDTIS2022
    {

    public bool RpCollectionExists = false;
    public int RpCollectionCount = 0;
    
    /// <summary>
    /// /xbrli:xbrl/:RP
    /// RDTIS:pyin.02.28:Report.Amendment.Indicator
    /// </summary>
    public bool? RDTIS1 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP
    /// RDTIS:pyid.02.00:Identifiers.TaxFileNumber.Identifier
    /// </summary>
    public string RDTIS70 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP
    /// RDTIS:pyin.02.00:Period.Start.Date
    /// </summary>
    public DateTime? RDTIS71 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP
    /// RDTIS:pyin.02.00:Period.End.Date
    /// </summary>
    public DateTime? RDTIS72 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP
    /// RDTIS:pyid.02.25:Identifiers.InnovationRegistrationNumber.Identifier
    /// </summary>
    public string RDTIS2 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.ResearchAndDevelopmentAccountingExpenditureAddBack.Amount
    /// </summary>
    public decimal? RDTIS3 = null;

    public bool RP_NotionalDeductionsCalculationCollectionExists = false;
    public int RP_NotionalDeductionsCalculationCollectionCount = 0;

    public bool RP_NotionalDeductionsCalculation_AustralianOwnedCollectionExists = false;
    public int RP_NotionalDeductionsCalculation_AustralianOwnedCollectionCount = 0;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:AustralianOwned
    /// RDTIS:bafpr3.02.09:Expense.ResearchAndDevelopment.ContractedExpenditureResearchServiceProvider.Amount
    /// </summary>
    public decimal? RDTIS4 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:AustralianOwned
    /// RDTIS:bafpr3.02.09:Expense.ResearchAndDevelopment.ContractedExpenditureNonResearchServiceProvider.Amount
    /// </summary>
    public decimal? RDTIS6 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:AustralianOwned
    /// RDTIS:lrla.02.12:Remuneration.WagesAndSalaries.Salary.Amount
    /// </summary>
    public decimal? RDTIS8 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:AustralianOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.OtherExpenditureRegisteredResearchAgency.Amount
    /// </summary>
    public decimal? RDTIS10 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:AustralianOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.Feedstock.Amount
    /// </summary>
    public decimal? RDTIS12 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:AustralianOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.AssociatesExpenditure.Amount
    /// </summary>
    public decimal? RDTIS14 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:AustralianOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.DeclineInValuePlantAndDepreciatingAssets.Amount
    /// </summary>
    public decimal? RDTIS16 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:AustralianOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.BalancingLosses.Amount
    /// </summary>
    public decimal? RDTIS18 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:AustralianOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.CooperativeResearchCentreContributions.Amount
    /// </summary>
    public decimal? RDTIS20 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:AustralianOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.AllocatedTotal.Amount
    /// </summary>
    public decimal? RDTIS22 = null;

    public bool RP_NotionalDeductionsCalculation_ForeignOwnedCollectionExists = false;
    public int RP_NotionalDeductionsCalculation_ForeignOwnedCollectionCount = 0;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:ForeignOwned
    /// RDTIS:bafpr3.02.09:Expense.ResearchAndDevelopment.ContractedExpenditureResearchServiceProvider.Amount
    /// </summary>
    public decimal? RDTIS5 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:ForeignOwned
    /// RDTIS:bafpr3.02.09:Expense.ResearchAndDevelopment.ContractedExpenditureNonResearchServiceProvider.Amount
    /// </summary>
    public decimal? RDTIS7 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:ForeignOwned
    /// RDTIS:lrla.02.12:Remuneration.WagesAndSalaries.Salary.Amount
    /// </summary>
    public decimal? RDTIS9 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:ForeignOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.OtherExpenditureRegisteredResearchAgency.Amount
    /// </summary>
    public decimal? RDTIS11 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:ForeignOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.Feedstock.Amount
    /// </summary>
    public decimal? RDTIS13 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:ForeignOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.AssociatesExpenditure.Amount
    /// </summary>
    public decimal? RDTIS15 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:ForeignOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.DeclineInValuePlantAndDepreciatingAssets.Amount
    /// </summary>
    public decimal? RDTIS17 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:ForeignOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.BalancingLosses.Amount
    /// </summary>
    public decimal? RDTIS19 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:ForeignOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.CooperativeResearchCentreContributions.Amount
    /// </summary>
    public decimal? RDTIS21 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation/:ForeignOwned
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.AllocatedTotal.Amount
    /// </summary>
    public decimal? RDTIS23 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NotionalDeductionsCalculation
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.AllocatedTotal.Amount
    /// </summary>
    public decimal? RDTIS24 = null;

    public bool RP_FeedstockCollectionExists = false;
    public int RP_FeedstockCollectionCount = 0;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:Feedstock
    /// RDTIS:bafpr3.02.08:Income.ResearchAndDevelopment.FeedstockRevenueTotal.Amount
    /// </summary>
    public decimal? RDTIS25 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:Feedstock
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.FeedstockInput.Amount
    /// </summary>
    public decimal? RDTIS26 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:Feedstock
    /// RDTIS:bafpr3.02.08:Income.ResearchAndDevelopment.FeedstockNet.Amount
    /// </summary>
    public decimal? RDTIS27 = null;

    public bool RP_ClawbackCollectionExists = false;
    public int RP_ClawbackCollectionCount = 0;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:Clawback
    /// RDTIS:gfagg.02.03:ResearchAndDevelopment.GovernmentGrantsAndRecoupments.Amount
    /// </summary>
    public decimal? RDTIS28 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:Clawback
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.RecoupmentRelated.Amount
    /// </summary>
    public decimal? RDTIS29 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:Clawback
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.GrantRelated.Amount
    /// </summary>
    public decimal? RDTIS30 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:Clawback
    /// RDTIS:gfagc.02.04:TaxConcession.ResearchAndDevelopment.GovernmentGrantsRecoupmentsClawback.Amount
    /// </summary>
    public decimal? RDTIS31 = null;

    public bool RP_ExpenditureToAssociatesCollectionExists = false;
    public int RP_ExpenditureToAssociatesCollectionCount = 0;

    public bool RP_ExpenditureToAssociates_IncurredOrPaidCollectionExists = false;
    public int RP_ExpenditureToAssociates_IncurredOrPaidCollectionCount = 0;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:ExpenditureToAssociates/:IncurredOrPaid
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.AssociatesCarriedForward.Amount
    /// </summary>
    public decimal? RDTIS51 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:ExpenditureToAssociates/:IncurredOrPaid
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.AssociatesUnpaid.Amount
    /// </summary>
    public decimal? RDTIS32 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:ExpenditureToAssociates/:IncurredOrPaid
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.AssociatesClaimed.Amount
    /// </summary>
    public decimal? RDTIS33 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:ExpenditureToAssociates/:IncurredOrPaid
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.AssociatesNotClaimed.Amount
    /// </summary>
    public decimal? RDTIS34 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:ExpenditureToAssociates
    /// RDTIS:bafpr3.02.08:Expense.ResearchAndDevelopment.AssociatesCarriedForward.Amount
    /// </summary>
    public decimal? RDTIS35 = null;

    public bool RP_TaxOffsetCalculationCollectionExists = false;
    public int RP_TaxOffsetCalculationCollectionCount = 0;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:TaxOffsetCalculation
    /// RDTIS:gfagc.02.04:TaxConcession.ExemptEntityOwnership.Indicator
    /// </summary>
    public bool? RDTIS36 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:TaxOffsetCalculation
    /// RDTIS:gfagc.02.04:TaxConcession.AggregatedTurnoverAtOrAboveThreshold.Indicator
    /// </summary>
    public bool? RDTIS37 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:TaxOffsetCalculation
    /// RDTIS:gfagc.02.04:TaxConcession.ResearchAndDevelopment.TaxOffsetEntityTurnover.Amount
    /// </summary>
    public decimal? RDTIS38 = null;

    public bool RP_TaxOffsetCalculation_GroupMemberCollectionExists = false;
    public int RP_TaxOffsetCalculation_GroupMemberCollectionCount = 0;
    
    public List<RP_TaxOffsetCalculation_GroupMember> RP_TaxOffsetCalculation_GroupMemberCollection = null;
    
    public class RP_TaxOffsetCalculation_GroupMember 
    {
        public int OccurrenceIndex = 0;

        /// <summary>
        /// /xbrli:xbrl/:RP/:TaxOffsetCalculation/:GroupMember
        /// RDTIS:pyde.02.00:OrganisationNameDetails.OrganisationalName.Text
        /// </summary>
        public string RDTIS41 = null;

        /// <summary>
        /// /xbrli:xbrl/:RP/:TaxOffsetCalculation/:GroupMember
        /// RDTIS:pyid.02.00:Identifiers.TaxFileNumber.Identifier
        /// </summary>
        public string RDTIS60 = null;

        /// <summary>
        /// /xbrli:xbrl/:RP/:TaxOffsetCalculation/:GroupMember
        /// RDTIS:gfagc.02.04:TaxConcession.ResearchAndDevelopment.TaxOffsetEntityTurnover.Amount
        /// </summary>
        public decimal? RDTIS42 = null;
    }
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:TaxOffsetCalculation
    /// RDTIS:gfagc.02.07:TaxConcession.ResearchAndDevelopment.TaxOffsetAdditionalEntitiesTurnover.Amount
    /// </summary>
    public decimal? RDTIS52 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:TaxOffsetCalculation
    /// RDTIS:gfagc.02.05:TaxConcession.ResearchAndDevelopment.TaxOffsetTurnoverExclusion.Amount
    /// </summary>
    public decimal? RDTIS43 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:TaxOffsetCalculation
    /// RDTIS:gfagc.02.04:TaxConcession.ResearchAndDevelopment.TaxOffsetTurnoverTotal.Amount
    /// </summary>
    public decimal? RDTIS44 = null;

    public bool RP_RefundableTaxOffsetCollectionExists = false;
    public int RP_RefundableTaxOffsetCollectionCount = 0;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:RefundableTaxOffset
    /// RDTIS:gfagc.02.04:TaxConcession.ResearchAndDevelopment.TaxOffsetNotionalRefundable.Amount
    /// </summary>
    public decimal? RDTIS45 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:RefundableTaxOffset
    /// RDTIS:gfagc.02.04:TaxConcession.ResearchAndDevelopment.TaxOffsetRefundable.Amount
    /// </summary>
    public decimal? RDTIS46 = null;

    public bool RP_NonRefundableTaxOffsetCollectionExists = false;
    public int RP_NonRefundableTaxOffsetCollectionCount = 0;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NonRefundableTaxOffset
    /// RDTIS:gfagc.02.04:TaxConcession.ResearchAndDevelopment.TaxOffsetNotionalNonRefundable.Amount
    /// </summary>
    public decimal? RDTIS47 = null;
    
    /// <summary>
    /// /xbrli:xbrl/:RP/:NonRefundableTaxOffset
    /// RDTIS:gfagc.02.04:TaxConcession.ResearchAndDevelopment.TaxOffsetNonRefundable.Amount
    /// </summary>
    public decimal? RDTIS48 = null;

    }
}
