// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2022-02-11T16:21:16, by ESR Version 2.4.47.0 using ESR Database SWS_EA_ESR_Cloud_Prod
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using Ato.EN.IntegrationServices.Core.Consumers.XBRLConsumption;
using System.Linq;
using System.Xml;
using System.Text.RegularExpressions;
using Ato.EN.IntegrationServices.Document.DataContracts;

namespace Ato.EN.IntegrationServices.CodeGenerationTRT
{
    public class TRT2022Consumer
    {

        private static Regex StripWhitespace = new Regex(@"\s*");

        #region Helper/Validation Methods
        private static bool? ToBoolean(string str)
        {
            bool returnValue;
            string value = (str ?? "").Trim();
            if (value == "0" || value == "1")
                return Convert.ToBoolean(Convert.ToInt32(value));
            
            if (Boolean.TryParse(value, out returnValue))
                return returnValue;
            return null;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString().ToLower() : string.Empty;
        }

        private static string GetValueOrEmptyDate(DateTime? val)
        {
            return (val.HasValue) ? val.Value.ToString("yyyy-MM-dd") : string.Empty;
        }

        private static string GetValueOrEmptyDateTime(DateTime? val)
        {
            return (val.HasValue) ? val.Value.ToString("yyyy-MM-ddTHH:mm:ssZ") : string.Empty;
        }
				
        private static string GetValueOrEmptyDate(string val)
        {
            DateTime dateTimeOut;
            if (DateTime.TryParse(val, out dateTimeOut))
            {
                return dateTimeOut.ToString("yyyy-MM-dd");
            }
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmptyDateTime(string val)
        {
            DateTime dateTimeOut;
            if (DateTime.TryParse(val, out dateTimeOut))
            {
                return dateTimeOut.ToString("yyyy-MM-ddTHH:mm:ssZ");
            }
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmpty(string val)
        {
            return !string.IsNullOrWhiteSpace(val) ? val : string.Empty;
        }

        private static string GetValueOrEmpty(decimal? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(int? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        /// <summary>
        /// Derives the SBR element location.
        /// </summary>
        /// <param name="sbrElement">The SBR element.</param>
        /// <param name="addOccurrenceIndex">if set to <c>true</c> [add occurrence the occurrence index to the path].</param>
        /// <returns></returns>
        private static string DeriveSbrElementLocation(SBRElement sbrElement, bool addOccurrenceIndex = false)
        {
            if (sbrElement == null) return "/xbrli:xbrl";
            int xpathOccurrence = sbrElement.OccurrenceIndex + 1;
            string location;

            if (addOccurrenceIndex)
            {
                location = "/" + sbrElement.NamespacePrefix + ":" + sbrElement.Name + "[" +
                           xpathOccurrence + "]";
            }
            else
            {
                location = "/" + sbrElement.NamespacePrefix + ":" + sbrElement.Name;
            }

            if (sbrElement.IsInTuple)
            {
                location = DeriveSbrElementLocation(sbrElement.ParentTuple, true) + location;
            }
            else
            {
                location = "/xbrli:xbrl" + location;
            }

            return location;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }

         #endregion

        public TRT2022 Consume(SBRDocument sbrDocument)
        {
            List<ProcessMessageDocument> errors;
            return Consume(sbrDocument, false, out errors);
        }

        /// <summary>
        /// Allows for validation of rules that can not be generated and must run at a lower level.
        /// A sub-class will need to be created with an override for this method - which does nothing in its base implementation.
        /// </summary>
        /// <param name="sbrDocument">The SBR document.</param>
        /// <param name="populatedReportElementsMap">The populated report elements map can be used to find data elements and tuples.</param>
        /// <param name="contextArray">The context array can be used to find context values.</param>
        /// <param name="errors">The errors collection is to be populated with validation results.</param>
        protected virtual void ValidateUnsupportedRules(SBRDocument sbrDocument, IDictionary<string, SBRElement> populatedReportElementsMap, SBRContext[] contextArray, List<ProcessMessageDocument> errors)
        {

        }

        public TRT2022 Consume(SBRDocument sbrDocument, bool validationMode, out List<ProcessMessageDocument> errors)
        {
            TRT2022 report;
            report = new TRT2022();
            errors = new List<ProcessMessageDocument>();

            SBRContext[] contextArray;
            IDictionary<string, SBRElement> populatedReportElementsMap;

            contextArray = sbrDocument.ContextsMap.Values.ToArray();
            populatedReportElementsMap = sbrDocument.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();

            if (validationMode) ValidateUnsupportedRules(sbrDocument, populatedReportElementsMap, contextArray, errors);

            /// <summary>
            /// Current element being extracted
            /// </summary>
            SBRElement currentValue = null;
            /// <summary>
            /// Current elements being extracted
            /// </summary>
            IList<SBRElement> currentValues = null;
            /// <summary>
            /// Current occurrences being extracted
            /// </summary>
            IList<SBRElement> currentOccurrences = null;
            /// <summary>
            /// Working Variable for date time variables
            /// </summary>
            DateTime currentDateTimeValue;
            /// <summary>
            /// Working Variable for boolean variables
            /// </summary>
            bool currentBooleanValue;
            /// <summary>
            /// Working Variable for decimal variables
            /// </summary>
            decimal currentDecimalValue;
            /// <summary>
            /// Working Variable for integer variables
            /// </summary>
            int currentIntValue;
            /// <summary>
            /// Working Variable for long variables
            /// </summary>
            long currentLongValue;
            XmlDocumentFragment currentSegment;
            XmlNamespaceManager currentNamespaceManager;
            XmlNode currentNode;
    
            #region sbrINTContext
            IEnumerable<SBRContext> sbrINTContexts = null;
            SBRContext sbrINTContext = null;
    
            sbrINTContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 1 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Intermediary")) )).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedINTElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrINTContexts != null && sbrINTContexts.Count() > 0)
            {
                sbrINTContext = sbrINTContexts.First();
        
                report.INTId = sbrINTContext.Id;
                report.INTIdentifier = sbrINTContext.EntityIdentifier;
                report.INTIdentifierScheme = sbrINTContext.EntityScheme;
        
                report.INTCount = sbrINTContexts.Count();
                report.INTExists = true;
                report.INTOccurrenceIndex = Array.IndexOf(contextArray, sbrINTContext) + 1;
                report.INTLastOccurrenceIndex = Array.IndexOf(contextArray, sbrINTContexts.Last()) + 1;
        

                if (report.INTIdentifierScheme == "http://www.ato.gov.au/abn") report.INTIdentifierABN = report.INTIdentifier;
    
                report.INTStartDate = ((SBRDurationPeriod)sbrINTContext.Period).DurationStartAsDateObject;
                report.INTEndDate = ((SBRDurationPeriod)sbrINTContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedINTElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrINTContexts.Count(); i++)
                {
                    sbrINTContext = sbrINTContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrINTContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedINTElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedINTElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedINTElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedINTElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Identifiers.TaxAgentClientReference.Text", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT251 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedINTElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Identifiers.TaxAgentNumber.Identifier", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT2 = currentValues[0].Value;
                    }
        
                    IEnumerable<SBRElement> sbrDeclarationCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration", out currentValue))
                        sbrDeclarationCollection = currentValue.Occurrences;
                    else
                        sbrDeclarationCollection = null;
            
                    #region sbrDeclarationCollection
            
                    if (sbrDeclarationCollection != null)
                    {
                        report.DeclarationCollectionExists = true;
                        report.DeclarationCollectionCount = sbrDeclarationCollection.Count();
                
                        IEnumerable<SBRElement> sbrDeclarationCollection_TrueAndCorrect_INTCollection;
                        sbrDeclarationCollection_TrueAndCorrect_INTCollection = sbrDeclarationCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "Declaration.StatementType.Code" && te.Value == "TrueAndCorrect" &&
                            sbrINTContexts.Contains(te.Context)));
                        if (sbrDeclarationCollection_TrueAndCorrect_INTCollection != null && sbrDeclarationCollection_TrueAndCorrect_INTCollection.Count() > 0)
                        {
                            SBRElement sbrDeclarationCollection_TrueAndCorrect_INT;
                            sbrDeclarationCollection_TrueAndCorrect_INT = sbrDeclarationCollection_TrueAndCorrect_INTCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrDeclarationCollection_TrueAndCorrect_INTTupleElementMap;
                            sbrDeclarationCollection_TrueAndCorrect_INTTupleElementMap = sbrDeclarationCollection_TrueAndCorrect_INT.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.DeclarationCollection_TrueAndCorrect_INTExists = true;
                            report.DeclarationCollection_TrueAndCorrect_INTCount = sbrDeclarationCollection_TrueAndCorrect_INTCollection.Count();
                            report.DeclarationCollection_TrueAndCorrect_INTOccurrenceIndex = sbrDeclarationCollection_TrueAndCorrect_INT.OccurrenceIndex + 1;
                            report.DeclarationCollection_TrueAndCorrect_INTLastOccurrenceIndex = sbrDeclarationCollection_TrueAndCorrect_INTCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrDeclarationCollection_TrueAndCorrect_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.StatementType.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT390 = currentValue.Value;
                            }
                    
                            if (sbrDeclarationCollection_TrueAndCorrect_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.StatementAccepted.Indicator", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT391 = ToBoolean(currentValue.Value);
                            }
                    
                            if (sbrDeclarationCollection_TrueAndCorrect_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.Statement.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT392 = currentValue.Value;
                            }
                    
                            if (sbrDeclarationCollection_TrueAndCorrect_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.Signature.Date", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT393 = DateTime.Parse(currentValue.Value);
                            }
                    
                            if (sbrDeclarationCollection_TrueAndCorrect_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.SignatoryIdentifier.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT394 = currentValue.Value;
                            }
                
                            IEnumerable<SBRElement> sbrDeclaration_PersonUnstructuredNameCollection;
                            if (sbrDeclarationCollection_TrueAndCorrect_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName", out currentValue))
                                sbrDeclaration_PersonUnstructuredNameCollection = currentValue.Occurrences;
                            else
                                sbrDeclaration_PersonUnstructuredNameCollection = null;
                    
                            #region sbrDeclaration_PersonUnstructuredNameCollection
                    
                            if (sbrDeclaration_PersonUnstructuredNameCollection != null)
                            {
                                report.Declaration_PersonUnstructuredNameCollectionExists = true;
                                report.Declaration_PersonUnstructuredNameCollectionCount = sbrDeclaration_PersonUnstructuredNameCollection.Count();
                        
                                IEnumerable<SBRElement> sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTCollection;
                                sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTCollection = sbrDeclaration_PersonUnstructuredNameCollection.Where(
                                    ce => ce.ChildElements != null && 
                                    ce.ChildElements.Any(te => te.Name == "PersonUnstructuredName.Usage.Code" && te.Value == "DeclarationSignatory" &&
                                    sbrINTContexts.Contains(te.Context)));
                                if (sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTCollection != null && sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTCollection.Count() > 0)
                                {
                                    SBRElement sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INT;
                                    sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INT = sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTCollection.ElementAt(0);
                        
                                    IDictionary<string, SBRElement> sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTTupleElementMap;
                                    sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTTupleElementMap = sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INT.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                        
                                    report.Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTExists = true;
                                    report.Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTCount = sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTCollection.Count();
                                    report.Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTOccurrenceIndex = sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INT.OccurrenceIndex + 1;
                                    report.Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTLastOccurrenceIndex = sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTCollection.Last().OccurrenceIndex + 1;
                            
                                    if (sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.Usage.Code", out currentValue))
                                    {
                                        if (!currentValue.IsNil) report.TRT395 = currentValue.Value;
                                    }
                            
                                    if (sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.FullName.Text", out currentValue))
                                    {
                                        if (!currentValue.IsNil) report.TRT396 = currentValue.Value;
                                    }
                                }  
                            } 
                            #endregion End of Tuple sbrDeclaration_PersonUnstructuredNameCollection
                            if (validationMode) ValidateINTDeclaration_PersonUnstructuredNameCollection(errors, sbrDeclaration_PersonUnstructuredNameCollection, sbrINTContexts, report);
                    
                        }  
                    } 
                    #endregion End of Tuple sbrDeclarationCollection
                    if (validationMode) ValidateINTDeclarationCollection(errors, sbrDeclarationCollection, sbrINTContexts, report);
            
        
                    IEnumerable<SBRElement> sbrPersonUnstructuredNameCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName", out currentValue))
                        sbrPersonUnstructuredNameCollection = currentValue.Occurrences;
                    else
                        sbrPersonUnstructuredNameCollection = null;
            
                    #region sbrPersonUnstructuredNameCollection
            
                    if (sbrPersonUnstructuredNameCollection != null)
                    {
                        report.PersonUnstructuredNameCollectionExists = true;
                        report.PersonUnstructuredNameCollectionCount = sbrPersonUnstructuredNameCollection.Count();
                
                        IEnumerable<SBRElement> sbrPersonUnstructuredNameCollection_Contact_INTCollection;
                        sbrPersonUnstructuredNameCollection_Contact_INTCollection = sbrPersonUnstructuredNameCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "PersonUnstructuredName.Usage.Code" && te.Value == "Contact" &&
                            sbrINTContexts.Contains(te.Context)));
                        if (sbrPersonUnstructuredNameCollection_Contact_INTCollection != null && sbrPersonUnstructuredNameCollection_Contact_INTCollection.Count() > 0)
                        {
                            SBRElement sbrPersonUnstructuredNameCollection_Contact_INT;
                            sbrPersonUnstructuredNameCollection_Contact_INT = sbrPersonUnstructuredNameCollection_Contact_INTCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrPersonUnstructuredNameCollection_Contact_INTTupleElementMap;
                            sbrPersonUnstructuredNameCollection_Contact_INTTupleElementMap = sbrPersonUnstructuredNameCollection_Contact_INT.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.PersonUnstructuredNameCollection_Contact_INTExists = true;
                            report.PersonUnstructuredNameCollection_Contact_INTCount = sbrPersonUnstructuredNameCollection_Contact_INTCollection.Count();
                            report.PersonUnstructuredNameCollection_Contact_INTOccurrenceIndex = sbrPersonUnstructuredNameCollection_Contact_INT.OccurrenceIndex + 1;
                            report.PersonUnstructuredNameCollection_Contact_INTLastOccurrenceIndex = sbrPersonUnstructuredNameCollection_Contact_INTCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrPersonUnstructuredNameCollection_Contact_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.Usage.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT397 = currentValue.Value;
                            }
                    
                            if (sbrPersonUnstructuredNameCollection_Contact_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.FullName.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT250 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrPersonUnstructuredNameCollection
                    if (validationMode) ValidateINTPersonUnstructuredNameCollection(errors, sbrPersonUnstructuredNameCollection, sbrINTContexts, report);
            
        
                    IEnumerable<SBRElement> sbrElectronicContactTelephoneCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContactTelephone", out currentValue))
                        sbrElectronicContactTelephoneCollection = currentValue.Occurrences;
                    else
                        sbrElectronicContactTelephoneCollection = null;
            
                    #region sbrElectronicContactTelephoneCollection
            
                    if (sbrElectronicContactTelephoneCollection != null)
                    {
                        report.ElectronicContactTelephoneCollectionExists = true;
                        report.ElectronicContactTelephoneCollectionCount = sbrElectronicContactTelephoneCollection.Count();
                
                        IEnumerable<SBRElement> sbrElectronicContactTelephoneCollection_03_INTCollection;
                        sbrElectronicContactTelephoneCollection_03_INTCollection = sbrElectronicContactTelephoneCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "ElectronicContact.Telephone.Usage.Code" && te.Value == "03" &&
                            sbrINTContexts.Contains(te.Context)));
                        if (sbrElectronicContactTelephoneCollection_03_INTCollection != null && sbrElectronicContactTelephoneCollection_03_INTCollection.Count() > 0)
                        {
                            SBRElement sbrElectronicContactTelephoneCollection_03_INT;
                            sbrElectronicContactTelephoneCollection_03_INT = sbrElectronicContactTelephoneCollection_03_INTCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrElectronicContactTelephoneCollection_03_INTTupleElementMap;
                            sbrElectronicContactTelephoneCollection_03_INTTupleElementMap = sbrElectronicContactTelephoneCollection_03_INT.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.ElectronicContactTelephoneCollection_03_INTExists = true;
                            report.ElectronicContactTelephoneCollection_03_INTCount = sbrElectronicContactTelephoneCollection_03_INTCollection.Count();
                            report.ElectronicContactTelephoneCollection_03_INTOccurrenceIndex = sbrElectronicContactTelephoneCollection_03_INT.OccurrenceIndex + 1;
                            report.ElectronicContactTelephoneCollection_03_INTLastOccurrenceIndex = sbrElectronicContactTelephoneCollection_03_INTCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrElectronicContactTelephoneCollection_03_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Usage.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT335 = currentValue.Value;
                            }
                    
                            if (sbrElectronicContactTelephoneCollection_03_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.ServiceLine.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT334 = currentValue.Value;
                            }
                    
                            if (sbrElectronicContactTelephoneCollection_03_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Area.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT248 = currentValue.Value;
                            }
                    
                            if (sbrElectronicContactTelephoneCollection_03_INTTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Minimal.Number", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT249 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrElectronicContactTelephoneCollection
                    if (validationMode) ValidateINTElectronicContactTelephoneCollection(errors, sbrElectronicContactTelephoneCollection, sbrINTContexts, report);
            
                } 
            } 
            #endregion End of Context sbrINTContext
    
            #region sbrRPContext
            IEnumerable<SBRContext> sbrRPContexts = null;
            SBRContext sbrRPContext = null;
    
            sbrRPContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 1 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty")) )).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPContexts != null && sbrRPContexts.Count() > 0)
            {
                sbrRPContext = sbrRPContexts.First();
        
                report.RPId = sbrRPContext.Id;
                report.RPIdentifier = sbrRPContext.EntityIdentifier;
                report.RPIdentifierScheme = sbrRPContext.EntityScheme;
        
                report.RPCount = sbrRPContexts.Count();
                report.RPExists = true;
                report.RPOccurrenceIndex = Array.IndexOf(contextArray, sbrRPContext) + 1;
                report.RPLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPContexts.Last()) + 1;
        

                if (report.RPIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPIdentifierTFN = report.RPIdentifier;
    
                report.RPStartDate = ((SBRDurationPeriod)sbrRPContext.Period).DurationStartAsDateObject;
                report.RPEndDate = ((SBRDurationPeriod)sbrRPContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPContexts.Count(); i++)
                {
                    sbrRPContext = sbrRPContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
                    report.TRT5 = report.RPIdentifier;
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Report.TargetFinancial.Year", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT1 = int.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Identifiers.AustralianBusinessNumber.Identifier", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT7 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Report.Amendment.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT414 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Report.AmendmentType.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT415 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Report.AmendmentReason.Text", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT416 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Report.AmendmentSequence.Number", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT417 = decimal.Parse(currentValues[0].Value);
                    }
        
                    IEnumerable<SBRElement> sbrOrganisationNameDetailsCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails", out currentValue))
                        sbrOrganisationNameDetailsCollection = currentValue.Occurrences;
                    else
                        sbrOrganisationNameDetailsCollection = null;
            
                    #region sbrOrganisationNameDetailsCollection
            
                    if (sbrOrganisationNameDetailsCollection != null)
                    {
                        report.OrganisationNameDetailsCollectionExists = true;
                        report.OrganisationNameDetailsCollectionCount = sbrOrganisationNameDetailsCollection.Count();
                
                        IEnumerable<SBRElement> sbrOrganisationNameDetailsCollection_MN_C_RPCollection;
                        sbrOrganisationNameDetailsCollection_MN_C_RPCollection = sbrOrganisationNameDetailsCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "OrganisationNameDetails.OrganisationalNameType.Code" && te.Value == "MN") &&
                            ce.ChildElements.Any(te => te.Name == "OrganisationNameDetails.Currency.Code" && te.Value == "C" &&
                            sbrRPContexts.Contains(te.Context)));
                        if (sbrOrganisationNameDetailsCollection_MN_C_RPCollection != null && sbrOrganisationNameDetailsCollection_MN_C_RPCollection.Count() > 0)
                        {
                            SBRElement sbrOrganisationNameDetailsCollection_MN_C_RP;
                            sbrOrganisationNameDetailsCollection_MN_C_RP = sbrOrganisationNameDetailsCollection_MN_C_RPCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrOrganisationNameDetailsCollection_MN_C_RPTupleElementMap;
                            sbrOrganisationNameDetailsCollection_MN_C_RPTupleElementMap = sbrOrganisationNameDetailsCollection_MN_C_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.OrganisationNameDetailsCollection_MN_C_RPExists = true;
                            report.OrganisationNameDetailsCollection_MN_C_RPCount = sbrOrganisationNameDetailsCollection_MN_C_RPCollection.Count();
                            report.OrganisationNameDetailsCollection_MN_C_RPOccurrenceIndex = sbrOrganisationNameDetailsCollection_MN_C_RP.OccurrenceIndex + 1;
                            report.OrganisationNameDetailsCollection_MN_C_RPLastOccurrenceIndex = sbrOrganisationNameDetailsCollection_MN_C_RPCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrOrganisationNameDetailsCollection_MN_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalNameType.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT363 = currentValue.Value;
                            }
                    
                            if (sbrOrganisationNameDetailsCollection_MN_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.Currency.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT364 = currentValue.Value;
                            }
                    
                            if (sbrOrganisationNameDetailsCollection_MN_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalName.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT6 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrOrganisationNameDetailsCollection
                    if (validationMode) ValidateRPOrganisationNameDetailsCollection(errors, sbrOrganisationNameDetailsCollection, sbrRPContexts, report);
            
            
                    #region sbrOrganisationNameDetailsCollection
            
                    if (sbrOrganisationNameDetailsCollection != null)
                    {
                
                        IEnumerable<SBRElement> sbrOrganisationNameDetailsCollection_MN_P_RPCollection;
                        sbrOrganisationNameDetailsCollection_MN_P_RPCollection = sbrOrganisationNameDetailsCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "OrganisationNameDetails.OrganisationalNameType.Code" && te.Value == "MN") &&
                            ce.ChildElements.Any(te => te.Name == "OrganisationNameDetails.Currency.Code" && te.Value == "P" &&
                            sbrRPContexts.Contains(te.Context)));
                        if (sbrOrganisationNameDetailsCollection_MN_P_RPCollection != null && sbrOrganisationNameDetailsCollection_MN_P_RPCollection.Count() > 0)
                        {
                            SBRElement sbrOrganisationNameDetailsCollection_MN_P_RP;
                            sbrOrganisationNameDetailsCollection_MN_P_RP = sbrOrganisationNameDetailsCollection_MN_P_RPCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrOrganisationNameDetailsCollection_MN_P_RPTupleElementMap;
                            sbrOrganisationNameDetailsCollection_MN_P_RPTupleElementMap = sbrOrganisationNameDetailsCollection_MN_P_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.OrganisationNameDetailsCollection_MN_P_RPExists = true;
                            report.OrganisationNameDetailsCollection_MN_P_RPCount = sbrOrganisationNameDetailsCollection_MN_P_RPCollection.Count();
                            report.OrganisationNameDetailsCollection_MN_P_RPOccurrenceIndex = sbrOrganisationNameDetailsCollection_MN_P_RP.OccurrenceIndex + 1;
                            report.OrganisationNameDetailsCollection_MN_P_RPLastOccurrenceIndex = sbrOrganisationNameDetailsCollection_MN_P_RPCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrOrganisationNameDetailsCollection_MN_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalNameType.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT365 = currentValue.Value;
                            }
                    
                            if (sbrOrganisationNameDetailsCollection_MN_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.Currency.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT366 = currentValue.Value;
                            }
                    
                            if (sbrOrganisationNameDetailsCollection_MN_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalName.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT8 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrOrganisationNameDetailsCollection
                    if (validationMode) ValidateRPOrganisationNameDetailsCollection1(errors, sbrOrganisationNameDetailsCollection, sbrRPContexts, report);
            
        
                    IEnumerable<SBRElement> sbrAddressDetailsCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails", out currentValue))
                        sbrAddressDetailsCollection = currentValue.Occurrences;
                    else
                        sbrAddressDetailsCollection = null;
            
                    #region sbrAddressDetailsCollection
            
                    if (sbrAddressDetailsCollection != null)
                    {
                        report.AddressDetailsCollectionExists = true;
                        report.AddressDetailsCollectionCount = sbrAddressDetailsCollection.Count();
                
                        IEnumerable<SBRElement> sbrAddressDetailsCollection_POS_C_RPCollection;
                        sbrAddressDetailsCollection_POS_C_RPCollection = sbrAddressDetailsCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "AddressDetails.Usage.Code" && te.Value == "POS") &&
                            ce.ChildElements.Any(te => te.Name == "AddressDetails.Currency.Code" && te.Value == "C" &&
                            sbrRPContexts.Contains(te.Context)));
                        if (sbrAddressDetailsCollection_POS_C_RPCollection != null && sbrAddressDetailsCollection_POS_C_RPCollection.Count() > 0)
                        {
                            SBRElement sbrAddressDetailsCollection_POS_C_RP;
                            sbrAddressDetailsCollection_POS_C_RP = sbrAddressDetailsCollection_POS_C_RPCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrAddressDetailsCollection_POS_C_RPTupleElementMap;
                            sbrAddressDetailsCollection_POS_C_RPTupleElementMap = sbrAddressDetailsCollection_POS_C_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.AddressDetailsCollection_POS_C_RPExists = true;
                            report.AddressDetailsCollection_POS_C_RPCount = sbrAddressDetailsCollection_POS_C_RPCollection.Count();
                            report.AddressDetailsCollection_POS_C_RPOccurrenceIndex = sbrAddressDetailsCollection_POS_C_RP.OccurrenceIndex + 1;
                            report.AddressDetailsCollection_POS_C_RPLastOccurrenceIndex = sbrAddressDetailsCollection_POS_C_RPCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.OverseasAddress.Indicator", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT315 = ToBoolean(currentValue.Value);
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Usage.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT321 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Currency.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT322 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line1.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT9 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line2.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT306 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line3.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT307 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line4.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT308 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.LocalityName.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT10 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Postcode.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT12 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.StateOrTerritory.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT11 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.CountryName.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT13 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Country.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT367 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrAddressDetailsCollection
                    if (validationMode) ValidateRPAddressDetailsCollection(errors, sbrAddressDetailsCollection, sbrRPContexts, report);
            
            
                    #region sbrAddressDetailsCollection
            
                    if (sbrAddressDetailsCollection != null)
                    {
                
                        IEnumerable<SBRElement> sbrAddressDetailsCollection_POS_P_RPCollection;
                        sbrAddressDetailsCollection_POS_P_RPCollection = sbrAddressDetailsCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "AddressDetails.Usage.Code" && te.Value == "POS") &&
                            ce.ChildElements.Any(te => te.Name == "AddressDetails.Currency.Code" && te.Value == "P" &&
                            sbrRPContexts.Contains(te.Context)));
                        if (sbrAddressDetailsCollection_POS_P_RPCollection != null && sbrAddressDetailsCollection_POS_P_RPCollection.Count() > 0)
                        {
                            SBRElement sbrAddressDetailsCollection_POS_P_RP;
                            sbrAddressDetailsCollection_POS_P_RP = sbrAddressDetailsCollection_POS_P_RPCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrAddressDetailsCollection_POS_P_RPTupleElementMap;
                            sbrAddressDetailsCollection_POS_P_RPTupleElementMap = sbrAddressDetailsCollection_POS_P_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.AddressDetailsCollection_POS_P_RPExists = true;
                            report.AddressDetailsCollection_POS_P_RPCount = sbrAddressDetailsCollection_POS_P_RPCollection.Count();
                            report.AddressDetailsCollection_POS_P_RPOccurrenceIndex = sbrAddressDetailsCollection_POS_P_RP.OccurrenceIndex + 1;
                            report.AddressDetailsCollection_POS_P_RPLastOccurrenceIndex = sbrAddressDetailsCollection_POS_P_RPCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.OverseasAddress.Indicator", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT317 = ToBoolean(currentValue.Value);
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Usage.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT323 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Currency.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT324 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line1.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT14 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line2.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT312 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line3.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT313 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line4.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT314 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.LocalityName.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT15 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Postcode.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT17 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.StateOrTerritory.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT16 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.CountryName.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT18 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_POS_P_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Country.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT368 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrAddressDetailsCollection
                    if (validationMode) ValidateRPAddressDetailsCollection1(errors, sbrAddressDetailsCollection, sbrRPContexts, report);
            
        
                    IEnumerable<SBRElement> sbrMailRecipientCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}MailRecipient", out currentValue))
                        sbrMailRecipientCollection = currentValue.Occurrences;
                    else
                        sbrMailRecipientCollection = null;
            
                    #region sbrMailRecipientCollection
            
                    if (sbrMailRecipientCollection != null)
                    {
                        report.MailRecipientCollectionExists = true;
                        report.MailRecipientCollectionCount = sbrMailRecipientCollection.Count();
                        SBRElement sbrMailRecipient;
                        sbrMailRecipient = sbrMailRecipientCollection.ElementAt(0);
                
                        IDictionary<string, SBRElement> sbrMailRecipientTupleElementMap;
                        sbrMailRecipientTupleElementMap = sbrMailRecipient.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
            
                        IEnumerable<SBRElement> sbrMailRecipient_PersonNameDetailsCollection;
                        if (sbrMailRecipientTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails", out currentValue))
                            sbrMailRecipient_PersonNameDetailsCollection = currentValue.Occurrences;
                        else
                            sbrMailRecipient_PersonNameDetailsCollection = null;
                
                        #region sbrMailRecipient_PersonNameDetailsCollection
                
                        if (sbrMailRecipient_PersonNameDetailsCollection != null)
                        {
                            report.MailRecipient_PersonNameDetailsCollectionExists = true;
                            report.MailRecipient_PersonNameDetailsCollectionCount = sbrMailRecipient_PersonNameDetailsCollection.Count();
                    
                            IEnumerable<SBRElement> sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPCollection;
                            sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPCollection = sbrMailRecipient_PersonNameDetailsCollection.Where(
                                ce => ce.ChildElements != null && 
                                ce.ChildElements.Any(te => te.Name == "PersonNameDetails.PersonNameType.Code" && te.Value == "LGL") &&
                                ce.ChildElements.Any(te => te.Name == "PersonNameDetails.Usage.Code" && te.Value == "MailRecipient" &&
                                sbrRPContexts.Contains(te.Context)));
                            if (sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPCollection != null && sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPCollection.Count() > 0)
                            {
                                SBRElement sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RP;
                                sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RP = sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPCollection.ElementAt(0);
                    
                                IDictionary<string, SBRElement> sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPTupleElementMap;
                                sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPTupleElementMap = sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                    
                                report.MailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPExists = true;
                                report.MailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPCount = sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPCollection.Count();
                                report.MailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPOccurrenceIndex = sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RP.OccurrenceIndex + 1;
                                report.MailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPLastOccurrenceIndex = sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPCollection.Last().OccurrenceIndex + 1;
                        
                                if (sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.PersonNameType.Code", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT329 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Usage.Code", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT331 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Currency.Code", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT369 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Title.Text", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT19 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.NameSuffix.Text", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT21 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.FamilyName.Text", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT20 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.GivenName.Text", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT22 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.OtherGivenName.Text", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT23 = currentValue.Value;
                                }
                            }  
                        } 
                        #endregion End of Tuple sbrMailRecipient_PersonNameDetailsCollection
                        if (validationMode) ValidateRPMailRecipient_PersonNameDetailsCollection(errors, sbrMailRecipient_PersonNameDetailsCollection, sbrRPContexts, report);
                
            
                        IEnumerable<SBRElement> sbrMailRecipient_OrganisationNameDetailsCollection;
                        if (sbrMailRecipientTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails", out currentValue))
                            sbrMailRecipient_OrganisationNameDetailsCollection = currentValue.Occurrences;
                        else
                            sbrMailRecipient_OrganisationNameDetailsCollection = null;
                
                        #region sbrMailRecipient_OrganisationNameDetailsCollection
                
                        if (sbrMailRecipient_OrganisationNameDetailsCollection != null)
                        {
                            report.MailRecipient_OrganisationNameDetailsCollectionExists = true;
                            report.MailRecipient_OrganisationNameDetailsCollectionCount = sbrMailRecipient_OrganisationNameDetailsCollection.Count();
                    
                            IEnumerable<SBRElement> sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPCollection;
                            sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPCollection = sbrMailRecipient_OrganisationNameDetailsCollection.Where(
                                ce => ce.ChildElements != null && 
                                ce.ChildElements.Any(te => te.Name == "OrganisationNameDetails.OrganisationalNameType.Code" && te.Value == "MN") &&
                                ce.ChildElements.Any(te => te.Name == "OrganisationNameDetails.Currency.Code" && te.Value == "C" &&
                                sbrRPContexts.Contains(te.Context)));
                            if (sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPCollection != null && sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPCollection.Count() > 0)
                            {
                                SBRElement sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RP;
                                sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RP = sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPCollection.ElementAt(0);
                    
                                IDictionary<string, SBRElement> sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPTupleElementMap;
                                sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPTupleElementMap = sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                    
                                report.MailRecipient_OrganisationNameDetailsCollection_MN_C_RPExists = true;
                                report.MailRecipient_OrganisationNameDetailsCollection_MN_C_RPCount = sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPCollection.Count();
                                report.MailRecipient_OrganisationNameDetailsCollection_MN_C_RPOccurrenceIndex = sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RP.OccurrenceIndex + 1;
                                report.MailRecipient_OrganisationNameDetailsCollection_MN_C_RPLastOccurrenceIndex = sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPCollection.Last().OccurrenceIndex + 1;
                        
                                if (sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalNameType.Code", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT330 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.Currency.Code", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT370 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_OrganisationNameDetailsCollection_MN_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalName.Text", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT24 = currentValue.Value;
                                }
                            }  
                        } 
                        #endregion End of Tuple sbrMailRecipient_OrganisationNameDetailsCollection
                        if (validationMode) ValidateRPMailRecipient_OrganisationNameDetailsCollection(errors, sbrMailRecipient_OrganisationNameDetailsCollection, sbrRPContexts, report);
                
                
                        if (sbrMailRecipientTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Identifiers.AustralianBusinessNumber.Identifier", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT25 = currentValue.Value;
                        }
            
                        IEnumerable<SBRElement> sbrMailRecipient_ElectronicContactTelephoneCollection;
                        if (sbrMailRecipientTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContactTelephone", out currentValue))
                            sbrMailRecipient_ElectronicContactTelephoneCollection = currentValue.Occurrences;
                        else
                            sbrMailRecipient_ElectronicContactTelephoneCollection = null;
                
                        #region sbrMailRecipient_ElectronicContactTelephoneCollection
                
                        if (sbrMailRecipient_ElectronicContactTelephoneCollection != null)
                        {
                            report.MailRecipient_ElectronicContactTelephoneCollectionExists = true;
                            report.MailRecipient_ElectronicContactTelephoneCollectionCount = sbrMailRecipient_ElectronicContactTelephoneCollection.Count();
                    
                            IEnumerable<SBRElement> sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPCollection;
                            sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPCollection = sbrMailRecipient_ElectronicContactTelephoneCollection.Where(
                                ce => ce.ChildElements != null && 
                                ce.ChildElements.Any(te => te.Name == "ElectronicContact.Telephone.Usage.Code" && te.Value == "03" &&
                                sbrRPContexts.Contains(te.Context)));
                            if (sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPCollection != null && sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPCollection.Count() > 0)
                            {
                                SBRElement sbrMailRecipient_ElectronicContactTelephoneCollection_03_RP;
                                sbrMailRecipient_ElectronicContactTelephoneCollection_03_RP = sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPCollection.ElementAt(0);
                    
                                IDictionary<string, SBRElement> sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPTupleElementMap;
                                sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPTupleElementMap = sbrMailRecipient_ElectronicContactTelephoneCollection_03_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                    
                                report.MailRecipient_ElectronicContactTelephoneCollection_03_RPExists = true;
                                report.MailRecipient_ElectronicContactTelephoneCollection_03_RPCount = sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPCollection.Count();
                                report.MailRecipient_ElectronicContactTelephoneCollection_03_RPOccurrenceIndex = sbrMailRecipient_ElectronicContactTelephoneCollection_03_RP.OccurrenceIndex + 1;
                                report.MailRecipient_ElectronicContactTelephoneCollection_03_RPLastOccurrenceIndex = sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPCollection.Last().OccurrenceIndex + 1;
                        
                                if (sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Usage.Code", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT333 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.ServiceLine.Code", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT371 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Area.Code", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT26 = currentValue.Value;
                                }
                        
                                if (sbrMailRecipient_ElectronicContactTelephoneCollection_03_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Minimal.Number", out currentValue))
                                {
                                    if (!currentValue.IsNil) report.TRT27 = currentValue.Value;
                                }
                            }  
                        } 
                        #endregion End of Tuple sbrMailRecipient_ElectronicContactTelephoneCollection
                        if (validationMode) ValidateRPMailRecipient_ElectronicContactTelephoneCollection(errors, sbrMailRecipient_ElectronicContactTelephoneCollection, sbrRPContexts, report);
                
                    } 
                    #endregion End of Tuple sbrMailRecipientCollection
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Elections.FamilyTrustElectionStatus.Year", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT28 = int.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Elections.FamilyTrustElectionRevocation.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT29 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Elections.InterposedEntityElectionStatus.Year", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT30 = int.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Elections.InterposedEntityElectionRevocation.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT31 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationDetails.OrganisationType.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT32 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationDetails.CharitableOrganisation.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT33 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonDemographicDetails.Death.Date", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT34 = DateTime.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationDetails.ManagedInvestmentTrust.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT520 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationDetails.ManagedInvestmentTrustType.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT521 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Elections.ManagedInvestmentTrusts.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT352 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Report.Statement.Summary.PaymentRefundOrNil.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT35 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Lodgment.FinalReturn.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT36 = ToBoolean(currentValues[0].Value);
                    }
        
                    IEnumerable<SBRElement> sbrFinancialInstitutionAccountCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}FinancialInstitutionAccount", out currentValue))
                        sbrFinancialInstitutionAccountCollection = currentValue.Occurrences;
                    else
                        sbrFinancialInstitutionAccountCollection = null;
            
                    #region sbrFinancialInstitutionAccountCollection
            
                    if (sbrFinancialInstitutionAccountCollection != null)
                    {
                        report.FinancialInstitutionAccountCollectionExists = true;
                        report.FinancialInstitutionAccountCollectionCount = sbrFinancialInstitutionAccountCollection.Count();
                        SBRElement sbrFinancialInstitutionAccount;
                        sbrFinancialInstitutionAccount = sbrFinancialInstitutionAccountCollection.ElementAt(0);
                
                        IDictionary<string, SBRElement> sbrFinancialInstitutionAccountTupleElementMap;
                        sbrFinancialInstitutionAccountTupleElementMap = sbrFinancialInstitutionAccount.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                        if (sbrFinancialInstitutionAccountTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}FinancialInstitutionAccount.BankStateBranch.Number", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT38 = currentValue.Value;
                        }
                
                        if (sbrFinancialInstitutionAccountTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}FinancialInstitutionAccount.FinancialInstitutionAccount.Number", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT39 = currentValue.Value;
                        }
                
                        if (sbrFinancialInstitutionAccountTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}FinancialInstitutionAccount.FinancialInstitutionAccountName.Text", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT40 = currentValue.Value;
                        }
                
                        if (sbrFinancialInstitutionAccountTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}FinancialInstitutionAccount.FinancialInstitutionBranchName.Text", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT406 = currentValue.Value;
                        }
                
                        if (sbrFinancialInstitutionAccountTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}FinancialInstitutionAccount.FinancialInstitutionName.Text", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT407 = currentValue.Value;
                        }
                    } 
                    #endregion End of Tuple sbrFinancialInstitutionAccountCollection
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationDetails.MainIncomeActivity.Description", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT41 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationDetails.OrganisationIndustry2006Extended.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT42 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationDetails.ActivityEvent.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT43 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationDetails.TaxConsolidationStatus.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT44 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationDetails.SignificantGlobalEntityStatus.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT487 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InternationalDealings.CountryByCountryReportingEntityStatus.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT550 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}CapitalGainsTax.Event.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT131 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}CapitalGainsTax.ExemptionOrRolloverApplied.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT454 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}CapitalGainsTax.ExemptionOrRolloverApplied.Code", out currentValues))
                    {
                        report.TRT448Collection = new List<string>();
                        try
                        {
                                foreach (SBRElement occurrence in currentValues)
                                {
                                    if (!occurrence.IsNil)
                                        report.TRT448Collection.Add(occurrence.Value);
                                }
                        }
                        catch (Exception)
                        {
                            // The above code is known to throw exceptions in some cases but not others.
                            // We don't really know why but think that catching them like this will result in correct behaviour
                        }
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.CapitalGainsNet.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT133 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForCapitalGainsWithheldFromForeignResidents.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT480 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Deduction.TaxLossesDeducted.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT144 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InternationalDealings.RelatedPartiesTransactionsExcessAggregateValue.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT148 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Liabilities.ThinCapitalisation.ProvisionsApplied.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT449 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Residency.TaxPurposesPersonStatus.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT149 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InternationalDealings.TransactionsWithTaxHavenCountries.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT151 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.PersonalServicesIncomeIncluded.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT155 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.PersonalServicesIncome.Total.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT450 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.PersonalServicesIncome.Deduction.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT451 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PersonalServicesIncome.IndividualResultsTestSatisfied.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT452 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PersonalServicesIncome.IndividualPersonalServiceBusinessDeterminationHeld.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT453 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PersonalServicesIncome.UnrelatedClientsTestSatisfied.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT455 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PersonalServicesIncome.EmploymentTestSatisfied.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT456 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PersonalServicesIncome.BusinessPremisesTestSatisfied.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT457 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT535 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT536 = decimal.Parse(currentValues[0].Value);
                    }
            
                    #region sbrOrganisationNameDetailsCollection
            
                    if (sbrOrganisationNameDetailsCollection != null)
                    {
                
                        IEnumerable<SBRElement> sbrOrganisationNameDetailsCollection_MTR_C_RPCollection;
                        sbrOrganisationNameDetailsCollection_MTR_C_RPCollection = sbrOrganisationNameDetailsCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "OrganisationNameDetails.OrganisationalNameType.Code" && te.Value == "MTR") &&
                            ce.ChildElements.Any(te => te.Name == "OrganisationNameDetails.Currency.Code" && te.Value == "C" &&
                            sbrRPContexts.Contains(te.Context)));
                        if (sbrOrganisationNameDetailsCollection_MTR_C_RPCollection != null && sbrOrganisationNameDetailsCollection_MTR_C_RPCollection.Count() > 0)
                        {
                            SBRElement sbrOrganisationNameDetailsCollection_MTR_C_RP;
                            sbrOrganisationNameDetailsCollection_MTR_C_RP = sbrOrganisationNameDetailsCollection_MTR_C_RPCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrOrganisationNameDetailsCollection_MTR_C_RPTupleElementMap;
                            sbrOrganisationNameDetailsCollection_MTR_C_RPTupleElementMap = sbrOrganisationNameDetailsCollection_MTR_C_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.OrganisationNameDetailsCollection_MTR_C_RPExists = true;
                            report.OrganisationNameDetailsCollection_MTR_C_RPCount = sbrOrganisationNameDetailsCollection_MTR_C_RPCollection.Count();
                            report.OrganisationNameDetailsCollection_MTR_C_RPOccurrenceIndex = sbrOrganisationNameDetailsCollection_MTR_C_RP.OccurrenceIndex + 1;
                            report.OrganisationNameDetailsCollection_MTR_C_RPLastOccurrenceIndex = sbrOrganisationNameDetailsCollection_MTR_C_RPCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrOrganisationNameDetailsCollection_MTR_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalNameType.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT372 = currentValue.Value;
                            }
                    
                            if (sbrOrganisationNameDetailsCollection_MTR_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.Currency.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT373 = currentValue.Value;
                            }
                    
                            if (sbrOrganisationNameDetailsCollection_MTR_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalName.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT161 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrOrganisationNameDetailsCollection
                    if (validationMode) ValidateRPOrganisationNameDetailsCollection2(errors, sbrOrganisationNameDetailsCollection, sbrRPContexts, report);
            
            
                    #region sbrAddressDetailsCollection
            
                    if (sbrAddressDetailsCollection != null)
                    {
                
                        IEnumerable<SBRElement> sbrAddressDetailsCollection_BUS_C_RPCollection;
                        sbrAddressDetailsCollection_BUS_C_RPCollection = sbrAddressDetailsCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "AddressDetails.Usage.Code" && te.Value == "BUS") &&
                            ce.ChildElements.Any(te => te.Name == "AddressDetails.Currency.Code" && te.Value == "C" &&
                            sbrRPContexts.Contains(te.Context)));
                        if (sbrAddressDetailsCollection_BUS_C_RPCollection != null && sbrAddressDetailsCollection_BUS_C_RPCollection.Count() > 0)
                        {
                            SBRElement sbrAddressDetailsCollection_BUS_C_RP;
                            sbrAddressDetailsCollection_BUS_C_RP = sbrAddressDetailsCollection_BUS_C_RPCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrAddressDetailsCollection_BUS_C_RPTupleElementMap;
                            sbrAddressDetailsCollection_BUS_C_RPTupleElementMap = sbrAddressDetailsCollection_BUS_C_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.AddressDetailsCollection_BUS_C_RPExists = true;
                            report.AddressDetailsCollection_BUS_C_RPCount = sbrAddressDetailsCollection_BUS_C_RPCollection.Count();
                            report.AddressDetailsCollection_BUS_C_RPOccurrenceIndex = sbrAddressDetailsCollection_BUS_C_RP.OccurrenceIndex + 1;
                            report.AddressDetailsCollection_BUS_C_RPLastOccurrenceIndex = sbrAddressDetailsCollection_BUS_C_RPCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.OverseasAddress.Indicator", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT316 = ToBoolean(currentValue.Value);
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Usage.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT325 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Currency.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT326 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line1.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT162 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line2.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT309 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line3.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT310 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line4.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT311 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.LocalityName.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT163 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Postcode.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT165 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.StateOrTerritory.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT164 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.CountryName.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT360 = currentValue.Value;
                            }
                    
                            if (sbrAddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Country.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT374 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrAddressDetailsCollection
                    if (validationMode) ValidateRPAddressDetailsCollection2(errors, sbrAddressDetailsCollection, sbrRPContexts, report);
            
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Purchases.AndOtherCosts.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT167 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.WagesAndSalaries.Total.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT172 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.WagesAndSalariesAction.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT173 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.PaymentToRelatedPartiesGross.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT174 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.FringeBenefits.EmployeeContribution.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT181 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PrivateCompanyUnpaidPresentEntitlement.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT187 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Elections.TradingStock.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT188 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.AggregatedTurnoverRange.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT563 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.AggregatedTurnover.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT564 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DepreciatingAssets.IntangibleFirstDeducted.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT175 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DepreciatingAssets.OtherFirstDeducted.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT176 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.PropertyPlantAndEquipment.DepreciatingAssets.FirstDeductedSelfAssessedEffectiveLife.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT458 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Deduction.TemporaryFullExpensingEligibleAssetsOptOut.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT551 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Deduction.TemporaryFullExpensingEligibleAssetsOptOut.Number", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT552 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Deduction.TemporaryFullExpensingEligibleAssetsOptOut.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT553 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Deduction.TemporaryFullExpensingEligibleAssets.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT554 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Deduction.TemporaryFullExpensingEligibleAssets.Number", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT555 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.SubsequentYearAcceleratedDepreciationDeductionsForAssets.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT561 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.PropertyPlantAndEquipment.DepreciatingAssets.EffectiveLifeRecalculation.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT459 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.DepreciatingAssets.AdjustableValuesTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT460 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.DepreciatingAssets.IntangibleBalancingAdjustment.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT461 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DepreciatingAssets.IntangibleBalancingAdjustment.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT462 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.DepreciatingAssets.IntangibleTerminationValue.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT177 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.DepreciatingAssets.OtherTerminationValue.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT178 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.ProjectPoolAllowableDeduction.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT179 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.CapitalExpenditureSpecifiedAllowableDeduction.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT180 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.LandcareOperationsAcceleratedDepreciation.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT184 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NationalRentalAffordabilitySchemeEntitlement.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT340 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.TaxOffsetRefundableOther.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT463 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.TaxOffsetRefundableOther.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT464 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.MedicareLevy.BeneficiarySpouseTaxableIncome.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT194 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.MedicareLevy.DependentChildrenAndStudents.Count", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT195 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.MedicareLevy.ExemptionFullDays.Count", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT196 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.MedicareLevy.ExemptionFullDays.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT197 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.MedicareLevy.ExemptionHalfDays.Count", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT198 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.TrustEstateIncome.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT440 = decimal.Parse(currentValues[0].Value);
                    }
        
                    IEnumerable<SBRElement> sbrStatementOfDistributionToBeneficiaryCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}StatementOfDistributionToBeneficiary", out currentValue))
                        sbrStatementOfDistributionToBeneficiaryCollection = currentValue.Occurrences;
                    else
                        sbrStatementOfDistributionToBeneficiaryCollection = null;
            
                    #region sbrStatementOfDistributionToBeneficiaryCollection
            
                    if (sbrStatementOfDistributionToBeneficiaryCollection != null)
                    {
                        report.StatementOfDistributionToBeneficiaryCollectionExists = true;
                        report.StatementOfDistributionToBeneficiaryCollectionCount = sbrStatementOfDistributionToBeneficiaryCollection.Count();
                        if (sbrStatementOfDistributionToBeneficiaryCollection != null && sbrStatementOfDistributionToBeneficiaryCollection.Count() > 0)
                        {
                            report.StatementOfDistributionToBeneficiaryCollection = new List<TRT2022.StatementOfDistributionToBeneficiary>();
                            for (int tupleIndex = 0; tupleIndex < sbrStatementOfDistributionToBeneficiaryCollection.Count(); tupleIndex++)
                            {
                                SBRElement sbrStatementOfDistributionToBeneficiary;
                                sbrStatementOfDistributionToBeneficiary = sbrStatementOfDistributionToBeneficiaryCollection.ElementAt(tupleIndex);
                
                                IDictionary<string, SBRElement> sbrStatementOfDistributionToBeneficiaryTupleElementMap;
                                sbrStatementOfDistributionToBeneficiaryTupleElementMap = sbrStatementOfDistributionToBeneficiary.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                                TRT2022.StatementOfDistributionToBeneficiary statementOfDistributionToBeneficiary = new TRT2022.StatementOfDistributionToBeneficiary();
                                report.StatementOfDistributionToBeneficiaryCollection.Add(statementOfDistributionToBeneficiary);
                                statementOfDistributionToBeneficiary.OccurrenceIndex = tupleIndex + 1;
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Identifiers.TaxFileNumber.Identifier", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT211 = currentValue.Value;
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Identifiers.TaxFileNumberTrailingNumeric.Identifier", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT212 = currentValue.Value;
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.BeneficiaryEntityType.Code", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT432 = currentValue.Value;
                                }
                    
                                IEnumerable<SBRElement> sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection;
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails", out currentValue))
                                    sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection = currentValue.Occurrences;
                                else
                                    sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection = null;
                        
                                #region sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection
                        
                                if (sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection != null)
                                {
                                    statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_OrganisationNameDetailsCollectionExists = true;
                                    statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_OrganisationNameDetailsCollectionCount = sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection.Count();
                            
                                    IEnumerable<SBRElement> sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPCollection;
                                    sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPCollection = sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection.Where(
                                        ce => ce.ChildElements != null && 
                                        ce.ChildElements.Any(te => te.Name == "OrganisationNameDetails.OrganisationalNameType.Code" && te.Value == "MN") &&
                                        ce.ChildElements.Any(te => te.Name == "OrganisationNameDetails.Currency.Code" && te.Value == "C" &&
                                        sbrRPContexts.Contains(te.Context)));
                                    if (sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPCollection != null && sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPCollection.Count() > 0)
                                    {
                                        SBRElement sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RP;
                                        sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RP = sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPCollection.ElementAt(0);
                            
                                        IDictionary<string, SBRElement> sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPTupleElementMap;
                                        sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPTupleElementMap = sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                            
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPExists = true;
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPCount = sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPCollection.Count();
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPOccurrenceIndex = sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RP.OccurrenceIndex + 1;
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPLastOccurrenceIndex = sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPCollection.Last().OccurrenceIndex + 1;
                                
                                        if (sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalNameType.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT380 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.Currency.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT381 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalName.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT203 = currentValue.Value;
                                        }
                                    }  
                                } 
                                #endregion End of Tuple sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection
                                if (validationMode) ValidateRPStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection(errors, sbrStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection, sbrRPContexts, report);
                        
                    
                                IEnumerable<SBRElement> sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection;
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails", out currentValue))
                                    sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection = currentValue.Occurrences;
                                else
                                    sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection = null;
                        
                                #region sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection
                        
                                if (sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection != null)
                                {
                                    statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_PersonNameDetailsCollectionExists = true;
                                    statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_PersonNameDetailsCollectionCount = sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection.Count();
                            
                                    IEnumerable<SBRElement> sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPCollection;
                                    sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPCollection = sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection.Where(
                                        ce => ce.ChildElements != null && 
                                        ce.ChildElements.Any(te => te.Name == "PersonNameDetails.PersonNameType.Code" && te.Value == "LGL") &&
                                        ce.ChildElements.Any(te => te.Name == "PersonNameDetails.Usage.Code" && te.Value == "Contact" &&
                                        sbrRPContexts.Contains(te.Context)));
                                    if (sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPCollection != null && sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPCollection.Count() > 0)
                                    {
                                        SBRElement sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RP;
                                        sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RP = sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPCollection.ElementAt(0);
                            
                                        IDictionary<string, SBRElement> sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPTupleElementMap;
                                        sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPTupleElementMap = sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                            
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPExists = true;
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPCount = sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPCollection.Count();
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPOccurrenceIndex = sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RP.OccurrenceIndex + 1;
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPLastOccurrenceIndex = sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPCollection.Last().OccurrenceIndex + 1;
                                
                                        if (sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.PersonNameType.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT375 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Usage.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT376 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Currency.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT377 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Title.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT378 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.NameSuffix.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT379 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.FamilyName.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT200 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.GivenName.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT201 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection_LGL_Contact_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.OtherGivenName.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT202 = currentValue.Value;
                                        }
                                    }  
                                } 
                                #endregion End of Tuple sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection
                                if (validationMode) ValidateRPStatementOfDistributionToBeneficiary_PersonNameDetailsCollection(errors, sbrStatementOfDistributionToBeneficiary_PersonNameDetailsCollection, sbrRPContexts, report);
                        
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonDemographicDetails.Birth.Date", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT213 = DateTime.Parse(currentValue.Value);
                                }
                    
                                IEnumerable<SBRElement> sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection;
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails", out currentValue))
                                    sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection = currentValue.Occurrences;
                                else
                                    sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection = null;
                        
                                #region sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection
                        
                                if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection != null)
                                {
                                    statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AddressDetailsCollectionExists = true;
                                    statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AddressDetailsCollectionCount = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection.Count();
                            
                                    IEnumerable<SBRElement> sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPCollection;
                                    sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPCollection = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection.Where(
                                        ce => ce.ChildElements != null && 
                                        ce.ChildElements.Any(te => te.Name == "AddressDetails.Usage.Code" && te.Value == "RES") &&
                                        ce.ChildElements.Any(te => te.Name == "AddressDetails.Currency.Code" && te.Value == "C" &&
                                        sbrRPContexts.Contains(te.Context)));
                                    if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPCollection != null && sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPCollection.Count() > 0)
                                    {
                                        SBRElement sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RP;
                                        sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RP = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPCollection.ElementAt(0);
                            
                                        IDictionary<string, SBRElement> sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap;
                                        sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                            
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPExists = true;
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPCount = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPCollection.Count();
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPOccurrenceIndex = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RP.OccurrenceIndex + 1;
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPLastOccurrenceIndex = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPCollection.Last().OccurrenceIndex + 1;
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.OverseasAddress.Indicator", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT320 = ToBoolean(currentValue.Value);
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Usage.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT327 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Currency.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT328 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line1.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT205 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line2.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT206 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line3.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT318 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line4.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT319 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.LocalityName.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT207 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Postcode.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT209 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.StateOrTerritory.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT208 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.CountryName.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT210 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Country.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT382 = currentValue.Value;
                                        }
                                    }  
                                } 
                                #endregion End of Tuple sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection
                                if (validationMode) ValidateRPStatementOfDistributionToBeneficiary_AddressDetailsCollection(errors, sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection, sbrRPContexts, report);
                        
                        
                                #region sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection
                        
                                if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection != null)
                                {
                            
                                    IEnumerable<SBRElement> sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPCollection;
                                    sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPCollection = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection.Where(
                                        ce => ce.ChildElements != null && 
                                        ce.ChildElements.Any(te => te.Name == "AddressDetails.Usage.Code" && te.Value == "BUS") &&
                                        ce.ChildElements.Any(te => te.Name == "AddressDetails.Currency.Code" && te.Value == "C" &&
                                        sbrRPContexts.Contains(te.Context)));
                                    if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPCollection != null && sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPCollection.Count() > 0)
                                    {
                                        SBRElement sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RP;
                                        sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RP = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPCollection.ElementAt(0);
                            
                                        IDictionary<string, SBRElement> sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap;
                                        sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                            
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPExists = true;
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPCount = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPCollection.Count();
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPOccurrenceIndex = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RP.OccurrenceIndex + 1;
                                        statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPLastOccurrenceIndex = sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPCollection.Last().OccurrenceIndex + 1;
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.OverseasAddress.Indicator", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT508 = ToBoolean(currentValue.Value);
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Usage.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT509 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Currency.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT510 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line1.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT511 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line2.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT512 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line3.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT513 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line4.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT514 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.LocalityName.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT515 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Postcode.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT516 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.StateOrTerritory.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT517 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.CountryName.Text", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT518 = currentValue.Value;
                                        }
                                
                                        if (sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection_BUS_C_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Country.Code", out currentValue))
                                        {
                                            if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT519 = currentValue.Value;
                                        }
                                    }  
                                } 
                                #endregion End of Tuple sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection
                                if (validationMode) ValidateRPStatementOfDistributionToBeneficiary_AddressDetailsCollection1(errors, sbrStatementOfDistributionToBeneficiary_AddressDetailsCollection, sbrRPContexts, report);
                        
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.AssessmentCalculation.Code", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT214 = currentValue.Value;
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.TrustEstateIncomeShare.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT441 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForAmountsWithheldFromForeignResidents.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT476 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.FrankingCredits.ReceivedFromNewZealandCompanies.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT217 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.BeneficiaryShare.Amount", out currentValue))
                                {
                                    foreach (var sbrElementItem in currentValue.Occurrences)
                                    {
                                        if (!sbrElementItem.IsNil) 
                                        {
                                            if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                            {                    
                                                if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}PrimaryProduction") || p.Domain.EndsWith(":PrimaryProduction"))>-1)
                                                {
                                                    statementOfDistributionToBeneficiary.TRT218 = decimal.Parse(sbrElementItem.Value);
                                                }
                                            }
                                        }
                                    }
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                                {
                                    foreach (var sbrElementItem in currentValue.Occurrences)
                                    {
                                        if (!sbrElementItem.IsNil) 
                                        {
                                            if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                            {                    
                                                if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}PrimaryProduction") || p.Domain.EndsWith(":PrimaryProduction"))>-1)
                                                {
                                                    statementOfDistributionToBeneficiary.TRT537 = decimal.Parse(sbrElementItem.Value);
                                                }
                                            }
                                        }
                                    }
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                                {
                                    foreach (var sbrElementItem in currentValue.Occurrences)
                                    {
                                        if (!sbrElementItem.IsNil) 
                                        {
                                            if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                            {                    
                                                if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}PrimaryProduction") || p.Domain.EndsWith(":PrimaryProduction"))>-1)
                                                {
                                                    statementOfDistributionToBeneficiary.TRT538 = decimal.Parse(sbrElementItem.Value);
                                                }
                                            }
                                        }
                                    }
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.BeneficiaryShare.Amount", out currentValue))
                                {
                                    foreach (var sbrElementItem in currentValue.Occurrences)
                                    {
                                        if (!sbrElementItem.IsNil) 
                                        {
                                            if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                            {                    
                                                if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}NonPrimaryProduction") || p.Domain.EndsWith(":NonPrimaryProduction"))>-1)
                                                {
                                                    statementOfDistributionToBeneficiary.TRT219 = decimal.Parse(sbrElementItem.Value);
                                                }
                                            }
                                        }
                                    }
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                                {
                                    foreach (var sbrElementItem in currentValue.Occurrences)
                                    {
                                        if (!sbrElementItem.IsNil) 
                                        {
                                            if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                            {                    
                                                if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}NonPrimaryProduction") || p.Domain.EndsWith(":NonPrimaryProduction"))>-1)
                                                {
                                                    statementOfDistributionToBeneficiary.TRT539 = decimal.Parse(sbrElementItem.Value);
                                                }
                                            }
                                        }
                                    }
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                                {
                                    foreach (var sbrElementItem in currentValue.Occurrences)
                                    {
                                        if (!sbrElementItem.IsNil) 
                                        {
                                            if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                            {                    
                                                if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}NonPrimaryProduction") || p.Domain.EndsWith(":NonPrimaryProduction"))>-1)
                                                {
                                                    statementOfDistributionToBeneficiary.TRT540 = decimal.Parse(sbrElementItem.Value);
                                                }
                                            }
                                        }
                                    }
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldWhereABNNotQuoted.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT220 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.TaxableMinorBeneficiary.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT549 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.DistributionFranked.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT442 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.FrankingCredits.ReceivedFromAustralianCompanies.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT221 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForAmountsWithheldWhereTFNNotQuoted.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT222 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldFromCloselyHeldTrust.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT419 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.CapitalGainsNet.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT223 = decimal.Parse(currentValue.Value);
                                }

                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                                {
                                    foreach (var sbrElementItem in currentValue.Occurrences)
                                    {
                                        if (!sbrElementItem.IsNil)
                                        {
                                            if (sbrElementItem.Context.Segment.DimensionDomains.Count == 1)
                                            {
                                                if (sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p => p.Domain.EndsWith("}ReportingParty") || p.Domain.EndsWith(":ReportingParty")) > -1)
                                                {
                                                    statementOfDistributionToBeneficiary.TRT541 = decimal.Parse(sbrElementItem.Value);
                                                }
                                            }
                                        }
                                    }
                                }

                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                                {
                                    foreach (var sbrElementItem in currentValue.Occurrences)
                                    {
                                        if (!sbrElementItem.IsNil)
                                        {
                                            if (sbrElementItem.Context.Segment.DimensionDomains.Count == 1)
                                            {
                                                if (sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p => p.Domain.EndsWith("}ReportingParty") || p.Domain.EndsWith(":ReportingParty")) > -1)
                                                {
                                                    statementOfDistributionToBeneficiary.TRT542 = decimal.Parse(sbrElementItem.Value);
                                                }
                                            }
                                        }
                                    }
                                }

                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForCapitalGainsWithheldFromForeignResidents.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT481 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.AttributedForeignIncome.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT224 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.InternationalDealings.Net.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT225 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.InternationalDealings.TaxOffset.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT226 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NationalRentalAffordabilitySchemeEntitlement.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT342 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.ExplorationCreditsDistributed.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT465 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NonRefundableOther.Amount", out currentValue))
                                {
                                    foreach (var sbrElementItem in currentValue.Occurrences)
                                    {
                                        if (!sbrElementItem.IsNil) 
                                        {
                                            if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                            {                    
                                                if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}LimitedPartners") || p.Domain.EndsWith(":LimitedPartners"))>-1)
                                                {
                                                    statementOfDistributionToBeneficiary.TRT502 = decimal.Parse(sbrElementItem.Value);
                                                }
                                            }
                                        }
                                    }
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NonRefundableOther.Amount", out currentValue))
                                {
                                    foreach (var sbrElementItem in currentValue.Occurrences)
                                    {
                                        if (!sbrElementItem.IsNil) 
                                        {
                                            if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                            {                    
                                                if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}Investor") || p.Domain.EndsWith(":Investor"))>-1)
                                                {
                                                    statementOfDistributionToBeneficiary.TRT503 = decimal.Parse(sbrElementItem.Value);
                                                }
                                            }
                                        }
                                    }
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.SmallBusinessEntityNet.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT479 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InternationalDealings.AssessableIncomeNonResidentBeneficiaryNonTrustee.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT228 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InternationalDealings.AssessableIncomeNonResidentBeneficiaryTrustee.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT229 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.TrustBeneficiaryStatement.Indicator", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT344 = ToBoolean(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Superannuation.TrusteeBeneficiaryTaxPreferred.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT345 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Superannuation.TrusteeBeneficiaryUntaxedPartShareOfNetIncome.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT346 = decimal.Parse(currentValue.Value);
                                }
                    
                                IEnumerable<SBRElement> sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationCollection;
                                if (sbrStatementOfDistributionToBeneficiaryTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AnnualTrusteePaymentReportInformation", out currentValue))
                                    sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationCollection = currentValue.Occurrences;
                                else
                                    sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationCollection = null;
                        
                                #region sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationCollection
                        
                                if (sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationCollection != null)
                                {
                                    statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationCollectionExists = true;
                                    statementOfDistributionToBeneficiary.StatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationCollectionCount = sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationCollection.Count();
                                    SBRElement sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformation;
                                    sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformation = sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationCollection.ElementAt(0);
                            
                                    IDictionary<string, SBRElement> sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationTupleElementMap;
                                    sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationTupleElementMap = sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformation.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                            
                                    if (sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DistributionBeneficiaryCloselyHeldTrust.Amount", out currentValue))
                                    {
                                        if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT433 = decimal.Parse(currentValue.Value);
                                    }
                            
                                    if (sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldFromCloselyHeldTrust.Amount", out currentValue))
                                    {
                                        if (!currentValue.IsNil) statementOfDistributionToBeneficiary.TRT434 = decimal.Parse(currentValue.Value);
                                    }
                                } 
                                #endregion End of Tuple sbrStatementOfDistributionToBeneficiary_AnnualTrusteePaymentReportInformationCollection
                    } 
                    #endregion End of Tuple sbrStatementOfDistributionToBeneficiaryCollection
                        } 
                    } 
        
                    IEnumerable<SBRElement> sbrIncomeNoBeneficiaryPresentlyEntitledCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeNoBeneficiaryPresentlyEntitled", out currentValue))
                        sbrIncomeNoBeneficiaryPresentlyEntitledCollection = currentValue.Occurrences;
                    else
                        sbrIncomeNoBeneficiaryPresentlyEntitledCollection = null;
            
                    #region sbrIncomeNoBeneficiaryPresentlyEntitledCollection
            
                    if (sbrIncomeNoBeneficiaryPresentlyEntitledCollection != null)
                    {
                        report.IncomeNoBeneficiaryPresentlyEntitledCollectionExists = true;
                        report.IncomeNoBeneficiaryPresentlyEntitledCollectionCount = sbrIncomeNoBeneficiaryPresentlyEntitledCollection.Count();
                        SBRElement sbrIncomeNoBeneficiaryPresentlyEntitled;
                        sbrIncomeNoBeneficiaryPresentlyEntitled = sbrIncomeNoBeneficiaryPresentlyEntitledCollection.ElementAt(0);
                
                        IDictionary<string, SBRElement> sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap;
                        sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap = sbrIncomeNoBeneficiaryPresentlyEntitled.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.AssessmentCalculation.Code", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT230 = currentValue.Value;
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.TrustEstateIncomeShare.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT443 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForAmountsWithheldFromForeignResidents.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT477 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.FrankingCredits.ReceivedFromNewZealandCompanies.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT233 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.IncomeOrLossTaxable.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil) 
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                    {                    
                                        if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}PrimaryProduction") || p.Domain.EndsWith(":PrimaryProduction"))>-1)
                                        {
                                            report.TRT234 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil) 
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                    {                    
                                        if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}PrimaryProduction") || p.Domain.EndsWith(":PrimaryProduction"))>-1)
                                        {
                                            report.TRT543 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil) 
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                    {                    
                                        if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}PrimaryProduction") || p.Domain.EndsWith(":PrimaryProduction"))>-1)
                                        {
                                            report.TRT544 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.IncomeOrLossTaxable.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil) 
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                    {                    
                                        if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}NonPrimaryProduction") || p.Domain.EndsWith(":NonPrimaryProduction"))>-1)
                                        {
                                            report.TRT235 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil) 
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                    {                    
                                        if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}NonPrimaryProduction") || p.Domain.EndsWith(":NonPrimaryProduction"))>-1)
                                        {
                                            report.TRT545 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil) 
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                    {                    
                                        if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}NonPrimaryProduction") || p.Domain.EndsWith(":NonPrimaryProduction"))>-1)
                                        {
                                            report.TRT546 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldWhereABNNotQuoted.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT236 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.DistributionFranked.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT444 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.FrankingCredits.ReceivedFromAustralianCompanies.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT237 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForAmountsWithheldWhereTFNNotQuoted.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT238 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldFromCloselyHeldTrust.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT435 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.CapitalGainsNet.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT239 = decimal.Parse(currentValue.Value);
                        }

                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil)
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 1)
                                    {
                                        if (sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p => p.Domain.EndsWith("}ReportingParty") || p.Domain.EndsWith(":ReportingParty")) > -1)
                                        {
                                            report.TRT547 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }

                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil)
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 1)
                                    {
                                        if (sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p => p.Domain.EndsWith("}ReportingParty") || p.Domain.EndsWith(":ReportingParty")) > -1)
                                        {
                                            report.TRT548 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }

                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForCapitalGainsWithheldFromForeignResidents.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT482 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.AttributedForeignIncome.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT240 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.InternationalDealings.Net.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT241 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.InternationalDealings.TaxOffset.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT242 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NationalRentalAffordabilitySchemeEntitlement.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT343 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.TaxOffsetRefundableOther.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT466 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NonRefundableOther.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil) 
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                    {                    
                                        if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}LimitedPartners") || p.Domain.EndsWith(":LimitedPartners"))>-1)
                                        {
                                            report.TRT504 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NonRefundableOther.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil) 
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 3)
                                    {                    
                                        if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}LimitedPartners") || p.Domain.EndsWith(":LimitedPartners"))>-1 && sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}YPrevious") || p.Domain.EndsWith(":YPrevious"))>-1)
                                        {
                                            report.TRT505 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NonRefundableOther.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil) 
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 2)
                                    {                    
                                        if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}Investor") || p.Domain.EndsWith(":Investor"))>-1)
                                        {
                                            report.TRT506 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }
                
                        if (sbrIncomeNoBeneficiaryPresentlyEntitledTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NonRefundableOther.Amount", out currentValue))
                        {
                            foreach (var sbrElementItem in currentValue.Occurrences)
                            {
                                if (!sbrElementItem.IsNil) 
                                {
                                    if (sbrElementItem.Context.Segment.DimensionDomains.Count == 3)
                                    {                    
                                        if(sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}Investor") || p.Domain.EndsWith(":Investor"))>-1 && sbrElementItem.Context.Segment.DimensionDomains.ToList().FindIndex(p=>p.Domain.EndsWith("}YPrevious") || p.Domain.EndsWith(":YPrevious"))>-1)
                                        {
                                            report.TRT507 = decimal.Parse(sbrElementItem.Value);
                                        }
                                    }
                                }
                            }
                        }
                    } 
                    #endregion End of Tuple sbrIncomeNoBeneficiaryPresentlyEntitledCollection
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}CapitalGainsTax.AssessmentCalculation.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT445 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}CapitalGainsTax.TrusteeAssessedCapitalGain.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT446 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.BeneficiaryUnderLegalDisabilityAlsoPresentlyEntitledToIncomeFromAnotherTrust.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT244 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Residency.TaxPurposesOrganisationStatus.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT245 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InternationalDealings.NonResidentTrustNonAustralianSourcedIncomeNoPresentEntitlement.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT246 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}RegulatoryDisclosures.GeneralInformationAboutFinancialStatements.Text", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT405 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Report.CompletionHours.Number", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT247 = decimal.Parse(currentValues[0].Value);
                    }
        
                    IEnumerable<SBRElement> sbrDeclarationCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration", out currentValue))
                        sbrDeclarationCollection = currentValue.Occurrences;
                    else
                        sbrDeclarationCollection = null;
            
                    #region sbrDeclarationCollection
            
                    if (sbrDeclarationCollection != null)
                    {
                
                        IEnumerable<SBRElement> sbrDeclarationCollection_TrueAndCorrect_RPCollection;
                        sbrDeclarationCollection_TrueAndCorrect_RPCollection = sbrDeclarationCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "Declaration.StatementType.Code" && te.Value == "TrueAndCorrect" &&
                            sbrRPContexts.Contains(te.Context)));
                        if (sbrDeclarationCollection_TrueAndCorrect_RPCollection != null && sbrDeclarationCollection_TrueAndCorrect_RPCollection.Count() > 0)
                        {
                            SBRElement sbrDeclarationCollection_TrueAndCorrect_RP;
                            sbrDeclarationCollection_TrueAndCorrect_RP = sbrDeclarationCollection_TrueAndCorrect_RPCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrDeclarationCollection_TrueAndCorrect_RPTupleElementMap;
                            sbrDeclarationCollection_TrueAndCorrect_RPTupleElementMap = sbrDeclarationCollection_TrueAndCorrect_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.DeclarationCollection_TrueAndCorrect_RPExists = true;
                            report.DeclarationCollection_TrueAndCorrect_RPCount = sbrDeclarationCollection_TrueAndCorrect_RPCollection.Count();
                            report.DeclarationCollection_TrueAndCorrect_RPOccurrenceIndex = sbrDeclarationCollection_TrueAndCorrect_RP.OccurrenceIndex + 1;
                            report.DeclarationCollection_TrueAndCorrect_RPLastOccurrenceIndex = sbrDeclarationCollection_TrueAndCorrect_RPCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrDeclarationCollection_TrueAndCorrect_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.StatementType.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT383 = currentValue.Value;
                            }
                    
                            if (sbrDeclarationCollection_TrueAndCorrect_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.StatementAccepted.Indicator", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT384 = ToBoolean(currentValue.Value);
                            }
                    
                            if (sbrDeclarationCollection_TrueAndCorrect_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.Statement.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT385 = currentValue.Value;
                            }
                    
                            if (sbrDeclarationCollection_TrueAndCorrect_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.Signature.Date", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT386 = DateTime.Parse(currentValue.Value);
                            }
                    
                            if (sbrDeclarationCollection_TrueAndCorrect_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.SignatoryIdentifier.Text", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT387 = currentValue.Value;
                            }
                
                            IEnumerable<SBRElement> sbrDeclaration_PersonUnstructuredNameCollection;
                            if (sbrDeclarationCollection_TrueAndCorrect_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName", out currentValue))
                                sbrDeclaration_PersonUnstructuredNameCollection = currentValue.Occurrences;
                            else
                                sbrDeclaration_PersonUnstructuredNameCollection = null;
                    
                            #region sbrDeclaration_PersonUnstructuredNameCollection
                    
                            if (sbrDeclaration_PersonUnstructuredNameCollection != null)
                            {
                        
                                IEnumerable<SBRElement> sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPCollection;
                                sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPCollection = sbrDeclaration_PersonUnstructuredNameCollection.Where(
                                    ce => ce.ChildElements != null && 
                                    ce.ChildElements.Any(te => te.Name == "PersonUnstructuredName.Usage.Code" && te.Value == "DeclarationSignatory" &&
                                    sbrRPContexts.Contains(te.Context)));
                                if (sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPCollection != null && sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPCollection.Count() > 0)
                                {
                                    SBRElement sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RP;
                                    sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RP = sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPCollection.ElementAt(0);
                        
                                    IDictionary<string, SBRElement> sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPTupleElementMap;
                                    sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPTupleElementMap = sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RP.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                        
                                    report.Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPExists = true;
                                    report.Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPCount = sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPCollection.Count();
                                    report.Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPOccurrenceIndex = sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RP.OccurrenceIndex + 1;
                                    report.Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPLastOccurrenceIndex = sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPCollection.Last().OccurrenceIndex + 1;
                            
                                    if (sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.Usage.Code", out currentValue))
                                    {
                                        if (!currentValue.IsNil) report.TRT388 = currentValue.Value;
                                    }
                            
                                    if (sbrDeclaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.FullName.Text", out currentValue))
                                    {
                                        if (!currentValue.IsNil) report.TRT389 = currentValue.Value;
                                    }
                                }  
                            } 
                            #endregion End of Tuple sbrDeclaration_PersonUnstructuredNameCollection
                            if (validationMode) ValidateRPDeclaration_PersonUnstructuredNameCollection(errors, sbrDeclaration_PersonUnstructuredNameCollection, sbrRPContexts, report);
                    
                        }  
                    } 
                    #endregion End of Tuple sbrDeclarationCollection
                    if (validationMode) ValidateRPDeclarationCollection(errors, sbrDeclarationCollection, sbrRPContexts, report);
            
                } 
            } 
            #endregion End of Context sbrRPContext
    
            #region sbrRPPrimContext
            IEnumerable<SBRContext> sbrRPPrimContexts = null;
            SBRContext sbrRPPrimContext = null;
    
            sbrRPPrimContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}IndustryProductionTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}PrimaryProduction")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPPrimElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPPrimContexts != null && sbrRPPrimContexts.Count() > 0)
            {
                sbrRPPrimContext = sbrRPPrimContexts.First();
        
                report.RPPrimId = sbrRPPrimContext.Id;
                report.RPPrimIdentifier = sbrRPPrimContext.EntityIdentifier;
                report.RPPrimIdentifierScheme = sbrRPPrimContext.EntityScheme;
        
                report.RPPrimCount = sbrRPPrimContexts.Count();
                report.RPPrimExists = true;
                report.RPPrimOccurrenceIndex = Array.IndexOf(contextArray, sbrRPPrimContext) + 1;
                report.RPPrimLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPPrimContexts.Last()) + 1;
        

                if (report.RPPrimIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPPrimIdentifierTFN = report.RPPrimIdentifier;
    
                report.RPPrimStartDate = ((SBRDurationPeriod)sbrRPPrimContext.Period).DurationStartAsDateObject;
                report.RPPrimEndDate = ((SBRDurationPeriod)sbrRPPrimContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPPrimElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPPrimContexts.Count(); i++)
                {
                    sbrRPPrimContext = sbrRPPrimContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPPrimContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPPrimElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPPrimElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPPrimElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT527 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT528 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPPrimContext
    
            #region sbrRPNonPrimContext
            IEnumerable<SBRContext> sbrRPNonPrimContexts = null;
            SBRContext sbrRPNonPrimContext = null;
    
            sbrRPNonPrimContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}IndustryProductionTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}NonPrimaryProduction")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPNonPrimElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPNonPrimContexts != null && sbrRPNonPrimContexts.Count() > 0)
            {
                sbrRPNonPrimContext = sbrRPNonPrimContexts.First();
        
                report.RPNonPrimId = sbrRPNonPrimContext.Id;
                report.RPNonPrimIdentifier = sbrRPNonPrimContext.EntityIdentifier;
                report.RPNonPrimIdentifierScheme = sbrRPNonPrimContext.EntityScheme;
        
                report.RPNonPrimCount = sbrRPNonPrimContexts.Count();
                report.RPNonPrimExists = true;
                report.RPNonPrimOccurrenceIndex = Array.IndexOf(contextArray, sbrRPNonPrimContext) + 1;
                report.RPNonPrimLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPNonPrimContexts.Last()) + 1;
        

                if (report.RPNonPrimIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPNonPrimIdentifierTFN = report.RPNonPrimIdentifier;
    
                report.RPNonPrimStartDate = ((SBRDurationPeriod)sbrRPNonPrimContext.Period).DurationStartAsDateObject;
                report.RPNonPrimEndDate = ((SBRDurationPeriod)sbrRPNonPrimContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPNonPrimElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPNonPrimContexts.Count(); i++)
                {
                    sbrRPNonPrimContext = sbrRPNonPrimContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPNonPrimContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPNonPrimElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPNonPrimElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPNonPrimElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT531 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT532 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPNonPrimContext
    
            #region sbrRPJAUSContext
            IEnumerable<SBRContext> sbrRPJAUSContexts = null;
            SBRContext sbrRPJAUSContext = null;
    
            sbrRPJAUSContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}InternationalJurisdictionDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Australian")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPJAUSElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPJAUSContexts != null && sbrRPJAUSContexts.Count() > 0)
            {
                sbrRPJAUSContext = sbrRPJAUSContexts.First();
        
                report.RPJAUSId = sbrRPJAUSContext.Id;
                report.RPJAUSIdentifier = sbrRPJAUSContext.EntityIdentifier;
                report.RPJAUSIdentifierScheme = sbrRPJAUSContext.EntityScheme;
        
                report.RPJAUSCount = sbrRPJAUSContexts.Count();
                report.RPJAUSExists = true;
                report.RPJAUSOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJAUSContext) + 1;
                report.RPJAUSLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJAUSContexts.Last()) + 1;
        

                if (report.RPJAUSIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPJAUSIdentifierTFN = report.RPJAUSIdentifier;
    
                report.RPJAUSStartDate = ((SBRDurationPeriod)sbrRPJAUSContext.Period).DurationStartAsDateObject;
                report.RPJAUSEndDate = ((SBRDurationPeriod)sbrRPJAUSContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPJAUSElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPJAUSContexts.Count(); i++)
                {
                    sbrRPJAUSContext = sbrRPJAUSContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPJAUSContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPJAUSElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPJAUSElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPJAUSElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.ForeignResidentWithholding.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT56 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.WagesAndSalaries.PaymentsContractorAndConsultant.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT57 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}SuperannuationContribution.EmployerContributions.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT58 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Operating.CostOfSales.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT467 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Operating.BadDebts.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT468 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Operating.LeaseTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT61 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Operating.Rent.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT469 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Operating.Interest.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT470 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Royalties.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT471 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DepreciationAndAmortisation.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT65 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Operating.MotorVehicle.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT472 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Operating.RepairsAndMaintenance.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT473 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DeductibleOtherTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT68 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ReconciliationAdjustmentTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT69 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.ReconciliationAdjustmentTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT447 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.SmallBusinessEntityNet.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT478 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldWhereABNNotQuoted.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT73 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForAmountsWithheldFromForeignResidents.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT474 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Interest.EarlyPaymentCredit.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT75 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldWhereABNNotQuotedShareReceivedIndirectly.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT84 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.FrankingCredits.FrankingCreditShareReceivedIndirectly.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT85 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForAmountsWithheldFromInterestAndDividendsWhereTFNNotQuotedShareReceivedIndirectly.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT86 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditForTaxWithheldFromCloselyHeldTrustShareReceivedIndirectly.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT418 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InternationalDealings.CreditForTaxWithheldFromForeignResidentWithholdingShareReceivedIndirectly.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT87 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Operating.RentalIncomeGross.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT89 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Interest.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT90 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.CapitalWorksDeduction.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT91 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Deduction.RentalIncomeDeductionsOtherThanInterestAndCapitalWorks.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT92 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ForestryManagedInvestmentScheme.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT93 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Interest.Gross.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT94 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.TFNAmountsWithheldFromGrossInterest.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT95 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.DividendsUnfranked.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT96 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.DividendsFranked.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT97 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.FrankingCredits.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT98 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.DividendsTFNAmountsWithheld.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT99 = decimal.Parse(currentValues[0].Value);
                    }
        
                    IEnumerable<SBRElement> sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}SuperannuationLumpSumWithholdingPaymentDetails", out currentValue))
                        sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection = currentValue.Occurrences;
                    else
                        sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection = null;
            
                    #region sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection
            
                    if (sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection != null)
                    {
                        report.SuperannuationLumpSumWithholdingPaymentDetailsCollectionExists = true;
                        report.SuperannuationLumpSumWithholdingPaymentDetailsCollectionCount = sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection.Count();
                
                        IEnumerable<SBRElement> sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSCollection;
                        sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSCollection = sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "InsuranceBenefits.BeneficiaryType.Code" && te.Value == "O" &&
                            sbrRPJAUSContexts.Contains(te.Context)));
                        if (sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSCollection != null && sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSCollection.Count() > 0)
                        {
                            SBRElement sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUS;
                            sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUS = sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSTupleElementMap;
                            sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSTupleElementMap = sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUS.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.SuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSExists = true;
                            report.SuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSCount = sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSCollection.Count();
                            report.SuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSOccurrenceIndex = sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUS.OccurrenceIndex + 1;
                            report.SuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSLastOccurrenceIndex = sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}SuperannuationBenefit.DeathBenefitLumpSumPaymentTaxedElement.Amount", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT100 = decimal.Parse(currentValue.Value);
                            }
                    
                            if (sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}SuperannuationBenefit.DeathBenefitLumpSumPaymentUntaxedElement.Amount", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT101 = decimal.Parse(currentValue.Value);
                            }
                    
                            if (sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InsuranceBenefits.DeathBenefit.Indicator", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT408 = ToBoolean(currentValue.Value);
                            }
                    
                            if (sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InsuranceBenefits.BeneficiaryType.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT410 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection
                    if (validationMode) ValidateRPJAUSSuperannuationLumpSumWithholdingPaymentDetailsCollection(errors, sbrSuperannuationLumpSumWithholdingPaymentDetailsCollection, sbrRPJAUSContexts, report);
            
        
                    IEnumerable<SBRElement> sbrEmploymentTerminationPaymentDetailsCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}EmploymentTerminationPaymentDetails", out currentValue))
                        sbrEmploymentTerminationPaymentDetailsCollection = currentValue.Occurrences;
                    else
                        sbrEmploymentTerminationPaymentDetailsCollection = null;
            
                    #region sbrEmploymentTerminationPaymentDetailsCollection
            
                    if (sbrEmploymentTerminationPaymentDetailsCollection != null)
                    {
                        report.EmploymentTerminationPaymentDetailsCollectionExists = true;
                        report.EmploymentTerminationPaymentDetailsCollectionCount = sbrEmploymentTerminationPaymentDetailsCollection.Count();
                
                        IEnumerable<SBRElement> sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSCollection;
                        sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSCollection = sbrEmploymentTerminationPaymentDetailsCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "InsuranceBenefits.BeneficiaryType.Code" && te.Value == "D" &&
                            sbrRPJAUSContexts.Contains(te.Context)));
                        if (sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSCollection != null && sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSCollection.Count() > 0)
                        {
                            SBRElement sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUS;
                            sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUS = sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSTupleElementMap;
                            sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSTupleElementMap = sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUS.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.EmploymentTerminationPaymentDetailsCollection_D_RPJAUSExists = true;
                            report.EmploymentTerminationPaymentDetailsCollection_D_RPJAUSCount = sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSCollection.Count();
                            report.EmploymentTerminationPaymentDetailsCollection_D_RPJAUSOccurrenceIndex = sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUS.OccurrenceIndex + 1;
                            report.EmploymentTerminationPaymentDetailsCollection_D_RPJAUSLastOccurrenceIndex = sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}SuperannuationBenefit.DeathBenefitEmploymentTerminationPaymentTaxableComponent.Amount", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT102 = decimal.Parse(currentValue.Value);
                            }
                    
                            if (sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InsuranceBenefits.DeathBenefit.Indicator", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT409 = ToBoolean(currentValue.Value);
                            }
                    
                            if (sbrEmploymentTerminationPaymentDetailsCollection_D_RPJAUSTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InsuranceBenefits.BeneficiaryType.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT411 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrEmploymentTerminationPaymentDetailsCollection
                    if (validationMode) ValidateRPJAUSEmploymentTerminationPaymentDetailsCollection(errors, sbrEmploymentTerminationPaymentDetailsCollection, sbrRPJAUSContexts, report);
            
            
                    #region sbrEmploymentTerminationPaymentDetailsCollection
            
                    if (sbrEmploymentTerminationPaymentDetailsCollection != null)
                    {
                
                        IEnumerable<SBRElement> sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSCollection;
                        sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSCollection = sbrEmploymentTerminationPaymentDetailsCollection.Where(
                            ce => ce.ChildElements != null && 
                            ce.ChildElements.Any(te => te.Name == "InsuranceBenefits.BeneficiaryType.Code" && te.Value == "O" &&
                            sbrRPJAUSContexts.Contains(te.Context)));
                        if (sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSCollection != null && sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSCollection.Count() > 0)
                        {
                            SBRElement sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUS;
                            sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUS = sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSCollection.ElementAt(0);
                
                            IDictionary<string, SBRElement> sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSTupleElementMap;
                            sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSTupleElementMap = sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUS.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                            report.EmploymentTerminationPaymentDetailsCollection_O_RPJAUSExists = true;
                            report.EmploymentTerminationPaymentDetailsCollection_O_RPJAUSCount = sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSCollection.Count();
                            report.EmploymentTerminationPaymentDetailsCollection_O_RPJAUSOccurrenceIndex = sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUS.OccurrenceIndex + 1;
                            report.EmploymentTerminationPaymentDetailsCollection_O_RPJAUSLastOccurrenceIndex = sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSCollection.Last().OccurrenceIndex + 1;
                    
                            if (sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}SuperannuationBenefit.DeathBenefitEmploymentTerminationPaymentTaxableComponent.Amount", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT103 = decimal.Parse(currentValue.Value);
                            }
                    
                            if (sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InsuranceBenefits.DeathBenefit.Indicator", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT412 = ToBoolean(currentValue.Value);
                            }
                    
                            if (sbrEmploymentTerminationPaymentDetailsCollection_O_RPJAUSTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InsuranceBenefits.BeneficiaryType.Code", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT413 = currentValue.Value;
                            }
                        }  
                    } 
                    #endregion End of Tuple sbrEmploymentTerminationPaymentDetailsCollection
                    if (validationMode) ValidateRPJAUSEmploymentTerminationPaymentDetailsCollection1(errors, sbrEmploymentTerminationPaymentDetailsCollection, sbrRPJAUSContexts, report);
            
        
                    IEnumerable<SBRElement> sbrOtherAustralianIncomeCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OtherAustralianIncome", out currentValue))
                        sbrOtherAustralianIncomeCollection = currentValue.Occurrences;
                    else
                        sbrOtherAustralianIncomeCollection = null;
            
                    #region sbrOtherAustralianIncomeCollection
            
                    if (sbrOtherAustralianIncomeCollection != null)
                    {
                        report.OtherAustralianIncomeCollectionExists = true;
                        report.OtherAustralianIncomeCollectionCount = sbrOtherAustralianIncomeCollection.Count();
                        if (sbrOtherAustralianIncomeCollection != null && sbrOtherAustralianIncomeCollection.Count() > 0)
                        {
                            report.OtherAustralianIncomeCollection = new List<TRT2022.OtherAustralianIncome>();
                            for (int tupleIndex = 0; tupleIndex < sbrOtherAustralianIncomeCollection.Count(); tupleIndex++)
                            {
                                SBRElement sbrOtherAustralianIncome;
                                sbrOtherAustralianIncome = sbrOtherAustralianIncomeCollection.ElementAt(tupleIndex);
                
                                IDictionary<string, SBRElement> sbrOtherAustralianIncomeTupleElementMap;
                                sbrOtherAustralianIncomeTupleElementMap = sbrOtherAustralianIncome.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                                TRT2022.OtherAustralianIncome otherAustralianIncome = new TRT2022.OtherAustralianIncome();
                                report.OtherAustralianIncomeCollection.Add(otherAustralianIncome);
                                otherAustralianIncome.OccurrenceIndex = tupleIndex + 1;
                        
                                if (sbrOtherAustralianIncomeTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Other.Description", out currentValue))
                                {
                                    if (!currentValue.IsNil) otherAustralianIncome.TRT120 = currentValue.Value;
                                }
                        
                                if (sbrOtherAustralianIncomeTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Other.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) otherAustralianIncome.TRT121 = decimal.Parse(currentValue.Value);
                                }
                    } 
                    #endregion End of Tuple sbrOtherAustralianIncomeCollection
                        } 
                    } 
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExceptedTrustNet.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT122 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.AustralianGovernmentPensionsAndAllowancesTaxWithheld.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT104 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Pension.Total.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT105 = decimal.Parse(currentValues[0].Value);
                    }
        
                    IEnumerable<SBRElement> sbrIndividualNonBusinessWithholdingPaymentDetailsCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IndividualNonBusinessWithholdingPaymentDetails", out currentValue))
                        sbrIndividualNonBusinessWithholdingPaymentDetailsCollection = currentValue.Occurrences;
                    else
                        sbrIndividualNonBusinessWithholdingPaymentDetailsCollection = null;
            
                    #region sbrIndividualNonBusinessWithholdingPaymentDetailsCollection
            
                    if (sbrIndividualNonBusinessWithholdingPaymentDetailsCollection != null)
                    {
                        report.IndividualNonBusinessWithholdingPaymentDetailsCollectionExists = true;
                        report.IndividualNonBusinessWithholdingPaymentDetailsCollectionCount = sbrIndividualNonBusinessWithholdingPaymentDetailsCollection.Count();
                        if (sbrIndividualNonBusinessWithholdingPaymentDetailsCollection != null && sbrIndividualNonBusinessWithholdingPaymentDetailsCollection.Count() > 0)
                        {
                            report.IndividualNonBusinessWithholdingPaymentDetailsCollection = new List<TRT2022.IndividualNonBusinessWithholdingPaymentDetails>();
                            for (int tupleIndex = 0; tupleIndex < sbrIndividualNonBusinessWithholdingPaymentDetailsCollection.Count(); tupleIndex++)
                            {
                                SBRElement sbrIndividualNonBusinessWithholdingPaymentDetails;
                                sbrIndividualNonBusinessWithholdingPaymentDetails = sbrIndividualNonBusinessWithholdingPaymentDetailsCollection.ElementAt(tupleIndex);
                
                                IDictionary<string, SBRElement> sbrIndividualNonBusinessWithholdingPaymentDetailsTupleElementMap;
                                sbrIndividualNonBusinessWithholdingPaymentDetailsTupleElementMap = sbrIndividualNonBusinessWithholdingPaymentDetails.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                                TRT2022.IndividualNonBusinessWithholdingPaymentDetails individualNonBusinessWithholdingPaymentDetails = new TRT2022.IndividualNonBusinessWithholdingPaymentDetails();
                                report.IndividualNonBusinessWithholdingPaymentDetailsCollection.Add(individualNonBusinessWithholdingPaymentDetails);
                                individualNonBusinessWithholdingPaymentDetails.OccurrenceIndex = tupleIndex + 1;
                        
                                if (sbrIndividualNonBusinessWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Identifiers.AustralianBusinessNumber.Identifier", out currentValue))
                                {
                                    if (!currentValue.IsNil) individualNonBusinessWithholdingPaymentDetails.TRT107 = currentValue.Value;
                                }
                        
                                if (sbrIndividualNonBusinessWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.TaxWithheld.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) individualNonBusinessWithholdingPaymentDetails.TRT108 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrIndividualNonBusinessWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.IndividualNonBusinessGross.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) individualNonBusinessWithholdingPaymentDetails.TRT109 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrIndividualNonBusinessWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldUnusedAnnualOrLongServiceLeavePaymentLumpSumA.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) individualNonBusinessWithholdingPaymentDetails.TRT110 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrIndividualNonBusinessWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.UnusedAnnualLongServiceLeavePaymentLumpSumA.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) individualNonBusinessWithholdingPaymentDetails.TRT111 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrIndividualNonBusinessWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.CreditTaxWithheldUnusedAnnualOrLongServiceLeavePaymentLumpSumB.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) individualNonBusinessWithholdingPaymentDetails.TRT112 = decimal.Parse(currentValue.Value);
                                }
                        
                                if (sbrIndividualNonBusinessWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.UnusedAnnualLongServiceLeavePaymentLumpSumB.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) individualNonBusinessWithholdingPaymentDetails.TRT113 = decimal.Parse(currentValue.Value);
                                }
                    } 
                    #endregion End of Tuple sbrIndividualNonBusinessWithholdingPaymentDetailsCollection
                        } 
                    } 
        
                    IEnumerable<SBRElement> sbrSuperannuationIncomeStreamWithholdingPaymentDetailsCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}SuperannuationIncomeStreamWithholdingPaymentDetails", out currentValue))
                        sbrSuperannuationIncomeStreamWithholdingPaymentDetailsCollection = currentValue.Occurrences;
                    else
                        sbrSuperannuationIncomeStreamWithholdingPaymentDetailsCollection = null;
            
                    #region sbrSuperannuationIncomeStreamWithholdingPaymentDetailsCollection
            
                    if (sbrSuperannuationIncomeStreamWithholdingPaymentDetailsCollection != null)
                    {
                        report.SuperannuationIncomeStreamWithholdingPaymentDetailsCollectionExists = true;
                        report.SuperannuationIncomeStreamWithholdingPaymentDetailsCollectionCount = sbrSuperannuationIncomeStreamWithholdingPaymentDetailsCollection.Count();
                        SBRElement sbrSuperannuationIncomeStreamWithholdingPaymentDetails;
                        sbrSuperannuationIncomeStreamWithholdingPaymentDetails = sbrSuperannuationIncomeStreamWithholdingPaymentDetailsCollection.ElementAt(0);
                
                        IDictionary<string, SBRElement> sbrSuperannuationIncomeStreamWithholdingPaymentDetailsTupleElementMap;
                        sbrSuperannuationIncomeStreamWithholdingPaymentDetailsTupleElementMap = sbrSuperannuationIncomeStreamWithholdingPaymentDetails.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                        if (sbrSuperannuationIncomeStreamWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PayAsYouGoWithholding.TaxWithheld.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT114 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrSuperannuationIncomeStreamWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Superannuation.TaxableComponentTaxedElement.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT115 = decimal.Parse(currentValue.Value);
                        }
                
                        if (sbrSuperannuationIncomeStreamWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Superannuation.TaxableComponentUntaxedElement.Amount", out currentValue))
                        {
                            if (!currentValue.IsNil) report.TRT116 = decimal.Parse(currentValue.Value);
                        }
            
                        IEnumerable<SBRElement> sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsCollection;
                        if (sbrSuperannuationIncomeStreamWithholdingPaymentDetailsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}LumpSumInArrears", out currentValue))
                            sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsCollection = currentValue.Occurrences;
                        else
                            sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsCollection = null;
                
                        #region sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsCollection
                
                        if (sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsCollection != null)
                        {
                            report.SuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsCollectionExists = true;
                            report.SuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsCollectionCount = sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsCollection.Count();
                            SBRElement sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrears;
                            sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrears = sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsCollection.ElementAt(0);
                    
                            IDictionary<string, SBRElement> sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsTupleElementMap;
                            sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsTupleElementMap = sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrears.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                    
                            if (sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Superannuation.TaxableComponentTaxedElement.Amount", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT117 = decimal.Parse(currentValue.Value);
                            }
                    
                            if (sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Superannuation.TaxableComponentUntaxedElement.Amount", out currentValue))
                            {
                                if (!currentValue.IsNil) report.TRT118 = decimal.Parse(currentValue.Value);
                            }
                        } 
                        #endregion End of Tuple sbrSuperannuationIncomeStreamWithholdingPaymentDetails_LumpSumInArrearsCollection
                    } 
                    #endregion End of Tuple sbrSuperannuationIncomeStreamWithholdingPaymentDetailsCollection
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.BonusesAndAllowances.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT119 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.AustralianInvestmentAllowableDeduction.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT123 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Deduction.DistributionFranked.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT439 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.ForestryManagedInvestmentSchemeDeduction.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT124 = decimal.Parse(currentValues[0].Value);
                    }
        
                    IEnumerable<SBRElement> sbrOtherDeductionsCollection;
                    if (populatedReportElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OtherDeductions", out currentValue))
                        sbrOtherDeductionsCollection = currentValue.Occurrences;
                    else
                        sbrOtherDeductionsCollection = null;
            
                    #region sbrOtherDeductionsCollection
            
                    if (sbrOtherDeductionsCollection != null)
                    {
                        report.OtherDeductionsCollectionExists = true;
                        report.OtherDeductionsCollectionCount = sbrOtherDeductionsCollection.Count();
                        if (sbrOtherDeductionsCollection != null && sbrOtherDeductionsCollection.Count() > 0)
                        {
                            report.OtherDeductionsCollection = new List<TRT2022.OtherDeductions>();
                            for (int tupleIndex = 0; tupleIndex < sbrOtherDeductionsCollection.Count(); tupleIndex++)
                            {
                                SBRElement sbrOtherDeductions;
                                sbrOtherDeductions = sbrOtherDeductionsCollection.ElementAt(tupleIndex);
                
                                IDictionary<string, SBRElement> sbrOtherDeductionsTupleElementMap;
                                sbrOtherDeductionsTupleElementMap = sbrOtherDeductions.PopulatedChildElementsMap ?? new Dictionary<string, SBRElement>();
                
                                TRT2022.OtherDeductions otherDeductions = new TRT2022.OtherDeductions();
                                report.OtherDeductionsCollection.Add(otherDeductions);
                                otherDeductions.OccurrenceIndex = tupleIndex + 1;
                        
                                if (sbrOtherDeductionsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DeductibleOther.Text", out currentValue))
                                {
                                    if (!currentValue.IsNil) otherDeductions.TRT128 = currentValue.Value;
                                }
                        
                                if (sbrOtherDeductionsTupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DeductibleOther.Amount", out currentValue))
                                {
                                    if (!currentValue.IsNil) otherDeductions.TRT129 = decimal.Parse(currentValue.Value);
                                }
                    } 
                    #endregion End of Tuple sbrOtherDeductionsCollection
                        } 
                    } 
            
                    if (sbrPopulatedRPJAUSElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Net.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT130 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPJAUSContext
    
            #region sbrRPJFOREIGNContext
            IEnumerable<SBRContext> sbrRPJFOREIGNContexts = null;
            SBRContext sbrRPJFOREIGNContext = null;
    
            sbrRPJFOREIGNContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}InternationalJurisdictionDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Foreign")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPJFOREIGNElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPJFOREIGNContexts != null && sbrRPJFOREIGNContexts.Count() > 0)
            {
                sbrRPJFOREIGNContext = sbrRPJFOREIGNContexts.First();
        
                report.RPJFOREIGNId = sbrRPJFOREIGNContext.Id;
                report.RPJFOREIGNIdentifier = sbrRPJFOREIGNContext.EntityIdentifier;
                report.RPJFOREIGNIdentifierScheme = sbrRPJFOREIGNContext.EntityScheme;
        
                report.RPJFOREIGNCount = sbrRPJFOREIGNContexts.Count();
                report.RPJFOREIGNExists = true;
                report.RPJFOREIGNOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJFOREIGNContext) + 1;
                report.RPJFOREIGNLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJFOREIGNContexts.Last()) + 1;
        

                if (report.RPJFOREIGNIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPJFOREIGNIdentifierTFN = report.RPJFOREIGNIdentifier;
    
                report.RPJFOREIGNStartDate = ((SBRDurationPeriod)sbrRPJFOREIGNContext.Period).DurationStartAsDateObject;
                report.RPJFOREIGNEndDate = ((SBRDurationPeriod)sbrRPJFOREIGNContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPJFOREIGNElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPJFOREIGNContexts.Count(); i++)
                {
                    sbrRPJFOREIGNContext = sbrRPJFOREIGNContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPJFOREIGNContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPJFOREIGNElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPJFOREIGNElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPJFOREIGNElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPJFOREIGNElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.InternationalDealings.AttributedForeignIncomeForeignTrustorControlledForeignCompanyorTransferorTrust.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT138 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJFOREIGNElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Other.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT140 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJFOREIGNElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Net.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT141 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJFOREIGNElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.InternationalDealings.TaxOffset.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT142 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJFOREIGNElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.FrankingCredits.ReceivedFromNewZealandCompanies.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT143 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJFOREIGNElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Interest.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT182 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJFOREIGNElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.Royalties.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT183 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPJFOREIGNContext
    
            #region sbrRPTOFAContext
            IEnumerable<SBRContext> sbrRPTOFAContexts = null;
            SBRContext sbrRPTOFAContext = null;
    
            sbrRPTOFAContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}FinancialArrangementTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}TOFA")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPTOFAElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPTOFAContexts != null && sbrRPTOFAContexts.Count() > 0)
            {
                sbrRPTOFAContext = sbrRPTOFAContexts.First();
        
                report.RPTOFAId = sbrRPTOFAContext.Id;
                report.RPTOFAIdentifier = sbrRPTOFAContext.EntityIdentifier;
                report.RPTOFAIdentifierScheme = sbrRPTOFAContext.EntityScheme;
        
                report.RPTOFACount = sbrRPTOFAContexts.Count();
                report.RPTOFAExists = true;
                report.RPTOFAOccurrenceIndex = Array.IndexOf(contextArray, sbrRPTOFAContext) + 1;
                report.RPTOFALastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPTOFAContexts.Last()) + 1;
        

                if (report.RPTOFAIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPTOFAIdentifierTFN = report.RPTOFAIdentifier;
    
                report.RPTOFAStartDate = ((SBRDurationPeriod)sbrRPTOFAContext.Period).DurationStartAsDateObject;
                report.RPTOFAEndDate = ((SBRDurationPeriod)sbrRPTOFAContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPTOFAElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPTOFAContexts.Count(); i++)
                {
                    sbrRPTOFAContext = sbrRPTOFAContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPTOFAContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPTOFAElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPTOFAElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPTOFAElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPTOFAElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.GainsTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT356 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPTOFAElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.LossesTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT357 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPTOFAContext
    
            #region sbrRPClosingInstantContext
            IEnumerable<SBRContext> sbrRPClosingInstantContexts = null;
            SBRContext sbrRPClosingInstantContext = null;
    
            sbrRPClosingInstantContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.INSTANT &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}OpeningAndClosingBalanceDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Closing")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPClosingInstantElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPClosingInstantContexts != null && sbrRPClosingInstantContexts.Count() > 0)
            {
                sbrRPClosingInstantContext = sbrRPClosingInstantContexts.First();
        
                report.RPClosingInstantId = sbrRPClosingInstantContext.Id;
                report.RPClosingInstantIdentifier = sbrRPClosingInstantContext.EntityIdentifier;
                report.RPClosingInstantIdentifierScheme = sbrRPClosingInstantContext.EntityScheme;
        
                report.RPClosingInstantCount = sbrRPClosingInstantContexts.Count();
                report.RPClosingInstantExists = true;
                report.RPClosingInstantOccurrenceIndex = Array.IndexOf(contextArray, sbrRPClosingInstantContext) + 1;
                report.RPClosingInstantLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPClosingInstantContexts.Last()) + 1;
        

                if (report.RPClosingInstantIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPClosingInstantIdentifierTFN = report.RPClosingInstantIdentifier;
    
                report.RPClosingInstantInstantDate = ((SBRInstantPeriod)sbrRPClosingInstantContext.Period).InstantAsDateObject;
        
                sbrPopulatedRPClosingInstantElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPClosingInstantContexts.Count(); i++)
                {
                    sbrRPClosingInstantContext = sbrRPClosingInstantContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPClosingInstantContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPClosingInstantElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPClosingInstantElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPClosingInstantElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPClosingInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Capital.Losses.CarriedForward.Net.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT475 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPClosingInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.CurrentTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT156 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPClosingInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.Total.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT157 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPClosingInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Liabilities.CurrentTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT158 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPClosingInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Liabilities.Total.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT159 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPClosingInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.Inventories.Total.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT168 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPClosingInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.Inventories.ValuationMethod.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT169 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPClosingInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.TradeandReceivablesOther.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT170 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPClosingInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Liabilities.TradeAndOtherPayablesTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT171 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPClosingInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.PrivateCompanyUnpaidPresentEntitlement.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT186 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPClosingInstantContext
    
            #region sbrRPOpeningInstantContext
            IEnumerable<SBRContext> sbrRPOpeningInstantContexts = null;
            SBRContext sbrRPOpeningInstantContext = null;
    
            sbrRPOpeningInstantContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.INSTANT &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}OpeningAndClosingBalanceDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Opening")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPOpeningInstantElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPOpeningInstantContexts != null && sbrRPOpeningInstantContexts.Count() > 0)
            {
                sbrRPOpeningInstantContext = sbrRPOpeningInstantContexts.First();
        
                report.RPOpeningInstantId = sbrRPOpeningInstantContext.Id;
                report.RPOpeningInstantIdentifier = sbrRPOpeningInstantContext.EntityIdentifier;
                report.RPOpeningInstantIdentifierScheme = sbrRPOpeningInstantContext.EntityScheme;
        
                report.RPOpeningInstantCount = sbrRPOpeningInstantContexts.Count();
                report.RPOpeningInstantExists = true;
                report.RPOpeningInstantOccurrenceIndex = Array.IndexOf(contextArray, sbrRPOpeningInstantContext) + 1;
                report.RPOpeningInstantLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPOpeningInstantContexts.Last()) + 1;
        

                if (report.RPOpeningInstantIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPOpeningInstantIdentifierTFN = report.RPOpeningInstantIdentifier;
    
                report.RPOpeningInstantInstantDate = ((SBRInstantPeriod)sbrRPOpeningInstantContext.Period).InstantAsDateObject;
        
                sbrPopulatedRPOpeningInstantElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPOpeningInstantContexts.Count(); i++)
                {
                    sbrRPOpeningInstantContext = sbrRPOpeningInstantContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPOpeningInstantContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPOpeningInstantElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPOpeningInstantElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPOpeningInstantElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPOpeningInstantElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Assets.Inventories.Total.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT166 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPOpeningInstantContext
    
            #region sbrRPOpeningContext
            IEnumerable<SBRContext> sbrRPOpeningContexts = null;
            SBRContext sbrRPOpeningContext = null;
    
            sbrRPOpeningContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}OpeningAndClosingBalanceDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Opening")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPOpeningElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPOpeningContexts != null && sbrRPOpeningContexts.Count() > 0)
            {
                sbrRPOpeningContext = sbrRPOpeningContexts.First();
        
                report.RPOpeningId = sbrRPOpeningContext.Id;
                report.RPOpeningIdentifier = sbrRPOpeningContext.EntityIdentifier;
                report.RPOpeningIdentifierScheme = sbrRPOpeningContext.EntityScheme;
        
                report.RPOpeningCount = sbrRPOpeningContexts.Count();
                report.RPOpeningExists = true;
                report.RPOpeningOccurrenceIndex = Array.IndexOf(contextArray, sbrRPOpeningContext) + 1;
                report.RPOpeningLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPOpeningContexts.Last()) + 1;
        

                if (report.RPOpeningIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPOpeningIdentifierTFN = report.RPOpeningIdentifier;
    
                report.RPOpeningStartDate = ((SBRDurationPeriod)sbrRPOpeningContext.Period).DurationStartAsDateObject;
                report.RPOpeningEndDate = ((SBRDurationPeriod)sbrRPOpeningContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPOpeningElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPOpeningContexts.Count(); i++)
                {
                    sbrRPOpeningContext = sbrRPOpeningContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPOpeningContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPOpeningElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPOpeningElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPOpeningElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPOpeningElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.LandcareAndWaterFacilityBroughtForward.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT147 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPOpeningContext
    
            #region sbrRPClosingContext
            IEnumerable<SBRContext> sbrRPClosingContexts = null;
            SBRContext sbrRPClosingContext = null;
    
            sbrRPClosingContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}OpeningAndClosingBalanceDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Closing")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPClosingElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPClosingContexts != null && sbrRPClosingContexts.Count() > 0)
            {
                sbrRPClosingContext = sbrRPClosingContexts.First();
        
                report.RPClosingId = sbrRPClosingContext.Id;
                report.RPClosingIdentifier = sbrRPClosingContext.EntityIdentifier;
                report.RPClosingIdentifierScheme = sbrRPClosingContext.EntityScheme;
        
                report.RPClosingCount = sbrRPClosingContexts.Count();
                report.RPClosingExists = true;
                report.RPClosingOccurrenceIndex = Array.IndexOf(contextArray, sbrRPClosingContext) + 1;
                report.RPClosingLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPClosingContexts.Last()) + 1;
        

                if (report.RPClosingIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPClosingIdentifierTFN = report.RPClosingIdentifier;
    
                report.RPClosingStartDate = ((SBRDurationPeriod)sbrRPClosingContext.Period).DurationStartAsDateObject;
                report.RPClosingEndDate = ((SBRDurationPeriod)sbrRPClosingContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPClosingElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPClosingContexts.Count(); i++)
                {
                    sbrRPClosingContext = sbrRPClosingContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPClosingContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPClosingElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPClosingElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPClosingElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPClosingElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Tax.Losses.CarriedForward.LaterIncomeYearsTotal.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT145 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPClosingContext
    
            #region sbrRPJAUSPrimContext
            IEnumerable<SBRContext> sbrRPJAUSPrimContexts = null;
            SBRContext sbrRPJAUSPrimContext = null;
    
            sbrRPJAUSPrimContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 3 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}InternationalJurisdictionDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Australian"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}IndustryProductionTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}PrimaryProduction")) )))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPJAUSPrimElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPJAUSPrimContexts != null && sbrRPJAUSPrimContexts.Count() > 0)
            {
                sbrRPJAUSPrimContext = sbrRPJAUSPrimContexts.First();
        
                report.RPJAUSPrimId = sbrRPJAUSPrimContext.Id;
                report.RPJAUSPrimIdentifier = sbrRPJAUSPrimContext.EntityIdentifier;
                report.RPJAUSPrimIdentifierScheme = sbrRPJAUSPrimContext.EntityScheme;
        
                report.RPJAUSPrimCount = sbrRPJAUSPrimContexts.Count();
                report.RPJAUSPrimExists = true;
                report.RPJAUSPrimOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJAUSPrimContext) + 1;
                report.RPJAUSPrimLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJAUSPrimContexts.Last()) + 1;
        

                if (report.RPJAUSPrimIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPJAUSPrimIdentifierTFN = report.RPJAUSPrimIdentifier;
    
                report.RPJAUSPrimStartDate = ((SBRDurationPeriod)sbrRPJAUSPrimContext.Period).DurationStartAsDateObject;
                report.RPJAUSPrimEndDate = ((SBRDurationPeriod)sbrRPJAUSPrimContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPJAUSPrimElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPJAUSPrimContexts.Count(); i++)
                {
                    sbrRPJAUSPrimContext = sbrRPJAUSPrimContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPJAUSPrimContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPJAUSPrimElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPJAUSPrimElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPJAUSPrimElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.ABNNotQuotedPaymentGross.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT46 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}GovernmentFunding.GovernmentIndustryPaymentsAssessable.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT50 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}GovernmentFunding.GovernmentIndustryPaymentsAssessable.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT361 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Other.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT54 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Net.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT71 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.PartnershipDistributionGross.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT76 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.TrustShareNet.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT77 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Party.TrustType.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT353 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DistributionDeductionsOther.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT79 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT523 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT524 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPJAUSPrimContext
    
            #region sbrRPJAUSNonPrimContext
            IEnumerable<SBRContext> sbrRPJAUSNonPrimContexts = null;
            SBRContext sbrRPJAUSNonPrimContext = null;
    
            sbrRPJAUSNonPrimContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 3 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}InternationalJurisdictionDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Australian"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}IndustryProductionTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}NonPrimaryProduction")) )))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPJAUSNonPrimElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPJAUSNonPrimContexts != null && sbrRPJAUSNonPrimContexts.Count() > 0)
            {
                sbrRPJAUSNonPrimContext = sbrRPJAUSNonPrimContexts.First();
        
                report.RPJAUSNonPrimId = sbrRPJAUSNonPrimContext.Id;
                report.RPJAUSNonPrimIdentifier = sbrRPJAUSNonPrimContext.EntityIdentifier;
                report.RPJAUSNonPrimIdentifierScheme = sbrRPJAUSNonPrimContext.EntityScheme;
        
                report.RPJAUSNonPrimCount = sbrRPJAUSNonPrimContexts.Count();
                report.RPJAUSNonPrimExists = true;
                report.RPJAUSNonPrimOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJAUSNonPrimContext) + 1;
                report.RPJAUSNonPrimLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJAUSNonPrimContexts.Last()) + 1;
        

                if (report.RPJAUSNonPrimIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPJAUSNonPrimIdentifierTFN = report.RPJAUSNonPrimIdentifier;
    
                report.RPJAUSNonPrimStartDate = ((SBRDurationPeriod)sbrRPJAUSNonPrimContext.Period).DurationStartAsDateObject;
                report.RPJAUSNonPrimEndDate = ((SBRDurationPeriod)sbrRPJAUSNonPrimContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPJAUSNonPrimElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPJAUSNonPrimContexts.Count(); i++)
                {
                    sbrRPJAUSNonPrimContext = sbrRPJAUSNonPrimContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPJAUSNonPrimContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPJAUSNonPrimElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPJAUSNonPrimElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPJAUSNonPrimElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.ABNNotQuotedPaymentGross.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT47 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Remuneration.PaymentToForeignResidentGross.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT49 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}GovernmentFunding.GovernmentIndustryPaymentsAssessable.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT52 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}GovernmentFunding.GovernmentIndustryPaymentsAssessable.Indicator", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT362 = ToBoolean(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Other.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT55 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.Net.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT72 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.PartnershipDistributionLessForeignIncome.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT80 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.TrustShareNetExcludeNetCapitalGainsAndForeignIncomeAndDistributionFranked.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT81 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Party.TrustType.Code", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT436 = currentValues[0].Value;
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DistributionDeductionsOther.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT83 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.TrustDistributionFranked.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT437 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}IncomeTax.Deduction.TrustDistributionFranked.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT438 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT525 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPJAUSNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT526 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPJAUSNonPrimContext
    
            #region sbrRPJFOREIGNCFCLCContext
            IEnumerable<SBRContext> sbrRPJFOREIGNCFCLCContexts = null;
            SBRContext sbrRPJFOREIGNCFCLCContext = null;
    
            sbrRPJFOREIGNCFCLCContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 3 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}CountryOfResidencyCFCClassificationDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ListedCountry"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}InternationalJurisdictionDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Foreign")) )))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPJFOREIGNCFCLCElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPJFOREIGNCFCLCContexts != null && sbrRPJFOREIGNCFCLCContexts.Count() > 0)
            {
                sbrRPJFOREIGNCFCLCContext = sbrRPJFOREIGNCFCLCContexts.First();
        
                report.RPJFOREIGNCFCLCId = sbrRPJFOREIGNCFCLCContext.Id;
                report.RPJFOREIGNCFCLCIdentifier = sbrRPJFOREIGNCFCLCContext.EntityIdentifier;
                report.RPJFOREIGNCFCLCIdentifierScheme = sbrRPJFOREIGNCFCLCContext.EntityScheme;
        
                report.RPJFOREIGNCFCLCCount = sbrRPJFOREIGNCFCLCContexts.Count();
                report.RPJFOREIGNCFCLCExists = true;
                report.RPJFOREIGNCFCLCOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJFOREIGNCFCLCContext) + 1;
                report.RPJFOREIGNCFCLCLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJFOREIGNCFCLCContexts.Last()) + 1;
        

                if (report.RPJFOREIGNCFCLCIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPJFOREIGNCFCLCIdentifierTFN = report.RPJFOREIGNCFCLCIdentifier;
    
                report.RPJFOREIGNCFCLCStartDate = ((SBRDurationPeriod)sbrRPJFOREIGNCFCLCContext.Period).DurationStartAsDateObject;
                report.RPJFOREIGNCFCLCEndDate = ((SBRDurationPeriod)sbrRPJFOREIGNCFCLCContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPJFOREIGNCFCLCElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPJFOREIGNCFCLCContexts.Count(); i++)
                {
                    sbrRPJFOREIGNCFCLCContext = sbrRPJFOREIGNCFCLCContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPJFOREIGNCFCLCContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPJFOREIGNCFCLCElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPJFOREIGNCFCLCElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPJFOREIGNCFCLCElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPJFOREIGNCFCLCElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.InternationalDealings.Attributed.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT134 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPJFOREIGNCFCLCContext
    
            #region sbrRPJFOREIGNCFCUCContext
            IEnumerable<SBRContext> sbrRPJFOREIGNCFCUCContexts = null;
            SBRContext sbrRPJFOREIGNCFCUCContext = null;
    
            sbrRPJFOREIGNCFCUCContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 3 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}CountryOfResidencyCFCClassificationDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}UnlistedCountry"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}InternationalJurisdictionDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Foreign")) )))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPJFOREIGNCFCUCElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPJFOREIGNCFCUCContexts != null && sbrRPJFOREIGNCFCUCContexts.Count() > 0)
            {
                sbrRPJFOREIGNCFCUCContext = sbrRPJFOREIGNCFCUCContexts.First();
        
                report.RPJFOREIGNCFCUCId = sbrRPJFOREIGNCFCUCContext.Id;
                report.RPJFOREIGNCFCUCIdentifier = sbrRPJFOREIGNCFCUCContext.EntityIdentifier;
                report.RPJFOREIGNCFCUCIdentifierScheme = sbrRPJFOREIGNCFCUCContext.EntityScheme;
        
                report.RPJFOREIGNCFCUCCount = sbrRPJFOREIGNCFCUCContexts.Count();
                report.RPJFOREIGNCFCUCExists = true;
                report.RPJFOREIGNCFCUCOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJFOREIGNCFCUCContext) + 1;
                report.RPJFOREIGNCFCUCLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPJFOREIGNCFCUCContexts.Last()) + 1;
        

                if (report.RPJFOREIGNCFCUCIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPJFOREIGNCFCUCIdentifierTFN = report.RPJFOREIGNCFCUCIdentifier;
    
                report.RPJFOREIGNCFCUCStartDate = ((SBRDurationPeriod)sbrRPJFOREIGNCFCUCContext.Period).DurationStartAsDateObject;
                report.RPJFOREIGNCFCUCEndDate = ((SBRDurationPeriod)sbrRPJFOREIGNCFCUCContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPJFOREIGNCFCUCElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPJFOREIGNCFCUCContexts.Count(); i++)
                {
                    sbrRPJFOREIGNCFCUCContext = sbrRPJFOREIGNCFCUCContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPJFOREIGNCFCUCContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPJFOREIGNCFCUCElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPJFOREIGNCFCUCElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPJFOREIGNCFCUCElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPJFOREIGNCFCUCElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.InternationalDealings.Attributed.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT136 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPJFOREIGNCFCUCContext
    
            #region sbrRPLowCostContext
            IEnumerable<SBRContext> sbrRPLowCostContexts = null;
            SBRContext sbrRPLowCostContext = null;
    
            sbrRPLowCostContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}SmallBusinessDepreciatingAssetTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}LowCost")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPLowCostElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPLowCostContexts != null && sbrRPLowCostContexts.Count() > 0)
            {
                sbrRPLowCostContext = sbrRPLowCostContexts.First();
        
                report.RPLowCostId = sbrRPLowCostContext.Id;
                report.RPLowCostIdentifier = sbrRPLowCostContext.EntityIdentifier;
                report.RPLowCostIdentifierScheme = sbrRPLowCostContext.EntityScheme;
        
                report.RPLowCostCount = sbrRPLowCostContexts.Count();
                report.RPLowCostExists = true;
                report.RPLowCostOccurrenceIndex = Array.IndexOf(contextArray, sbrRPLowCostContext) + 1;
                report.RPLowCostLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPLowCostContexts.Last()) + 1;
        

                if (report.RPLowCostIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPLowCostIdentifierTFN = report.RPLowCostIdentifier;
    
                report.RPLowCostStartDate = ((SBRDurationPeriod)sbrRPLowCostContext.Period).DurationStartAsDateObject;
                report.RPLowCostEndDate = ((SBRDurationPeriod)sbrRPLowCostContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPLowCostElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPLowCostContexts.Count(); i++)
                {
                    sbrRPLowCostContext = sbrRPLowCostContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPLowCostContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPLowCostElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPLowCostElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPLowCostElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPLowCostElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DepreciatingAssets.SmallBusinessEntity.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT189 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPLowCostContext
    
            #region sbrRPGeneralPoolContext
            IEnumerable<SBRContext> sbrRPGeneralPoolContexts = null;
            SBRContext sbrRPGeneralPoolContext = null;
    
            sbrRPGeneralPoolContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}SmallBusinessDepreciatingAssetTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}GeneralPool")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPGeneralPoolElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPGeneralPoolContexts != null && sbrRPGeneralPoolContexts.Count() > 0)
            {
                sbrRPGeneralPoolContext = sbrRPGeneralPoolContexts.First();
        
                report.RPGeneralPoolId = sbrRPGeneralPoolContext.Id;
                report.RPGeneralPoolIdentifier = sbrRPGeneralPoolContext.EntityIdentifier;
                report.RPGeneralPoolIdentifierScheme = sbrRPGeneralPoolContext.EntityScheme;
        
                report.RPGeneralPoolCount = sbrRPGeneralPoolContexts.Count();
                report.RPGeneralPoolExists = true;
                report.RPGeneralPoolOccurrenceIndex = Array.IndexOf(contextArray, sbrRPGeneralPoolContext) + 1;
                report.RPGeneralPoolLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPGeneralPoolContexts.Last()) + 1;
        

                if (report.RPGeneralPoolIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPGeneralPoolIdentifierTFN = report.RPGeneralPoolIdentifier;
    
                report.RPGeneralPoolStartDate = ((SBRDurationPeriod)sbrRPGeneralPoolContext.Period).DurationStartAsDateObject;
                report.RPGeneralPoolEndDate = ((SBRDurationPeriod)sbrRPGeneralPoolContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPGeneralPoolElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPGeneralPoolContexts.Count(); i++)
                {
                    sbrRPGeneralPoolContext = sbrRPGeneralPoolContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPGeneralPoolContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPGeneralPoolElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPGeneralPoolElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPGeneralPoolElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPGeneralPoolElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Expense.DepreciatingAssets.SmallBusinessEntity.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT190 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPGeneralPoolContext
    
            #region sbrRPInvestorContext
            IEnumerable<SBRContext> sbrRPInvestorContexts = null;
            SBRContext sbrRPInvestorContext = null;
    
            sbrRPInvestorContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}EarlyInvestorDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Investor")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPInvestorElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPInvestorContexts != null && sbrRPInvestorContexts.Count() > 0)
            {
                sbrRPInvestorContext = sbrRPInvestorContexts.First();
        
                report.RPInvestorId = sbrRPInvestorContext.Id;
                report.RPInvestorIdentifier = sbrRPInvestorContext.EntityIdentifier;
                report.RPInvestorIdentifierScheme = sbrRPInvestorContext.EntityScheme;
        
                report.RPInvestorCount = sbrRPInvestorContexts.Count();
                report.RPInvestorExists = true;
                report.RPInvestorOccurrenceIndex = Array.IndexOf(contextArray, sbrRPInvestorContext) + 1;
                report.RPInvestorLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPInvestorContexts.Last()) + 1;
        

                if (report.RPInvestorIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPInvestorIdentifierTFN = report.RPInvestorIdentifier;
    
                report.RPInvestorStartDate = ((SBRDurationPeriod)sbrRPInvestorContext.Period).DurationStartAsDateObject;
                report.RPInvestorEndDate = ((SBRDurationPeriod)sbrRPInvestorContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPInvestorElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPInvestorContexts.Count(); i++)
                {
                    sbrRPInvestorContext = sbrRPInvestorContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPInvestorContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPInvestorElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPInvestorElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPInvestorElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPInvestorElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NonRefundableOther.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT501 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPInvestorContext
    
            #region sbrRPLimitedPartnersContext
            IEnumerable<SBRContext> sbrRPLimitedPartnersContexts = null;
            SBRContext sbrRPLimitedPartnersContext = null;
    
            sbrRPLimitedPartnersContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 2 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}EarlyInvestorDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}LimitedPartners")) ))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPLimitedPartnersElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPLimitedPartnersContexts != null && sbrRPLimitedPartnersContexts.Count() > 0)
            {
                sbrRPLimitedPartnersContext = sbrRPLimitedPartnersContexts.First();
        
                report.RPLimitedPartnersId = sbrRPLimitedPartnersContext.Id;
                report.RPLimitedPartnersIdentifier = sbrRPLimitedPartnersContext.EntityIdentifier;
                report.RPLimitedPartnersIdentifierScheme = sbrRPLimitedPartnersContext.EntityScheme;
        
                report.RPLimitedPartnersCount = sbrRPLimitedPartnersContexts.Count();
                report.RPLimitedPartnersExists = true;
                report.RPLimitedPartnersOccurrenceIndex = Array.IndexOf(contextArray, sbrRPLimitedPartnersContext) + 1;
                report.RPLimitedPartnersLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPLimitedPartnersContexts.Last()) + 1;
        

                if (report.RPLimitedPartnersIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPLimitedPartnersIdentifierTFN = report.RPLimitedPartnersIdentifier;
    
                report.RPLimitedPartnersStartDate = ((SBRDurationPeriod)sbrRPLimitedPartnersContext.Period).DurationStartAsDateObject;
                report.RPLimitedPartnersEndDate = ((SBRDurationPeriod)sbrRPLimitedPartnersContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPLimitedPartnersElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPLimitedPartnersContexts.Count(); i++)
                {
                    sbrRPLimitedPartnersContext = sbrRPLimitedPartnersContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPLimitedPartnersContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPLimitedPartnersElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPLimitedPartnersElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPLimitedPartnersElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPLimitedPartnersElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}TaxOffsetClaim.NonRefundableOther.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT500 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPLimitedPartnersContext
    
            #region sbrRPInvestorYPreviousContext
            IEnumerable<SBRContext> sbrRPInvestorYPreviousContexts = null;
            SBRContext sbrRPInvestorYPreviousContext = null;
    
            sbrRPInvestorYPreviousContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 3 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}EarlyInvestorDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Investor"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}RelativePeriodDurationDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}YPrevious")) )))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPInvestorYPreviousElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPInvestorYPreviousContexts != null && sbrRPInvestorYPreviousContexts.Count() > 0)
            {
                sbrRPInvestorYPreviousContext = sbrRPInvestorYPreviousContexts.First();
        
                report.RPInvestorYPreviousId = sbrRPInvestorYPreviousContext.Id;
                report.RPInvestorYPreviousIdentifier = sbrRPInvestorYPreviousContext.EntityIdentifier;
                report.RPInvestorYPreviousIdentifierScheme = sbrRPInvestorYPreviousContext.EntityScheme;
        
                report.RPInvestorYPreviousCount = sbrRPInvestorYPreviousContexts.Count();
                report.RPInvestorYPreviousExists = true;
                report.RPInvestorYPreviousOccurrenceIndex = Array.IndexOf(contextArray, sbrRPInvestorYPreviousContext) + 1;
                report.RPInvestorYPreviousLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPInvestorYPreviousContexts.Last()) + 1;
        

                if (report.RPInvestorYPreviousIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPInvestorYPreviousIdentifierTFN = report.RPInvestorYPreviousIdentifier;
    
                report.RPInvestorYPreviousStartDate = ((SBRDurationPeriod)sbrRPInvestorYPreviousContext.Period).DurationStartAsDateObject;
                report.RPInvestorYPreviousEndDate = ((SBRDurationPeriod)sbrRPInvestorYPreviousContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPInvestorYPreviousElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPInvestorYPreviousContexts.Count(); i++)
                {
                    sbrRPInvestorYPreviousContext = sbrRPInvestorYPreviousContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPInvestorYPreviousContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPInvestorYPreviousElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPInvestorYPreviousElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPInvestorYPreviousElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
                } 
            } 
            #endregion End of Context sbrRPInvestorYPreviousContext
    
            #region sbrRPLimitedPartnersYPreviousContext
            IEnumerable<SBRContext> sbrRPLimitedPartnersYPreviousContexts = null;
            SBRContext sbrRPLimitedPartnersYPreviousContext = null;
    
            sbrRPLimitedPartnersYPreviousContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 3 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}EarlyInvestorDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}LimitedPartners"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}RelativePeriodDurationDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}YPrevious")) )))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPLimitedPartnersYPreviousElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPLimitedPartnersYPreviousContexts != null && sbrRPLimitedPartnersYPreviousContexts.Count() > 0)
            {
                sbrRPLimitedPartnersYPreviousContext = sbrRPLimitedPartnersYPreviousContexts.First();
        
                report.RPLimitedPartnersYPreviousId = sbrRPLimitedPartnersYPreviousContext.Id;
                report.RPLimitedPartnersYPreviousIdentifier = sbrRPLimitedPartnersYPreviousContext.EntityIdentifier;
                report.RPLimitedPartnersYPreviousIdentifierScheme = sbrRPLimitedPartnersYPreviousContext.EntityScheme;
        
                report.RPLimitedPartnersYPreviousCount = sbrRPLimitedPartnersYPreviousContexts.Count();
                report.RPLimitedPartnersYPreviousExists = true;
                report.RPLimitedPartnersYPreviousOccurrenceIndex = Array.IndexOf(contextArray, sbrRPLimitedPartnersYPreviousContext) + 1;
                report.RPLimitedPartnersYPreviousLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPLimitedPartnersYPreviousContexts.Last()) + 1;
        

                if (report.RPLimitedPartnersYPreviousIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPLimitedPartnersYPreviousIdentifierTFN = report.RPLimitedPartnersYPreviousIdentifier;
    
                report.RPLimitedPartnersYPreviousStartDate = ((SBRDurationPeriod)sbrRPLimitedPartnersYPreviousContext.Period).DurationStartAsDateObject;
                report.RPLimitedPartnersYPreviousEndDate = ((SBRDurationPeriod)sbrRPLimitedPartnersYPreviousContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPLimitedPartnersYPreviousElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPLimitedPartnersYPreviousContexts.Count(); i++)
                {
                    sbrRPLimitedPartnersYPreviousContext = sbrRPLimitedPartnersYPreviousContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPLimitedPartnersYPreviousContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPLimitedPartnersYPreviousElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPLimitedPartnersYPreviousElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPLimitedPartnersYPreviousElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
                } 
            } 
            #endregion End of Context sbrRPLimitedPartnersYPreviousContext
    
            #region sbrRPSharePrimContext
            IEnumerable<SBRContext> sbrRPSharePrimContexts = null;
            SBRContext sbrRPSharePrimContext = null;
    
            sbrRPSharePrimContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 3 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ShareOfAmountTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Share"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}IndustryProductionTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}PrimaryProduction")) )))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPSharePrimElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPSharePrimContexts != null && sbrRPSharePrimContexts.Count() > 0)
            {
                sbrRPSharePrimContext = sbrRPSharePrimContexts.First();
        
                report.RPSharePrimId = sbrRPSharePrimContext.Id;
                report.RPSharePrimIdentifier = sbrRPSharePrimContext.EntityIdentifier;
                report.RPSharePrimIdentifierScheme = sbrRPSharePrimContext.EntityScheme;
        
                report.RPSharePrimCount = sbrRPSharePrimContexts.Count();
                report.RPSharePrimExists = true;
                report.RPSharePrimOccurrenceIndex = Array.IndexOf(contextArray, sbrRPSharePrimContext) + 1;
                report.RPSharePrimLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPSharePrimContexts.Last()) + 1;
        

                if (report.RPSharePrimIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPSharePrimIdentifierTFN = report.RPSharePrimIdentifier;
    
                report.RPSharePrimStartDate = ((SBRDurationPeriod)sbrRPSharePrimContext.Period).DurationStartAsDateObject;
                report.RPSharePrimEndDate = ((SBRDurationPeriod)sbrRPSharePrimContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPSharePrimElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPSharePrimContexts.Count(); i++)
                {
                    sbrRPSharePrimContext = sbrRPSharePrimContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPSharePrimContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPSharePrimElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPSharePrimElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPSharePrimElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPSharePrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT529 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPSharePrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT530 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPSharePrimContext
    
            #region sbrRPShareNonPrimContext
            IEnumerable<SBRContext> sbrRPShareNonPrimContexts = null;
            SBRContext sbrRPShareNonPrimContext = null;
    
            sbrRPShareNonPrimContexts = contextArray.Where(
                c => c.Period != null && c.Period.PeriodType == SBRPeriod_PeriodType.DURATION &&
                c.Segment != null && c.Segment.ExplicitOrTypedDimensionDomains.Count == 3 && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ReportPartyTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}ReportingParty"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}ShareOfAmountTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}Share"))  && 
                (c.Segment.ExplicitOrTypedDimensionDomains.Any(dd => dd.DimensionType == SBRExplicitOrTypedDimensionDomain_Type.EXPLICIT && dd.Dimension.EndsWith("}IndustryProductionTypeDimension") && ((SBRExplicitDimensionDomain)dd).Domain.EndsWith("}NonPrimaryProduction")) )))).ToList();
            Dictionary<string, IList<SBRElement>> sbrPopulatedRPShareNonPrimElementsMap = new Dictionary<string, IList<SBRElement>>();
            if (sbrRPShareNonPrimContexts != null && sbrRPShareNonPrimContexts.Count() > 0)
            {
                sbrRPShareNonPrimContext = sbrRPShareNonPrimContexts.First();
        
                report.RPShareNonPrimId = sbrRPShareNonPrimContext.Id;
                report.RPShareNonPrimIdentifier = sbrRPShareNonPrimContext.EntityIdentifier;
                report.RPShareNonPrimIdentifierScheme = sbrRPShareNonPrimContext.EntityScheme;
        
                report.RPShareNonPrimCount = sbrRPShareNonPrimContexts.Count();
                report.RPShareNonPrimExists = true;
                report.RPShareNonPrimOccurrenceIndex = Array.IndexOf(contextArray, sbrRPShareNonPrimContext) + 1;
                report.RPShareNonPrimLastOccurrenceIndex = Array.IndexOf(contextArray, sbrRPShareNonPrimContexts.Last()) + 1;
        

                if (report.RPShareNonPrimIdentifierScheme == "http://www.ato.gov.au/tfn") report.RPShareNonPrimIdentifierTFN = report.RPShareNonPrimIdentifier;
    
                report.RPShareNonPrimStartDate = ((SBRDurationPeriod)sbrRPShareNonPrimContext.Period).DurationStartAsDateObject;
                report.RPShareNonPrimEndDate = ((SBRDurationPeriod)sbrRPShareNonPrimContext.Period).DurationEndAsDateObject;
        
                sbrPopulatedRPShareNonPrimElementsMap = new System.Collections.Generic.Dictionary<string, IList<SBRElement>>();
                for (int i = 0; i < sbrRPShareNonPrimContexts.Count(); i++)
                {
                    sbrRPShareNonPrimContext = sbrRPShareNonPrimContexts.ElementAt(i);
            
                    IList<SBRElement> elements = sbrDocument.ElementsByContextId[sbrRPShareNonPrimContext.Id];
                    if (elements != null)
                    {
                        for (int e = 0; e < elements.Count(); e++)
                        {
                            SBRElement currentElement = elements[e];
                            if (currentElement == null || currentElement.IsInTuple) continue; // Don't add tuple elements here, they will be found through a different map.
                            if (sbrPopulatedRPShareNonPrimElementsMap.ContainsKey("{" + currentElement.Namespace + "}" + currentElement.Name))
                            {
                                sbrPopulatedRPShareNonPrimElementsMap["{" + currentElement.Namespace + "}" + currentElement.Name].Add(currentElement);
                            }
                            else
                            {
                                sbrPopulatedRPShareNonPrimElementsMap.Add("{" + currentElement.Namespace + "}" + currentElement.Name, new List<SBRElement> { currentElement } );
                            }
                        }
                    }
            
                    if (sbrPopulatedRPShareNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.NonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT533 = decimal.Parse(currentValues[0].Value);
                    }
            
                    if (sbrPopulatedRPShareNonPrimElementsMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Income.ExcludedFromNonConcessionalManagedInvestmentTrust.Amount", out currentValues))
                    {
                        if (!currentValues[0].IsNil) report.TRT534 = decimal.Parse(currentValues[0].Value);
                    }
                } 
            } 
            #endregion End of Context sbrRPShareNonPrimContext
            return report;

        } // Of Consume Method
        #region ValidateINTDeclaration_PersonUnstructuredNameCollection
        protected virtual void ValidateINTDeclaration_PersonUnstructuredNameCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the INT Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTExists = true;

                    SBRElement TRT395Value = null;
                    string TRT395 = null;
                    SBRElement TRT396Value = null;
                    string TRT396 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.Usage.Code", out TRT395Value))
                    {
                        if (!TRT395Value.IsNil) TRT395 = TRT395Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.FullName.Text", out TRT396Value))
                    {
                        if (!TRT396Value.IsNil) TRT396 = TRT396Value.Value;
                    }

                    #region VR.ATO.GEN.436279

                    /*  VR.ATO.GEN.436279
                        The unstructured person name tuple must include the Usage Code 'DeclarationSignatory'.

                    Legacy Rule Format:
                        WHERE IN TUPLE (personunstructuredname1.xx.xx:PersonUnstructuredName) IN TUPLE(declaration2.xx.xx:Declaration)
                        IF pyde.xx.xx:PersonUnstructuredName.Usage.Code <> "DeclarationSignatory"
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^PersonUnstructuredName <> NULL) AND (^TRT395 <> 'DeclarationSignatory')

                    Data Elements:

                    ^TRT395 = INT:Declaration:PersonUnstructuredName:PersonUnstructuredName.Usage.Code WHERE [PersonUnstructuredName.Usage.Code='DeclarationSignatory']

                    ^PersonUnstructuredName = INT:Declaration:PersonUnstructuredName
                    */
                    assertion = (Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_INTExists != false && TRT395 != @"DeclarationSignatory");
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.436279",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Declaration name must have a usage code of 'DeclarationSignatory'",
                            Location = TRT395Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:PersonUnstructuredName.Usage.Code" : DeriveSbrElementLocation(TRT395Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.436279" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT395", Value = TRT395 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateINTDeclarationCollection
        protected virtual void ValidateINTDeclarationCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the INT Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;

                    SBRElement TRT390Value = null;
                    string TRT390 = null;
                    SBRElement TRT391Value = null;
                    bool? TRT391 = null;
                    SBRElement TRT392Value = null;
                    string TRT392 = null;
                    SBRElement TRT393Value = null;
                    DateTime? TRT393 = null;
                    SBRElement TRT394Value = null;
                    string TRT394 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.StatementType.Code", out TRT390Value))
                    {
                        if (!TRT390Value.IsNil) TRT390 = TRT390Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.StatementAccepted.Indicator", out TRT391Value))
                    {
                        if (!TRT391Value.IsNil) TRT391 = ToBoolean(TRT391Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.Statement.Text", out TRT392Value))
                    {
                        if (!TRT392Value.IsNil) TRT392 = TRT392Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.Signature.Date", out TRT393Value))
                    {
                        if (!TRT393Value.IsNil) TRT393 = DateTime.Parse(TRT393Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.SignatoryIdentifier.Text", out TRT394Value))
                    {
                        if (!TRT394Value.IsNil) TRT394 = TRT394Value.Value;
                    }

                    #region VR.ATO.GEN.438061

                    /*  VR.ATO.GEN.438061
                        If an Intermediary is present, Intermediary declaration statement type code must be supplied and must be 
                        TrueAndCorrect.

                    Legacy Rule Format:
                        IF INT<>NULL AND INT:pyin.xx.xx:Declaration.StatementType.Code <> "TrueAndCorrect"
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        ^INT <> NULL AND ^TRT390 <> 'TrueAndCorrect'

                    Data Elements:

                    ^TRT390 = INT:Declaration:Declaration.StatementType.Code WHERE [Declaration.StatementType.Code='TrueAndCorrect']

                    ^INT = INT
                    */
                    assertion = (report.INTExists != false && TRT390 != @"TrueAndCorrect");
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.438061",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Declaration statement type code is required.",
                            LongDescription = @"If an Intermediary is present, Intermediary declaration statement type code must be supplied and must be ""TrueAndCorrect"".",
                            Location = TRT390Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:Declaration.StatementType.Code" : DeriveSbrElementLocation(TRT390Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438061" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT390", Value = TRT390 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateINTPersonUnstructuredNameCollection
        protected virtual void ValidateINTPersonUnstructuredNameCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the INT Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;

                    SBRElement TRT397Value = null;
                    string TRT397 = null;
                    SBRElement TRT250Value = null;
                    string TRT250 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.Usage.Code", out TRT397Value))
                    {
                        if (!TRT397Value.IsNil) TRT397 = TRT397Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.FullName.Text", out TRT250Value))
                    {
                        if (!TRT250Value.IsNil) TRT250 = TRT250Value.Value;
                    }

                    #region VR.ATO.GEN.438080

                    /*  VR.ATO.GEN.438080
                        The unstructured person name for the Intermediary contact must include a Usage Code of 'Contact'.

                    Legacy Rule Format:
                        WHERE IN TUPLE (xbrli\personunstructuredname1.xx.xx:PersonUnstructuredName)
                        IF INT:pyde.xx.xx:PersonUnstructuredName.Usage.Code <> "Contact"
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        ^TRT397 <> 'Contact'

                    Data Elements:

                    ^TRT397 = INT:PersonUnstructuredName:PersonUnstructuredName.Usage.Code WHERE [PersonUnstructuredName.Usage.Code='Contact']
                    */
                    assertion = (TRT397 != @"Contact");
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.438080",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Intermediary contact name must have a Usage code of 'Contact'",
                            LongDescription = @"The unstructured person name for the Intermediary contact must include a Usage Code of 'Contact'. Please contact your software vendor in order to rectify this error.",
                            Location = TRT397Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:PersonUnstructuredName.Usage.Code" : DeriveSbrElementLocation(TRT397Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438080" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT397", Value = TRT397 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateINTElectronicContactTelephoneCollection
        protected virtual void ValidateINTElectronicContactTelephoneCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the INT Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool ElectronicContactTelephoneCollection_03_INTExists = true;

                    SBRElement TRT335Value = null;
                    string TRT335 = null;

                    SBRElement TRT334Value = null;
                    string TRT334 = null;
                    SBRElement TRT248Value = null;
                    string TRT248 = null;
                    SBRElement TRT249Value = null;
                    string TRT249 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Usage.Code", out TRT335Value))
                    {
                        if (!TRT335Value.IsNil) TRT335 = TRT335Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.ServiceLine.Code", out TRT334Value))
                    {
                        if (!TRT334Value.IsNil) TRT334 = TRT334Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Area.Code", out TRT248Value))
                    {
                        if (!TRT248Value.IsNil) TRT248 = TRT248Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Minimal.Number", out TRT249Value))
                    {
                        if (!TRT249Value.IsNil) TRT249 = TRT249Value.Value;
                    }

                    #region VR.ATO.GEN.500131

                    /*  VR.ATO.GEN.500131
                        Telephone must include usage code '03' and service line code '01' or '02'.

                    Legacy Rule Format:
                        WHERE IN TUPLE(electroniccontacttelephone1.xx.xx:ElectronicContactTelephone)
                        IF pyde.xx.xx:ElectronicContact.Telephone.Usage.Code <> "03" OR pyde.xx.xx:ElectronicContact.Telephone.ServiceLine.Code <> SET ("01", "02")
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^ElectronicContactTelephone <> NULL) AND (^TRT335 <> '03' OR NotInSet(^TRT334, '"01", "02"'))

                    Data Elements:

                    ^TRT335 = INT:ElectronicContactTelephone:ElectronicContact.Telephone.Usage.Code WHERE [ElectronicContact.Telephone.Usage.Code='03']

                    ^TRT334 = INT:ElectronicContactTelephone:ElectronicContact.Telephone.ServiceLine.Code WHERE [ElectronicContact.Telephone.Usage.Code='03']

                    ^ElectronicContactTelephone = INT:ElectronicContactTelephone
                    */
                    assertion = (ElectronicContactTelephoneCollection_03_INTExists != false && (TRT335 != @"03" || !(IsMatch(TRT334, @"^(01|02)$", RegexOptions.IgnoreCase))));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.500131",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Telephone must include usage code '03' and service line code '01' or '02'.",
                            Location = TRT249Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:ElectronicContact.Telephone.Minimal.Number" : DeriveSbrElementLocation(TRT249Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500131" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT335", Value = TRT335 });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT334", Value = TRT334 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPOrganisationNameDetailsCollection
        protected virtual void ValidateRPOrganisationNameDetailsCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                }
            }
        }
        #endregion

        #region ValidateRPOrganisationNameDetailsCollection1
        protected virtual void ValidateRPOrganisationNameDetailsCollection1(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool OrganisationNameDetailsCollection_MN_P_RPExists = true;

                    SBRElement TRT365Value = null;
                    string TRT365 = null;
                    SBRElement TRT366Value = null;
                    string TRT366 = null;
                    SBRElement TRT8Value = null;
                    string TRT8 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalNameType.Code", out TRT365Value))
                    {
                        if (!TRT365Value.IsNil) TRT365 = TRT365Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.Currency.Code", out TRT366Value))
                    {
                        if (!TRT366Value.IsNil) TRT366 = TRT366Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalName.Text", out TRT8Value))
                    {
                        if (!TRT8Value.IsNil) TRT8 = TRT8Value.Value;
                    }

                    #region VR.ATO.TRT.432595

                    /*  VR.ATO.TRT.432595
                        A non-individual name must have the Name Type code 'MN' (main) or 'MTR' (main trading name)

                    Legacy Rule Format:
                        WHERE IN TUPLE (organisationname2.xx.xx:OrganisationNameDetails)
                        IF (pyde.xx.xx:OrganisationNameDetails.OrganisationalNameType.Code <> SET("MN", "MTR"))
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^OrganisationNameDetails <> NULL) AND ((NotInSet(^TRT365, '"MN", "MTR"')))

                    Data Elements:

                    ^TRT365 = RP:OrganisationNameDetails:OrganisationNameDetails.OrganisationalNameType.Code WHERE [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='P']

                    ^OrganisationNameDetails = RP:OrganisationNameDetails
                    */
                    assertion = (OrganisationNameDetailsCollection_MN_P_RPExists != false && !(IsMatch(TRT365, @"^(MN|MTR)$", RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.TRT.432595",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Organisation Name Type code must be 'MN' or 'MTR'",
                            LongDescription = @"A non-individual name must have the Name Type code 'MN' (main) or 'MTR' (main trading name). Please contact your software vendor in order to rectify this error.",
                            Location = TRT8Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:OrganisationNameDetails.OrganisationalName.Text" : DeriveSbrElementLocation(TRT8Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432595" } },
                        };
                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPAddressDetailsCollection
        protected virtual void ValidateRPAddressDetailsCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;

                    SBRElement TRT322Value = null;
                    string TRT322 = null;
                    SBRElement TRT315Value = null;
                    bool? TRT315 = null;
                    SBRElement TRT321Value = null;
                    string TRT321 = null;
                    SBRElement TRT9Value = null;
                    string TRT9 = null;
                    SBRElement TRT306Value = null;
                    string TRT306 = null;
                    SBRElement TRT307Value = null;
                    string TRT307 = null;
                    SBRElement TRT308Value = null;
                    string TRT308 = null;
                    SBRElement TRT10Value = null;
                    string TRT10 = null;
                    SBRElement TRT12Value = null;
                    string TRT12 = null;
                    SBRElement TRT11Value = null;
                    string TRT11 = null;
                    SBRElement TRT13Value = null;
                    string TRT13 = null;
                    SBRElement TRT367Value = null;
                    string TRT367 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Currency.Code", out TRT322Value))
                    {
                        if (!TRT322Value.IsNil) TRT322 = TRT322Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.OverseasAddress.Indicator", out TRT315Value))
                    {
                        if (!TRT315Value.IsNil) TRT315 = ToBoolean(TRT315Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Usage.Code", out TRT321Value))
                    {
                        if (!TRT321Value.IsNil) TRT321 = TRT321Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line1.Text", out TRT9Value))
                    {
                        if (!TRT9Value.IsNil) TRT9 = TRT9Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line2.Text", out TRT306Value))
                    {
                        if (!TRT306Value.IsNil) TRT306 = TRT306Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line3.Text", out TRT307Value))
                    {
                        if (!TRT307Value.IsNil) TRT307 = TRT307Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line4.Text", out TRT308Value))
                    {
                        if (!TRT308Value.IsNil) TRT308 = TRT308Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.LocalityName.Text", out TRT10Value))
                    {
                        if (!TRT10Value.IsNil) TRT10 = TRT10Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Postcode.Text", out TRT12Value))
                    {
                        if (!TRT12Value.IsNil) TRT12 = TRT12Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.StateOrTerritory.Code", out TRT11Value))
                    {
                        if (!TRT11Value.IsNil) TRT11 = TRT11Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.CountryName.Text", out TRT13Value))
                    {
                        if (!TRT13Value.IsNil) TRT13 = TRT13Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Country.Code", out TRT367Value))
                    {
                        if (!TRT367Value.IsNil) TRT367 = TRT367Value.Value;
                    }

                    #region VR.ATO.TRT.432795

                    /*  VR.ATO.TRT.432795
                        Address currency code must be "C" or "P"

                    Legacy Rule Format:
                        WHERE IN TUPLE(addressdetails2.xx.xx:AddressDetails)
                        IF pyde.xx.xx:AddressDetails.Currency.Code <> SET("C","P")
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        NotInSet(^TRT322, '"C","P"')

                    Data Elements:

                    ^TRT322 = RP:AddressDetails:AddressDetails.Currency.Code WHERE [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='C']
                    */
                    assertion = !(IsMatch(TRT322, @"^(C|P)$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.428202",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Address currency code must be ""C"" or ""P""",
                            Location = TRT322Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:AddressDetails.Currency.Code" : DeriveSbrElementLocation(TRT322Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432795" } },
                        };
                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPAddressDetailsCollection1
        protected virtual void ValidateRPAddressDetailsCollection1(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool AddressDetailsCollection_POS_P_RPExists = true;

                    SBRElement TRT323Value = null;
                    string TRT323 = null;

                    SBRElement TRT324Value = null;
                    string TRT324 = null;
                    SBRElement TRT317Value = null;
                    bool? TRT317 = null;
                    SBRElement TRT14Value = null;
                    string TRT14 = null;
                    SBRElement TRT312Value = null;
                    string TRT312 = null;
                    SBRElement TRT313Value = null;
                    string TRT313 = null;
                    SBRElement TRT314Value = null;
                    string TRT314 = null;
                    SBRElement TRT15Value = null;
                    string TRT15 = null;
                    SBRElement TRT17Value = null;
                    string TRT17 = null;
                    SBRElement TRT16Value = null;
                    string TRT16 = null;
                    SBRElement TRT18Value = null;
                    string TRT18 = null;
                    SBRElement TRT368Value = null;
                    string TRT368 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Usage.Code", out TRT323Value))
                    {
                        if (!TRT323Value.IsNil) TRT323 = TRT323Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Currency.Code", out TRT324Value))
                    {
                        if (!TRT324Value.IsNil) TRT324 = TRT324Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.OverseasAddress.Indicator", out TRT317Value))
                    {
                        if (!TRT317Value.IsNil) TRT317 = ToBoolean(TRT317Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line1.Text", out TRT14Value))
                    {
                        if (!TRT14Value.IsNil) TRT14 = TRT14Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line2.Text", out TRT312Value))
                    {
                        if (!TRT312Value.IsNil) TRT312 = TRT312Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line3.Text", out TRT313Value))
                    {
                        if (!TRT313Value.IsNil) TRT313 = TRT313Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line4.Text", out TRT314Value))
                    {
                        if (!TRT314Value.IsNil) TRT314 = TRT314Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.LocalityName.Text", out TRT15Value))
                    {
                        if (!TRT15Value.IsNil) TRT15 = TRT15Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Postcode.Text", out TRT17Value))
                    {
                        if (!TRT17Value.IsNil) TRT17 = TRT17Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.StateOrTerritory.Code", out TRT16Value))
                    {
                        if (!TRT16Value.IsNil) TRT16 = TRT16Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.CountryName.Text", out TRT18Value))
                    {
                        if (!TRT18Value.IsNil) TRT18 = TRT18Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Country.Code", out TRT368Value))
                    {
                        if (!TRT368Value.IsNil) TRT368 = TRT368Value.Value;
                    }

                    #region VR.ATO.TRT.432596

                    /*  VR.ATO.TRT.432596
                        An address must have a Usage code 'POS' (postal) or 'BUS' (business).

                    Legacy Rule Format:
                        WHERE IN TUPLE(xbrli/addressdetails2.xx.xx:AddressDetails)
                        IF (pyde.xx.xx:AddressDetails.Usage.Code <> SET("POS", "BUS"))
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^AddressDetails <> NULL) AND ((NotInSet(^TRT323, '"POS", "BUS"')))

                    Data Elements:

                    ^TRT323 = RP:AddressDetails:AddressDetails.Usage.Code WHERE [AddressDetails.Usage.Code='POS'].[AddressDetails.Currency.Code='P']

                    ^AddressDetails = RP:AddressDetails
                    */
                    assertion = (AddressDetailsCollection_POS_P_RPExists != false && !(IsMatch(TRT323, @"^(POS|BUS)$", RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.TRT.432596",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Address usage code must be 'POS' or 'BUS'",
                            LongDescription = @"An address must have a Usage code 'POS' (postal) or 'BUS' (business). Please contact your software vendor in order to rectify this error.",
                            Location = TRT14Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:AddressDetails.Line1.Text" : DeriveSbrElementLocation(TRT14Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432596" } },
                        };
                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPMailRecipient_PersonNameDetailsCollection
        protected virtual void ValidateRPMailRecipient_PersonNameDetailsCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool MailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPExists = true;

                    SBRElement TRT329Value = null;
                    string TRT329 = null;

                    SBRElement TRT369Value = null;
                    string TRT369 = null;

                    SBRElement TRT331Value = null;
                    string TRT331 = null;
                    SBRElement TRT19Value = null;
                    string TRT19 = null;
                    SBRElement TRT21Value = null;
                    string TRT21 = null;
                    SBRElement TRT20Value = null;
                    string TRT20 = null;
                    SBRElement TRT22Value = null;
                    string TRT22 = null;
                    SBRElement TRT23Value = null;
                    string TRT23 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.PersonNameType.Code", out TRT329Value))
                    {
                        if (!TRT329Value.IsNil) TRT329 = TRT329Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Currency.Code", out TRT369Value))
                    {
                        if (!TRT369Value.IsNil) TRT369 = TRT369Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Usage.Code", out TRT331Value))
                    {
                        if (!TRT331Value.IsNil) TRT331 = TRT331Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Title.Text", out TRT19Value))
                    {
                        if (!TRT19Value.IsNil) TRT19 = TRT19Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.NameSuffix.Text", out TRT21Value))
                    {
                        if (!TRT21Value.IsNil) TRT21 = TRT21Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.FamilyName.Text", out TRT20Value))
                    {
                        if (!TRT20Value.IsNil) TRT20 = TRT20Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.GivenName.Text", out TRT22Value))
                    {
                        if (!TRT22Value.IsNil) TRT22 = TRT22Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.OtherGivenName.Text", out TRT23Value))
                    {
                        if (!TRT23Value.IsNil) TRT23 = TRT23Value.Value;
                    }

                    #region VR.ATO.TRT.432433

                    /*  VR.ATO.TRT.432433
                        The name of the person to whom notices should be sent must have the Name Type code 'LGL' (legal), Currency Code 'C' (current) and Usage code 'MailRecipient'. Please contact your software vendor in order to rectify this error.

                    Legacy Rule Format:
                        WHERE IN TUPLE(prsnstrcnm3.xx.xx:PersonNameDetails) IN TUPLE (trt.0009.lodge.req.xx.xx:MailRecipient)
                        IF (pyde.xx.xx:PersonNameDetails.PersonNameType.Code <> "LGL") OR (pyde.xx.xx:PersonNameDetails.Currency.Code <> "C") OR (pyde.xx.xx:PersonNameDetails.Usage.Code <> "MailRecipient")
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^PersonNameDetails <> NULL) AND ((^TRT329 <> 'LGL') OR (^TRT369 <> 'C') OR (^TRT331 <> 'MailRecipient'))

                    Data Elements:

                    ^TRT329 = RP:MailRecipient:PersonNameDetails:PersonNameDetails.PersonNameType.Code WHERE [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='MailRecipient']

                    ^TRT369 = RP:MailRecipient:PersonNameDetails:PersonNameDetails.Currency.Code WHERE [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='MailRecipient']

                    ^TRT331 = RP:MailRecipient:PersonNameDetails:PersonNameDetails.Usage.Code WHERE [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='MailRecipient']

                    ^PersonNameDetails = RP:MailRecipient:PersonNameDetails
                    */
                    assertion = (MailRecipient_PersonNameDetailsCollection_LGL_MailRecipient_RPExists != false && (TRT329 != @"LGL" || TRT369 != @"C" || TRT331 != @"MailRecipient"));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.430310",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Individual name Type code, Currency code and Usage code must be present and correct",
                            LongDescription = @"The name of the person to whom notices should be sent must have the Name Type code 'LGL' (legal), Currency Code 'C' (current) and Usage code 'MailRecipient'. Please contact your software vendor in order to rectify this error.",
                            Location = TRT20Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:PersonNameDetails.FamilyName.Text" : DeriveSbrElementLocation(TRT20Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432433" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT329", Value = TRT329 });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT369", Value = TRT369 });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT331", Value = TRT331 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPMailRecipient_OrganisationNameDetailsCollection
        protected virtual void ValidateRPMailRecipient_OrganisationNameDetailsCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool MailRecipient_OrganisationNameDetailsCollection_MN_C_RPExists = true;

                    SBRElement TRT330Value = null;
                    string TRT330 = null;

                    SBRElement TRT370Value = null;
                    string TRT370 = null;
                    SBRElement TRT24Value = null;
                    string TRT24 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalNameType.Code", out TRT330Value))
                    {
                        if (!TRT330Value.IsNil) TRT330 = TRT330Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.Currency.Code", out TRT370Value))
                    {
                        if (!TRT370Value.IsNil) TRT370 = TRT370Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalName.Text", out TRT24Value))
                    {
                        if (!TRT24Value.IsNil) TRT24 = TRT24Value.Value;
                    }

                    #region VR.ATO.TRT.432432

                    /*  VR.ATO.TRT.432432
                        Organisation Name Type code must be 'MN' and Currency Code must be 'C'

                    Legacy Rule Format:
                        WHERE IN TUPLE (organisationname2.xx.xx:OrganisationNameDetails) 
                        IN TUPLE (trt.0009.lodge.req.xx.xx:MailRecipient)
                        IF (pyde.xx.xx:OrganisationNameDetails.OrganisationalNameType.Code <> "MN") OR (pyde.xx.xx:OrganisationNameDetails.Currency.Code <> "C")
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^OrganisationNameDetails <> NULL) AND ((^TRT330 <> 'MN') OR (^TRT370 <> 'C'))

                    Data Elements:

                    ^TRT330 = RP:MailRecipient:OrganisationNameDetails:OrganisationNameDetails.OrganisationalNameType.Code WHERE [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']

                    ^TRT370 = RP:MailRecipient:OrganisationNameDetails:OrganisationNameDetails.Currency.Code WHERE [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']

                    ^OrganisationNameDetails = RP:MailRecipient:OrganisationNameDetails
                    */
                    assertion = (MailRecipient_OrganisationNameDetailsCollection_MN_C_RPExists != false && (TRT330 != @"MN" || TRT370 != @"C"));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.430304",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Organisation Name Type code must be 'MN' and Currency Code must be 'C'",
                            LongDescription = @"The name of the non-individual partner to whom notices should be sent must have the Name Type code 'MN' (main) and Currency Code 'C' (current). Please contact your software vendor in order to rectify this error.",
                            Location = TRT24Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:OrganisationNameDetails.OrganisationalName.Text" : DeriveSbrElementLocation(TRT24Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432432" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT330", Value = TRT330 });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT370", Value = TRT370 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPMailRecipient_ElectronicContactTelephoneCollection
        protected virtual void ValidateRPMailRecipient_ElectronicContactTelephoneCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool MailRecipient_ElectronicContactTelephoneCollection_03_RPExists = true;

                    SBRElement TRT333Value = null;
                    string TRT333 = null;

                    SBRElement TRT371Value = null;
                    string TRT371 = null;
                    SBRElement TRT26Value = null;
                    string TRT26 = null;
                    SBRElement TRT27Value = null;
                    string TRT27 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Usage.Code", out TRT333Value))
                    {
                        if (!TRT333Value.IsNil) TRT333 = TRT333Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.ServiceLine.Code", out TRT371Value))
                    {
                        if (!TRT371Value.IsNil) TRT371 = TRT371Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Area.Code", out TRT26Value))
                    {
                        if (!TRT26Value.IsNil) TRT26 = TRT26Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}ElectronicContact.Telephone.Minimal.Number", out TRT27Value))
                    {
                        if (!TRT27Value.IsNil) TRT27 = TRT27Value.Value;
                    }

                    #region VR.ATO.GEN.500131

                    /*  VR.ATO.GEN.500131
                        Telephone must include usage code '03' and service line code '01' or '02'.

                    Legacy Rule Format:
                        WHERE IN TUPLE(electroniccontacttelephone1.xx.xx:ElectronicContactTelephone)
                        IF pyde.xx.xx:ElectronicContact.Telephone.Usage.Code <> "03" OR pyde.xx.xx:ElectronicContact.Telephone.ServiceLine.Code <> SET ("01", "02")
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^ElectronicContactTelephone <> NULL) AND (^TRT333 <> '03' OR NotInSet(^TRT371, '"01", "02"'))

                    Data Elements:

                    ^TRT333 = RP:MailRecipient:ElectronicContactTelephone:ElectronicContact.Telephone.Usage.Code WHERE [ElectronicContact.Telephone.Usage.Code='03']

                    ^TRT371 = RP:MailRecipient:ElectronicContactTelephone:ElectronicContact.Telephone.ServiceLine.Code WHERE [ElectronicContact.Telephone.Usage.Code='03']

                    ^ElectronicContactTelephone = RP:MailRecipient:ElectronicContactTelephone
                    */
                    assertion = (MailRecipient_ElectronicContactTelephoneCollection_03_RPExists != false && (TRT333 != @"03" || !(IsMatch(TRT371, @"^(01|02)$", RegexOptions.IgnoreCase))));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.500131",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Telephone must include usage code '03' and service line code '01' or '02'.",
                            Location = TRT27Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:ElectronicContact.Telephone.Minimal.Number" : DeriveSbrElementLocation(TRT27Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.500131" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT333", Value = TRT333 });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT371", Value = TRT371 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPOrganisationNameDetailsCollection2
        protected virtual void ValidateRPOrganisationNameDetailsCollection2(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                }
            }
        }
        #endregion

        #region ValidateRPAddressDetailsCollection2
        protected virtual void ValidateRPAddressDetailsCollection2(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool AddressDetailsCollection_BUS_C_RPExists = true;

                    SBRElement TRT325Value = null;
                    string TRT325 = null;

                    SBRElement TRT326Value = null;
                    string TRT326 = null;
                    SBRElement TRT316Value = null;
                    bool? TRT316 = null;
                    SBRElement TRT162Value = null;
                    string TRT162 = null;
                    SBRElement TRT309Value = null;
                    string TRT309 = null;
                    SBRElement TRT310Value = null;
                    string TRT310 = null;
                    SBRElement TRT311Value = null;
                    string TRT311 = null;
                    SBRElement TRT163Value = null;
                    string TRT163 = null;
                    SBRElement TRT165Value = null;
                    string TRT165 = null;
                    SBRElement TRT164Value = null;
                    string TRT164 = null;
                    SBRElement TRT360Value = null;
                    string TRT360 = null;
                    SBRElement TRT374Value = null;
                    string TRT374 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Usage.Code", out TRT325Value))
                    {
                        if (!TRT325Value.IsNil) TRT325 = TRT325Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Currency.Code", out TRT326Value))
                    {
                        if (!TRT326Value.IsNil) TRT326 = TRT326Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.OverseasAddress.Indicator", out TRT316Value))
                    {
                        if (!TRT316Value.IsNil) TRT316 = ToBoolean(TRT316Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line1.Text", out TRT162Value))
                    {
                        if (!TRT162Value.IsNil) TRT162 = TRT162Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line2.Text", out TRT309Value))
                    {
                        if (!TRT309Value.IsNil) TRT309 = TRT309Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line3.Text", out TRT310Value))
                    {
                        if (!TRT310Value.IsNil) TRT310 = TRT310Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line4.Text", out TRT311Value))
                    {
                        if (!TRT311Value.IsNil) TRT311 = TRT311Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.LocalityName.Text", out TRT163Value))
                    {
                        if (!TRT163Value.IsNil) TRT163 = TRT163Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Postcode.Text", out TRT165Value))
                    {
                        if (!TRT165Value.IsNil) TRT165 = TRT165Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.StateOrTerritory.Code", out TRT164Value))
                    {
                        if (!TRT164Value.IsNil) TRT164 = TRT164Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.CountryName.Text", out TRT360Value))
                    {
                        if (!TRT360Value.IsNil) TRT360 = TRT360Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Country.Code", out TRT374Value))
                    {
                        if (!TRT374Value.IsNil) TRT374 = TRT374Value.Value;
                    }

                    #region VR.ATO.GEN.430306

                    /*  VR.ATO.GEN.430306
                        The Business address of main business must have Currency Code 'C' (current).

                    Legacy Rule Format:
                        WHERE IN TUPLE(addressdetails2.xx.xx:AddressDetails)
                        IF (pyde.xx.xx:AddressDetails.Usage.Code = "BUS") AND (pyde.xx.xx:AddressDetails.Currency.Code = "P") 
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^AddressDetails <> NULL) AND ((^TRT325 = 'BUS') AND (^TRT326 = 'P'))

                    Data Elements:

                    ^TRT325 = RP:AddressDetails:AddressDetails.Usage.Code WHERE [AddressDetails.Usage.Code='BUS'].[AddressDetails.Currency.Code='C']

                    ^TRT326 = RP:AddressDetails:AddressDetails.Currency.Code WHERE [AddressDetails.Usage.Code='BUS'].[AddressDetails.Currency.Code='C']

                    ^AddressDetails = RP:AddressDetails
                    */
                    assertion = (AddressDetailsCollection_BUS_C_RPExists != false && (TRT325 == @"BUS" && TRT326 == @"P"));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.430306",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Business address Currency code must be 'C'",
                            LongDescription = @"The Business address of main business must have Currency Code 'C' (current). Please contact your software vendor in order to rectify this error.",
                            Location = TRT162Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:AddressDetails.Line1.Text" : DeriveSbrElementLocation(TRT162Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.430306" } },
                        };
                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection
        protected virtual void ValidateRPStatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool StatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPExists = true;

                    SBRElement TRT380Value = null;
                    string TRT380 = null;

                    SBRElement TRT381Value = null;
                    string TRT381 = null;
                    SBRElement TRT203Value = null;
                    string TRT203 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalNameType.Code", out TRT380Value))
                    {
                        if (!TRT380Value.IsNil) TRT380 = TRT380Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.Currency.Code", out TRT381Value))
                    {
                        if (!TRT381Value.IsNil) TRT381 = TRT381Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}OrganisationNameDetails.OrganisationalName.Text", out TRT203Value))
                    {
                        if (!TRT203Value.IsNil) TRT203 = TRT203Value.Value;
                    }

                    #region VR.ATO.TRT.432422

                    /*  VR.ATO.TRT.432422
                        Organisation Name Type code must be 'MN' and Currency Code must be 'C'

                    Legacy Rule Format:
                        WHERE IN TUPLE (organisationname2.xx.xx:OrganisationNameDetails) 
                        IN TUPLE (trt.0009.lodge.req.xx.xx:StatementOfDistributionToBeneficiary)
                        IF (pyde.xx.xx:OrganisationNameDetails.OrganisationalNameType.Code <> "MN") OR (pyde.xx.xx:OrganisationNameDetails.Currency.Code <> "C")
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^OrganisationNameDetails <> NULL) AND ((^TRT380 <> 'MN') OR (^TRT381 <> 'C'))

                    Data Elements:

                    ^TRT380 = RP:StatementOfDistributionToBeneficiary:OrganisationNameDetails:OrganisationNameDetails.OrganisationalNameType.Code WHERE [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']

                    ^TRT381 = RP:StatementOfDistributionToBeneficiary:OrganisationNameDetails:OrganisationNameDetails.Currency.Code WHERE [OrganisationNameDetails.OrganisationalNameType.Code='MN'].[OrganisationNameDetails.Currency.Code='C']

                    ^OrganisationNameDetails = RP:StatementOfDistributionToBeneficiary:OrganisationNameDetails
                    */
                    assertion = (StatementOfDistributionToBeneficiary_OrganisationNameDetailsCollection_MN_C_RPExists != false && (TRT380 != @"MN" || TRT381 != @"C"));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.430303",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Organisation Name Type code must be 'MN' and Currency Code must be 'C'",
                            LongDescription = @"Each non-individual name within the Statement of Distribution must have the Name Type code 'MN' (main) and Currency Code 'C' (current). Please contact your software vendor in order to rectify this error.",
                            Location = TRT203Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:OrganisationNameDetails.OrganisationalName.Text" : DeriveSbrElementLocation(TRT203Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432422" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT380", Value = TRT380 });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT381", Value = TRT381 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPStatementOfDistributionToBeneficiary_PersonNameDetailsCollection
        protected virtual void ValidateRPStatementOfDistributionToBeneficiary_PersonNameDetailsCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;

                    SBRElement TRT375Value = null;
                    string TRT375 = null;

                    SBRElement TRT377Value = null;
                    string TRT377 = null;

                    SBRElement TRT376Value = null;
                    string TRT376 = null;
                    SBRElement TRT378Value = null;
                    string TRT378 = null;
                    SBRElement TRT379Value = null;
                    string TRT379 = null;
                    SBRElement TRT200Value = null;
                    string TRT200 = null;
                    SBRElement TRT201Value = null;
                    string TRT201 = null;
                    SBRElement TRT202Value = null;
                    string TRT202 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.PersonNameType.Code", out TRT375Value))
                    {
                        if (!TRT375Value.IsNil) TRT375 = TRT375Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Currency.Code", out TRT377Value))
                    {
                        if (!TRT377Value.IsNil) TRT377 = TRT377Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Usage.Code", out TRT376Value))
                    {
                        if (!TRT376Value.IsNil) TRT376 = TRT376Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.Title.Text", out TRT378Value))
                    {
                        if (!TRT378Value.IsNil) TRT378 = TRT378Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.NameSuffix.Text", out TRT379Value))
                    {
                        if (!TRT379Value.IsNil) TRT379 = TRT379Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.FamilyName.Text", out TRT200Value))
                    {
                        if (!TRT200Value.IsNil) TRT200 = TRT200Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.GivenName.Text", out TRT201Value))
                    {
                        if (!TRT201Value.IsNil) TRT201 = TRT201Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonNameDetails.OtherGivenName.Text", out TRT202Value))
                    {
                        if (!TRT202Value.IsNil) TRT202 = TRT202Value.Value;
                    }

                    #region VR.ATO.TRT.432424

                    /*  VR.ATO.TRT.432424
                        The Individual name of each person in each Statement of Distribution must have the Name Type code 'LGL' (legal), Currency Code 'C' (current) and Usage code 'Contact'

                    Legacy Rule Format:
                        WHERE IN TUPLE(personstructuredname3.xx.xx:PersonNameDetails) IN TUPLE (trt.0009.lodge.req.xx.xx:StatementOfDistributionToBeneficiary)
                        IF (pyde.xx.xx:PersonNameDetails.PersonNameType.Code <> "LGL") OR (pyde.xx.xx:PersonNameDetails.Currency.Code <> "C") OR (pyde.xx.xx:PersonNameDetails.Usage.Code <> "Contact")
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^TRT375 <> 'LGL') OR (^TRT377 <> 'C') OR (^TRT376 <> 'Contact')

                    Data Elements:

                    ^TRT375 = RP:StatementOfDistributionToBeneficiary:PersonNameDetails:PersonNameDetails.PersonNameType.Code WHERE [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Contact']

                    ^TRT377 = RP:StatementOfDistributionToBeneficiary:PersonNameDetails:PersonNameDetails.Currency.Code WHERE [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Contact']

                    ^TRT376 = RP:StatementOfDistributionToBeneficiary:PersonNameDetails:PersonNameDetails.Usage.Code WHERE [PersonNameDetails.PersonNameType.Code='LGL'].[PersonNameDetails.Usage.Code='Contact']
                    */
                    assertion = (TRT375 != @"LGL" || TRT377 != @"C" || TRT376 != @"Contact");
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.430311",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Individual name Type code, Currency code and Usage code must be present and correct",
                            LongDescription = @"The Individual name of each person in each Statement of Distribution must have the Name Type code 'LGL' (legal), Currency Code 'C' (current) and Usage code 'Contact'. Please contact your software vendor in order to rectify this error.",
                            Location = TRT200Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:PersonNameDetails.FamilyName.Text" : DeriveSbrElementLocation(TRT200Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432424" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT375", Value = TRT375 });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT377", Value = TRT377 });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT376", Value = TRT376 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPStatementOfDistributionToBeneficiary_AddressDetailsCollection
        protected virtual void ValidateRPStatementOfDistributionToBeneficiary_AddressDetailsCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool StatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPExists = true;

                    SBRElement TRT327Value = null;
                    string TRT327 = null;

                    SBRElement TRT328Value = null;
                    string TRT328 = null;
                    SBRElement TRT320Value = null;
                    bool? TRT320 = null;
                    SBRElement TRT205Value = null;
                    string TRT205 = null;
                    SBRElement TRT206Value = null;
                    string TRT206 = null;
                    SBRElement TRT318Value = null;
                    string TRT318 = null;
                    SBRElement TRT319Value = null;
                    string TRT319 = null;
                    SBRElement TRT207Value = null;
                    string TRT207 = null;
                    SBRElement TRT209Value = null;
                    string TRT209 = null;
                    SBRElement TRT208Value = null;
                    string TRT208 = null;
                    SBRElement TRT210Value = null;
                    string TRT210 = null;
                    SBRElement TRT382Value = null;
                    string TRT382 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Usage.Code", out TRT327Value))
                    {
                        if (!TRT327Value.IsNil) TRT327 = TRT327Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Currency.Code", out TRT328Value))
                    {
                        if (!TRT328Value.IsNil) TRT328 = TRT328Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.OverseasAddress.Indicator", out TRT320Value))
                    {
                        if (!TRT320Value.IsNil) TRT320 = ToBoolean(TRT320Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line1.Text", out TRT205Value))
                    {
                        if (!TRT205Value.IsNil) TRT205 = TRT205Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line2.Text", out TRT206Value))
                    {
                        if (!TRT206Value.IsNil) TRT206 = TRT206Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line3.Text", out TRT318Value))
                    {
                        if (!TRT318Value.IsNil) TRT318 = TRT318Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Line4.Text", out TRT319Value))
                    {
                        if (!TRT319Value.IsNil) TRT319 = TRT319Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.LocalityName.Text", out TRT207Value))
                    {
                        if (!TRT207Value.IsNil) TRT207 = TRT207Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Postcode.Text", out TRT209Value))
                    {
                        if (!TRT209Value.IsNil) TRT209 = TRT209Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.StateOrTerritory.Code", out TRT208Value))
                    {
                        if (!TRT208Value.IsNil) TRT208 = TRT208Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.CountryName.Text", out TRT210Value))
                    {
                        if (!TRT210Value.IsNil) TRT210 = TRT210Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}AddressDetails.Country.Code", out TRT382Value))
                    {
                        if (!TRT382Value.IsNil) TRT382 = TRT382Value.Value;
                    }

                    #region VR.ATO.TRT.432599

                    /*  VR.ATO.TRT.432599
                        An address in the statement of distribution must have a Usage code 'RES' (Residential) or 'BUS' (business).

                    Legacy Rule Format:
                        WHERE IN TUPLE (addressdetails2.xx.xx:AddressDetails) IN TUPLE (trt.0009.lodge.req.xx.xx:StatementOfDistributionToBeneficiary) 
                        IF (pyde.xx.xx:AddressDetails.Usage.Code <> SET("RES", "BUS"))
                        RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^AddressDetails <> NULL) AND ((NotInSet(^TRT327, '"RES", "BUS"')))

                    Data Elements:

                    ^TRT327 = RP:StatementOfDistributionToBeneficiary:AddressDetails:AddressDetails.Usage.Code WHERE [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']

                    ^AddressDetails = RP:StatementOfDistributionToBeneficiary:AddressDetails
                    */
                    assertion = (StatementOfDistributionToBeneficiary_AddressDetailsCollection_RES_C_RPExists != false && !(IsMatch(TRT327, @"^(RES|BUS)$", RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.TRT.432599",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Address usage code must be 'RES' or 'BUS' .",
                            LongDescription = @"An address must have a Usage code 'RES' (residential) or 'BUS' (business) for beneficiary. Please contact your software vendor in order to rectify this error.",
                            Location = TRT327Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:AddressDetails.Usage.Code" : DeriveSbrElementLocation(TRT327Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432599" } },
                        };
                        errors.Add(processMessage);
                    }
                    #endregion

                    #region VR.ATO.TRT.432795

                    /*  VR.ATO.TRT.432795
                        Address currency code must be "C" or "P"

                    Legacy Rule Format:
                        WHERE IN TUPLE(addressdetails2.xx.xx:AddressDetails)
                        IF pyde.xx.xx:AddressDetails.Currency.Code <> SET("C","P")
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        NotInSet(^TRT328, '"C","P"')

                    Data Elements:

                    ^TRT328 = RP:StatementOfDistributionToBeneficiary:AddressDetails:AddressDetails.Currency.Code WHERE [AddressDetails.Usage.Code='RES'].[AddressDetails.Currency.Code='C']
                    */
                    assertion = !(IsMatch(TRT328, @"^(C|P)$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.428202",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Address currency code must be ""C"" or ""P""",
                            Location = TRT328Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:AddressDetails.Currency.Code" : DeriveSbrElementLocation(TRT328Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432795" } },
                        };
                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPStatementOfDistributionToBeneficiary_AddressDetailsCollection1
        protected virtual void ValidateRPStatementOfDistributionToBeneficiary_AddressDetailsCollection1(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                }
            }
        }
        #endregion

        #region ValidateRPDeclaration_PersonUnstructuredNameCollection
        protected virtual void ValidateRPDeclaration_PersonUnstructuredNameCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPExists = true;

                    SBRElement TRT388Value = null;
                    string TRT388 = null;
                    SBRElement TRT389Value = null;
                    string TRT389 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.Usage.Code", out TRT388Value))
                    {
                        if (!TRT388Value.IsNil) TRT388 = TRT388Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}PersonUnstructuredName.FullName.Text", out TRT389Value))
                    {
                        if (!TRT389Value.IsNil) TRT389 = TRT389Value.Value;
                    }

                    #region VR.ATO.GEN.436279

                    /*  VR.ATO.GEN.436279
                        The unstructured person name tuple must include the Usage Code 'DeclarationSignatory'.

                    Legacy Rule Format:
                        WHERE IN TUPLE (personunstructuredname1.xx.xx:PersonUnstructuredName) IN TUPLE(declaration2.xx.xx:Declaration)
                        IF pyde.xx.xx:PersonUnstructuredName.Usage.Code <> "DeclarationSignatory"
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^PersonUnstructuredName <> NULL) AND (^TRT388 <> 'DeclarationSignatory')

                    Data Elements:

                    ^TRT388 = RP:Declaration:PersonUnstructuredName:PersonUnstructuredName.Usage.Code WHERE [PersonUnstructuredName.Usage.Code='DeclarationSignatory']

                    ^PersonUnstructuredName = RP:Declaration:PersonUnstructuredName
                    */
                    assertion = (Declaration_PersonUnstructuredNameCollection_DeclarationSignatory_RPExists != false && TRT388 != @"DeclarationSignatory");
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.436279",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Declaration name must have a usage code of 'DeclarationSignatory'",
                            Location = TRT388Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:PersonUnstructuredName.Usage.Code" : DeriveSbrElementLocation(TRT388Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.436279" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT388", Value = TRT388 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPDeclarationCollection
        protected virtual void ValidateRPDeclarationCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RP Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;

                    SBRElement TRT383Value = null;
                    string TRT383 = null;
                    SBRElement TRT384Value = null;
                    bool? TRT384 = null;
                    SBRElement TRT385Value = null;
                    string TRT385 = null;
                    SBRElement TRT386Value = null;
                    DateTime? TRT386 = null;
                    SBRElement TRT387Value = null;
                    string TRT387 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.StatementType.Code", out TRT383Value))
                    {
                        if (!TRT383Value.IsNil) TRT383 = TRT383Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.StatementAccepted.Indicator", out TRT384Value))
                    {
                        if (!TRT384Value.IsNil) TRT384 = ToBoolean(TRT384Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.Statement.Text", out TRT385Value))
                    {
                        if (!TRT385Value.IsNil) TRT385 = TRT385Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.Signature.Date", out TRT386Value))
                    {
                        if (!TRT386Value.IsNil) TRT386 = DateTime.Parse(TRT386Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}Declaration.SignatoryIdentifier.Text", out TRT387Value))
                    {
                        if (!TRT387Value.IsNil) TRT387 = TRT387Value.Value;
                    }

                    #region VR.ATO.GEN.438062

                    /*  VR.ATO.GEN.438062
                        If an Intermediary is not present, Reporting Party Declaration Statement Type Code must be supplied and must be TrueAndCorrect.

                    Legacy Rule Format:
                        IF INT=NULL AND RP:pyin.xx.xx:Declaration.StatementType.Code <> "TrueAndCorrect"
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        ^INT = NULL AND ^TRT383 <> 'TrueAndCorrect'

                    Data Elements:

                    ^TRT383 = RP:Declaration:Declaration.StatementType.Code WHERE [Declaration.StatementType.Code='TrueAndCorrect']

                    ^INT = INT
                    */
                    assertion = (report.INTExists == false && TRT383 != @"TrueAndCorrect");
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.GEN.438062",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Declaration statement type code is required.",
                            LongDescription = @"If an Intermediary is not present, Reporting Party Declaration Statement Type Code must be supplied and must be ""TrueAndCorrect"".",
                            Location = TRT383Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:Declaration.StatementType.Code" : DeriveSbrElementLocation(TRT383Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.GEN.438062" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT383", Value = TRT383 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPJAUSSuperannuationLumpSumWithholdingPaymentDetailsCollection
        protected virtual void ValidateRPJAUSSuperannuationLumpSumWithholdingPaymentDetailsCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RPJAUS Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool SuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSExists = true;

                    SBRElement TRT100Value = null;
                    decimal? TRT100 = null;

                    SBRElement TRT101Value = null;
                    decimal? TRT101 = null;

                    SBRElement TRT408Value = null;
                    bool? TRT408 = null;

                    SBRElement TRT410Value = null;
                    string TRT410 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}SuperannuationBenefit.DeathBenefitLumpSumPaymentTaxedElement.Amount", out TRT100Value))
                    {
                        if (!TRT100Value.IsNil) TRT100 = decimal.Parse(TRT100Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}SuperannuationBenefit.DeathBenefitLumpSumPaymentUntaxedElement.Amount", out TRT101Value))
                    {
                        if (!TRT101Value.IsNil) TRT101 = decimal.Parse(TRT101Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InsuranceBenefits.DeathBenefit.Indicator", out TRT408Value))
                    {
                        if (!TRT408Value.IsNil) TRT408 = ToBoolean(TRT408Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InsuranceBenefits.BeneficiaryType.Code", out TRT410Value))
                    {
                        if (!TRT410Value.IsNil) TRT410 = TRT410Value.Value;
                    }

                    #region VR.ATO.TRT.432384

                    /*  VR.ATO.TRT.432384
                        Death benefit superannuation lump sum must be complete

                    Legacy Rule Format:
                        WHERE IN TUPLE(trt.0009.lodge.req.xx.xx:SuperannuationLumpSumWithholdingPaymentDetails)
                        IF ([TRT100] = NULL AND [TRT101] = NULL) OR ([TRT408] <> TRUE) OR ([TRT410] <> "O")
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^SuperannuationLumpSumWithholdingPaymentDetails <> NULL) AND ((^TRT100 = NULL AND ^TRT101 = NULL) OR (^TRT408 <> TRUE) OR (^TRT410 <> 'O'))

                    Data Elements:

                    ^TRT101 = RP.JAUS:SuperannuationLumpSumWithholdingPaymentDetails:SuperannuationBenefit.DeathBenefitLumpSumPaymentUntaxedElement.Amount WHERE [InsuranceBenefits.BeneficiaryType.Code='O']

                    ^TRT100 = RP.JAUS:SuperannuationLumpSumWithholdingPaymentDetails:SuperannuationBenefit.DeathBenefitLumpSumPaymentTaxedElement.Amount WHERE [InsuranceBenefits.BeneficiaryType.Code='O']

                    ^TRT408 = RP.JAUS:SuperannuationLumpSumWithholdingPaymentDetails:InsuranceBenefits.DeathBenefit.Indicator WHERE [InsuranceBenefits.BeneficiaryType.Code='O']

                    ^TRT410 = RP.JAUS:SuperannuationLumpSumWithholdingPaymentDetails:InsuranceBenefits.BeneficiaryType.Code WHERE [InsuranceBenefits.BeneficiaryType.Code='O']

                    ^SuperannuationLumpSumWithholdingPaymentDetails = RP.JAUS:SuperannuationLumpSumWithholdingPaymentDetails
                    */
                    assertion = (SuperannuationLumpSumWithholdingPaymentDetailsCollection_O_RPJAUSExists != false && (TRT100 == null && TRT101 == null || TRT408 != true || TRT410 != @"O"));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.TRT.432384",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Death benefit superannuation lump sum must be complete",
                            LongDescription = @"The 'Death benefit superannuation lump sum where the beneficiary is a non-dependant' must include a 'Taxed element' amount or 'Untaxed element' amount (or both), plus Beneficiary type code 'O', plus Death benefit indicator set to 'TRUE'",
                            Location = TRT101Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:SuperannuationBenefit.DeathBenefitLumpSumPaymentUntaxedElement.Amount" : DeriveSbrElementLocation(TRT101Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432384" } },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT100", Value = GetValueOrEmpty(TRT100) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT101", Value = GetValueOrEmpty(TRT101) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT408", Value = GetValueOrEmpty(TRT408) });

                        processMessage.Parameters.Add(new ProcessMessageParameter
                        { Name = "TRT410", Value = TRT410 });

                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPJAUSEmploymentTerminationPaymentDetailsCollection
        protected virtual void ValidateRPJAUSEmploymentTerminationPaymentDetailsCollection(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RPJAUS Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                    bool EmploymentTerminationPaymentDetailsCollection_D_RPJAUSExists = true;

                    SBRElement TRT102Value = null;
                    decimal? TRT102 = null;

                    SBRElement TRT411Value = null;
                    string TRT411 = null;

                    SBRElement TRT409Value = null;
                    bool? TRT409 = null;

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}SuperannuationBenefit.DeathBenefitEmploymentTerminationPaymentTaxableComponent.Amount", out TRT102Value))
                    {
                        if (!TRT102Value.IsNil) TRT102 = decimal.Parse(TRT102Value.Value);
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InsuranceBenefits.BeneficiaryType.Code", out TRT411Value))
                    {
                        if (!TRT411Value.IsNil) TRT411 = TRT411Value.Value;
                    }

                    if (tupleElementMap.TryGetValue("{http://www.sbr.gov.au/ato/trt}InsuranceBenefits.DeathBenefit.Indicator", out TRT409Value))
                    {
                        if (!TRT409Value.IsNil) TRT409 = ToBoolean(TRT409Value.Value);
                    }

                    #region VR.ATO.TRT.432420

                    /*  VR.ATO.TRT.432420
                        Amount, type code and indicator must be present for a death benefit ETP

                    Legacy Rule Format:
                        WHERE IN TUPLE(trt.0009.lodge.req.xx.xx:EmploymentTerminationPaymentDetails)
                        IF (emsup.xx.xx:SuperannuationBenefit.DeathBenefitEmploymentTerminationPaymentTaxableComponent.Amount
                        = NULL) OR (crigi.xx.xx:InsuranceBenefits.BeneficiaryType.Code = NULL) OR (crigi.xx.xx:InsuranceBenefits.DeathBenefit.Indicator <> TRUE)
                           RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        (^EmploymentTerminationPaymentDetails <> NULL) AND ((^TRT102= NULL) OR (^TRT411 = NULL) OR (^TRT409 <> TRUE))

                    Data Elements:

                    ^TRT102 = RP.JAUS:EmploymentTerminationPaymentDetails:SuperannuationBenefit.DeathBenefitEmploymentTerminationPaymentTaxableComponent.Amount WHERE [InsuranceBenefits.BeneficiaryType.Code='D']

                    ^TRT411 = RP.JAUS:EmploymentTerminationPaymentDetails:InsuranceBenefits.BeneficiaryType.Code WHERE [InsuranceBenefits.BeneficiaryType.Code='D']

                    ^TRT409 = RP.JAUS:EmploymentTerminationPaymentDetails:InsuranceBenefits.DeathBenefit.Indicator WHERE [InsuranceBenefits.BeneficiaryType.Code='D']

                    ^EmploymentTerminationPaymentDetails = RP.JAUS:EmploymentTerminationPaymentDetails
                    */
                    assertion = (EmploymentTerminationPaymentDetailsCollection_D_RPJAUSExists != false && (TRT102 == null || TRT411 == null || TRT409 != true));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.TRT.432420",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"Amount, type code and indicator must be present for a death benefit ETP",
                            LongDescription = @"For each Death benefit employment termination payment, an amount, a type code - indicating 'd' - dependant or 'o' -non-dependant, and a death benefit indicator set to 'yes' (true), must all be present.",
                            Location = TRT102Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:SuperannuationBenefit.DeathBenefitEmploymentTerminationPaymentTaxableComponent.Amount" : DeriveSbrElementLocation(TRT102Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432420" } },
                        };
                        errors.Add(processMessage);
                    }
                    #endregion

                    #region VR.ATO.TRT.432597

                    /*  VR.ATO.TRT.432597
                        ETP payments can only be made to beneficiary type code "D" or "O"

                    Legacy Rule Format:
                        IF COUNT TUPLE(trt.0009.lodge.req.xx.xx:EmploymentTerminationPaymentDetails WHERE TUPLE ELEMENT (crigi.xx.xx:InsuranceBenefits.BeneficiaryType.Code <> SET("D","O"))) > 0
                        RETURN VALIDATION MESSAGE
                        ENDIF

                    Technical Business Rule Format:
                        ^TRT411 <> BLANK AND NotInSet(^TRT411, '"D","O"')

                    Data Elements:

                    ^TRT411 = RP.JAUS:EmploymentTerminationPaymentDetails:InsuranceBenefits.BeneficiaryType.Code WHERE [InsuranceBenefits.BeneficiaryType.Code='D']
                    */
                    assertion = (string.IsNullOrWhiteSpace(TRT411) != true && !(IsMatch(TRT411, @"^(D|O)$", RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.TRT.432597",
                            Severity = ProcessMessageSeverity.Error,
                            Description = @"ETP payments can only be made to beneficiary type code ""D"" or ""O""",
                            Location = TRT102Value == null ? DeriveSbrElementLocation(tupleElement, true) + "/tns:SuperannuationBenefit.DeathBenefitEmploymentTerminationPaymentTaxableComponent.Amount" : DeriveSbrElementLocation(TRT102Value),
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.TRT.432597" } },
                        };
                        errors.Add(processMessage);
                    }
                    #endregion
                }
            }
        }
        #endregion

        #region ValidateRPJAUSEmploymentTerminationPaymentDetailsCollection1
        protected virtual void ValidateRPJAUSEmploymentTerminationPaymentDetailsCollection1(List<ProcessMessageDocument> errors, IEnumerable<SBRElement> tupleCollection, IEnumerable<SBRContext> contexts, TRT2022 report)
        {
            bool assertion;
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            HashSet<string> alreadyChecked = new HashSet<string>();

            if (tupleCollection != null)
            {
                foreach (SBRElement tupleElement in tupleCollection)
                {
                    //Only check this for the RPJAUS Context exit out otherwise
                    if (tupleElement.ChildElements == null || tupleElement.ChildElements.Count == 0 || contexts == null || !contexts.Contains(tupleElement.ChildElements[0].Context))
                        continue;

                    IDictionary<string, SBRElement> tupleElementMap = tupleElement.PopulatedChildElementsMap;
                }
            }
        }
        #endregion

    } // Of Class
} // Of Namespace

